@ECHO OFF
CLS
:: nastaveni barev na display - "zluta na cerne"
COLOR 0a
:: promenne i konstanty musi byt deklarovane PRED svym prvnim pouzitim

:: dulezita konstanta oznacujici mutaci SW
:: ***************************************
SET I_mut=en

:: "viceucelova" konstanta pro testy existence a typu FS oddilu, pro 
:: prejmenovavani slozek, pro informacni vypisy a pouzivana take jako
:: cast nazvu vsech pracovnich souboru a slozek
:: ****************************************************************** 
SET pismenko=t h e q u i c k f o x l z y g s p j n m w r v d

:: konstanty a soubory potrebne pro definici stream_1 a stream_2
:: prirazeni "SET stream=%stream_1% %stream_2%" nelze bezne pouzit
:: (jakkoliv se to nabizi), protoze nutna existence "escape" znaku
:: "^" pro specialni pouziti znaku ">" pri dvojitem predavani obsahu
:: promennych vysledny retezec znehodnoti - nasledujici konstrukce je
:: uz interpretovana spravne
SET stream_1=1^>^>"STD_%pismenko%.txt"
SET stream_2=2^>^>"ERR_%pismenko%.txt"
SET stream=1^>^>"STD_%pismenko%.txt" 2^>^>"ERR_%pismenko%.txt"

:: konstanty pro implicitni nespousteni "debuggingu", spousteni "casove
:: smycky" a obsluhu volani subroutine "Math_C, Math_MC a Math_DC"
SET I_cyklNY=N
SET I_zer=N
SET I_mul=N
SET I_div=N
SET wait_YN=Y
SET "I_com="

:: ***************************************************
:: nastaveni prostredi v zavislosti na verzi "cmd.exe"
:: ***************************************************
:: - chyby v procesu poznavani prostredi budou vypsany dvojjazycne a SW
::   nasilne ukonci praci
:: - test "schopnosti" processoru "cmd.exe" uzitim prikazu ICACLS, ktery
::   v nekterych verzich "cmd.exe" nepracuje (v tomto SW je pouziti
::   prikazu "ICACLS" bezpodminecne potrebne):
ICACLS %stream%
IF NOT "%ERRORLEVEL%" == "9009" GOTO OK_cmd
ECHO.
ECHO *** Unsuitable version "cmd.exe", SW "Diver_SysFol.bat" is ending job!
ECHO *** Nevhodna verze "cmd.exe", SW "Diver_SysFol.bat" konci praci!
GOTO nemo_err

:OK_cmd
:: ***********************************************************************
:: testovani existence "zpozdene expanze" podle verze processoru "cmd.exe"
:: ***********************************************************************
:: test existence "zpozdene expanze" (v tomto SW take bezpodminecne nutne)
:: neskodnym prikazem "VERIFY", s umyslne uvedenym neplatnym parametrem
:: "one_par" tak, aby se "ERRORLEVEL" nastavil/nenastavil na nenulovou
:: hodnotu: - prikaz, pokud bude aparat "zpozdene expanze" v poradku,
::            nastavi "ERRORLEVEL" na "0" - zda se tak stalo ci nikoliv,
::            proveri test
::          - pokud skonci chybou, bude neexistence "zpozdene expanze"
::            dvojjazycne vypsana a SW nasilne ukonci praci
VERIFY one_par 2>NUL
SETLOCAL EnableExtensions
IF ERRORLEVEL 1 (
ECHO.
ECHO *** "Delayed expansion" in the installation environment or in ABD
ECHO      could not be allowed, SW "Diver_SysFol.bat" is ending job!
ECHO *** "Zpozdenou expanzi" v prostredi instalace OS ani v prostredi
ECHO      ABD nelze povolit, SW "Diver_SysFol.bat" konci praci!
GOTO nemo_err
)
SETLOCAL EnableDelayedExpansion

:: *******************************************************************
:: nastaveni jazykove mutace "en/cz" podle odezvy processoru "cmd.exe"
:: *******************************************************************
SET en_pause=Press
SET cz_pause=Pokra
ECHO.
ECHO *** "Test cmd.exe => setting language | nastaveni jazyka"
ECHO ***  press any letter ... ^| stiskni libovolne pismeno ...
PAUSE>"test_%pismenko%.txt"
:: nastaveni tvaru vypisu "pause" a odpovedi v zavislosti na odezve "cmd.exe" 
FOR /F "tokens=1 usebackq" %%P IN ("test_%pismenko%.txt") DO (SET pause_w=%%P)
SET pause_w=%pause_w:~0,5%
IF "%pause_w%" == "Press" GOTO tx_Press
IF "%pause_w%" == "Pokra" GOTO tx_Pokra

:: zjisteni nezname verze - napr. nemecke, francouzske apod. - bude vypsano
:: dvojjazycne a SW nasilne ukonci praci
ECHO.
ECHO *** Unknown version cmd.exe, SW "Diver_SysFol.bat" is ending job^^!
ECHO *** Neznama verze cmd.exe, SW "Diver_SysFol.bat" konci praci^^!
GOTO nemo_err 

:nemo_err
SET I_mut=xy
SET charYA=X
:: datum a cas, cekani na reakci obsluhy a nasilne ukonceni pri nevhodnem typu
:: processoru "cmd.exe"
CALL :DA_TI s
:: odstraneni nastaveni eventualnich "cekacich smycek naslepo"
FOR %%w IN (rof rop rdf rdp tenv junc foun sort math) DO (
  CALL :flag_file_WD D %%w %I_mut% %charYA% Y
)
ECHO *** press ... ^| stiskni ... *** "Y|y" ^| "A|a"
PAUSE>NUL
:: ****************
:: nasilne ukonceni
:: ****************
EXIT

:: **********************************************************
:: * dve skupiny subroutine - pro obsluhu casu a matematiku *
:: **********************************************************

:: **************************************************************************
::   skupina subroutine pro obsluhu casu a rizeni "cekacich smycek":
:: -  "DA_TI",
:: -  "flag_file_WD" (vytvari task "loop_wait.bat", ktery obsluhuje "cekaci
::    smycky", ktery nemusi byt pouzit - chyba "nepouziti" je osetrena) a
:: - "watch" (vlastni vystup casu a data)
:: **************************************************************************

:: subroutine "DA_TI"
:: *****************
:: vystup zpracovaneho data a casu na display
:: ******************************************
:: vstupni parametry: s/u - start/ukonceni
:: vystupni parametry:
:: pozn.: vystupuje i URL webu autora SW
::
:DA_TI
:: spusteni "wait" smycky
CALL :flag_file_WD W math xy X Y
SET "stopwatch="
:: rozskok podle "s/u"
GOTO time_%1

:time_s
:: spusteni "stopek"
CALL :watch s stopwatch
GOTO fin_dati_s

:time_u
:: odecet stavu "stopek" a ukonceni "vsech cekacich smycek naslepo"
CALL :watch u stopwatch
FOR %%w IN (rof rop rdf rdp tenv junc foun sort math) DO (
  CALL :flag_file_WD D %%w %I_mut% %charYA% Y
)
GOTO fin_dati_s

:fin_dati_s
:: - odstraneni pracovnich souboru z oddilu
:: - odstraneni pracovnich souboru z domovske slozky tak, aby se nevytvorily soubory
::   "STD" a "ERR"
:: - mozne nastaveni uvodni "nuly" u data a casu tam, kde hodnota dne (hodin) < 10,
::   na prvni pozici je umisten znak " "
DEL "%I_r%NUL_%pismenko%.txt" %stream%
DEL "%O_r_del%NUL_%pismenko%.txt" %stream%
DEL "*_%pismenko%.txt" 1>NUL 2>&1
SET w_da=%DATE:~-10%
IF "%w_da:~0,1%" == " " SET w_da=0%w_da:~1%
SET w_ti=%TIME:~-11,8%
IF "%w_ti:~0,1%" == " " SET w_ti=0%w_ti:~1%
ECHO.
ECHO *************************************************************************
ECHO *** www.nemohouci.cz                     %w_da%  %w_ti%  %stopwatch%
ECHO *************************************************************************
GOTO :eof

:: interni subroutine "flag_file_WD"
:: *********************************
:: spusteni/ukonceni "wait" smycku praci se "semaforem" flag-souboru
:: *****************************************************************
:: vstupni parametry: - W/D - typ operace
::                    - cast nazvu flag_souboru - "nazev smycky"
::                    - mutace "en/cz" (specialne "xy")
::                    - potvrzovaci znak pro "pause" - "Y/A"
::                      (specialne "X")
::                    - transparentni prubeh: "Y" - spousteni
::                                                  externiho tasku
::                                            "N" - externi task
::                                                  nebude spousten
::                                                  ("cekaci smycka"
::                                                  se nespusti)
:: vystupni parametry:
:: pozn: - nazev smycky - rof, rop, rdf, rdp, tenv, junc, foun, sort
::                        a math (jde o nazev - identifikaci
::                        "flag-souboru" - semaforu)
::       - "en/cz" - mutace - ridi se podle ni velikost okna a jazyk,
::                   ve kterem je veskery text okna vypisovan (v CR
::                   volit "cz")
::       - potvrzovaci znak "Y/A" volit podle mutace processoru
::         "cmd.exe" - je-li v prostredi "command line" vypisovano
::         "Terminate batch job (Y/N)?"), volit "Y", jinak "A"
::       - vstupni parametry ""xy" a "X" se pouziji pri neznamych
::         okolnostech
::       - "W/D" - spousti/ukoncuje SW - je  povinnosti uzivatele,
::         aby spousteny SW ukoncoval (lze spoustet vice procesu,
::         "cekacich smycek", najednou)
::       - parametry je nutne zadavat vzdy vsechny, jakkoliv na 
::         "3"-ti a "4"-ty neni v pripade "W/D"="D" bran zretel
::         
:flag_file_WD
:: SW pro "wait" smycku existuje?
IF NOT EXIST loop_wait.bat GOTO fin_WF
IF %5 == N GOTO fin_WF
:: rozskok podle "W/D"
GOTO flag_file_%1

:flag_file_W
:: zalozeni prazdneho "flag-souboru" ("semaforu") pro rizeni existence casove
:: smycky a spusteni procesu
TYPE NUL > "%2_%pismenko%.txt"
START "loop_wait.bat" /NORMAL loop_wait.bat %2 %3 %4
GOTO fin_WF

:flag_file_D
:: odstraneni "flag_souboru" (shozeni "semaforu")
DEL "%2_%pismenko%.txt" 1>NUL 2>&1
GOTO fin_WF

:fin_WF
GOTO :eof

:: interni subroutine "watch"
:: **************************
:: vystup casu ve tvaru [hh:mm:ss] (nastaveni initializace a casu a urceni
:: prubezneho casu)
:: ***********************************************************************
:: vstupni parametry: "s/u" - start "stopek"/prubezny stav "stopek"
:: vystupni parametry: [hh:mm:ss]
:: pozn.: suma sekund realneho casu je prepoctena na hodiny, minuty
::        a sekundy a prevedena na tvar [hh:mm:ss], kde "casy", ktere
::        na uvodni pozici maji "0" (nebo jsou primo rovne "0") budou
::        zmenene tak, ze misto nich bude vlozena "0" a "zbytek" casoveho
::        udaje, napr. [0h:mm:0s] nebo dve "0", napr. [00:mm:00]
::
:watch
SET w_stop=0
:: prevod prubezneho casu na sumu sekund s osetrenim mozneho uvodniho znaku " "
:: pri hodnote hodin < 10 
SET w_ti=%TIME:~0,2%
IF "%TIME:~0,1%" == " " SET w_ti=%TIME:~1,1%
CALL :Math_M %w_ti% 3600 w_ti 0 0
CALL :Math_A %w_stop% %w_ti% w_stop 0 0
CALL :Math_M %TIME:~3,2% 60 w_ti 0 0
CALL :Math_A %w_stop% %w_ti% w_stop 0 0
CALL :Math_A %w_stop% %TIME:~6,2% w_stop 0 0
:: rozskok podle "s/u"
GOTO watch_%1

:watch_s
SET i_stop=%w_stop%
SET w_stop=0
GOTO fin_watch

:watch_u
:: "rozdil" = uplynuly cas v sekundach (bude preveden na "ctivejsi" tvar)
CALL :Math_S %w_stop% %i_stop% w_stop 0 0
GOTO fin_watch

:fin_watch
:: prevod sumy sekund na znakovy tvar [hh:mm:ss] s osetrenim moznych "0"
:: pro hodnoty "casu" < 10
SET "w_h="
SET "w_m="
SET "w_s="
SET w_ti=0
SET w_rest=0
: hodiny
CALL :Math_D %w_stop% 3600 w_h w_rest 0 0
:: prevod hodin na jednu "0" a hodiny nebo na dve "0", pokud hodiny <= 10
IF %w_h% EQU 0 SET w_h=00&GOTO all_m
IF %w_h% LSS 10 SET w_h=0%w_h%&GOTO all_m
GOTO all_m

:all_m
:: minuty
CALL :Math_D %w_rest% 60 w_m w_rest 0 0
:: prevod minut na jednu "0" a minuty nebo na dve "0", pokud minuty <= 10
IF %w_m% EQU 0 SET w_m=00&GOTO all_s
IF %w_m% LSS 10 SET w_m=0%w_m%&GOTO all_s
GOTO all_s

:all_s
:: sekundy
:: prevod sekund na jednu "0" a sekundy nebo na dve "0", pokud sekundy <= 10
IF %w_rest% EQU 0 SET w_s=00&GOTO fin_watch
IF %w_rest% LSS 10 SET w_s=0%w_rest%&GOTO fin_watch
SET w_s=%w_rest%
GOTO fin_watch

:fin_watch
:: sestaveni vysledku do tvaru [hh:mm:ss]
SET %2=[%w_h%:%w_m%:%w_s%]
GOTO :eof

:: **************************************************************************
::   skupina subroutine pro "matematiku":
:: - "Math_C, A, S, M, D" a "compar" (srovnavani) a "NO_zero" (odstranovani
::   nepotrebnych pocatecnich nul), ktere predstavuji aparat pro operace:
::   - srovnavani,
::   - secitani,
::   - odecitani,
::   - nasobeni a 
::   - deleni se zbytkem  s "cisly" tvorenymi retezci s neomezenym poctem
::     cifer ve "znakovem" tvaru (pocet cifer je teoreticky nekonecny),
:: - aparat prekonava omezeni jakekoli "x-bitove" aritmetiky,
:: - moduly, v zavislosti na skutecnem poctu zpracovavanych cifer, mohou
::   vypocetni system znatelne zatizit (lze je bez problemu pouzit jako
::   testovaci system)
:: **************************************************************************

:: interni subroutine "Math_C, A, S (MC, DC, MA, DA, MS, DS)"
:: **********************************************************
:: srovnani/soucet/rozdil dvou "neprazdnych" operandu, jejichz cifry jsou ve
:: "znakovem" tvaru (pocet cifer je neomezeny a muze presahovat moznosti
:: libovolne aritmetiky)
:: *************************************************************************
:: vstupni parametry: - prvni operand - neprazdny retezec "znakovych" cifer 
::                    - druhy   -"-   -               -"-
:: vystupni parametry: - "G/L/S", kde znak G: prvni operand > druhy operand,
::                                         L:      -"-      <      -"-     ,
::                                         S: operandy se rovnaji nebo
::                                            vysledek operace
::                                            secitani/odecitani
::                     - prvni operand (bez moznych zbytecnych uvodnich "0")
::                     - druhy                     -"-                      
:: pozn.: - pouze pri volani "Math_C" (srovnavani), mohou byt operandy
::          "prazdne", jinak ne - zpracovani by havarovalo (osetreni je
::          uzivatelska zalezitost)   
::        - operandy i vysledky jsou chapane jako "cisla" bez znamenek
::        - poradi operandu ma vliv na vysledek pouze u operace srovnavani
::          (u souctu je nezajimave a pri odecitani je rozdil "absolutni"
::          hodnotou a operandy jsou prohozeny, pokud je vysledek zaporny
::          (jedina indikace, ze vysledek byl zaporny)
::        - vsechny mozne zbytecne uvodni "0" budou odebrane (operandy
::          obsahujici pouze znakove "0" budou redukovany na znak "0")
::        - pokud vysledek bude mit hodnotu nula, bude tvoren znakem "0"
::        - pocet cifer operandu je neomezeny
::
:: bezne volani "Math_C, A, S"
:Math_C
SET c_a_s=com
GOTO all_YE_z

:Math_A
SET c_a_s=add
GOTO all_YE_z

:Math_S
SET c_a_s=sub
GOTO all_YE_z

:all_YE_z
SET I_ZYN=Y
GOTO all_c_a_s

:: interni volani "Math_MC, DC, MA, DA, MS, DS"
:Math_MC
:Math_DC
SET c_a_s=com
GOTO all_NO_z

:Math_MA
:Math_DA
SET c_a_s=add
GOTO all_NO_z

:Math_MS
:Math_DS
SET c_a_s=sub
GOTO all_NO_z

:all_NO_z
SET I_ZYN=N
GOTO all_c_a_s

:all_c_a_s
SET "gls="
SET "ch_ww="
:: odstraneni '"' a uklid do pracovnich bufferu, podminene provedeni/neprovedeni,
:: odstraneni moznych zbytecnych uvodnich nul z obou bufferu a nastaveni indikatoru
:: "prazdnych" bufferu, prenosu a promenne vysledku 
SET buf1=%~1
SET buf2=%~2
IF %I_ZYN% == Y CALL :NO_zero "%buf1%" buf1&CALL :NO_zero "%buf2%" buf2
SET buf1w=%buf1%
SET buf2w=%buf2%
SET em1=N
SET em2=N
SET I_tra=N
SET "res="
:: rozskok podle "com/add/sub"
GOTO op_%c_a_s%

:: ******************
:: *** srovnavani ***
:op_com
CALL :compar "%buf1%" "%buf2%" gls
SET %3=%gls%
GOTO fin_math_CAS

:: *****************
:: *** odecitani ***
:op_sub
:: pokud "operand_1" < "operand_2", budou operandy prohozeny a obnoveny buffery
CALL :compar "%buf1%" "%buf2%" gls
IF NOT %gls% == L GOTO NO_chang
SET ch_w=%buf1w%
SET buf1w=%buf2w%
SET buf2w=%ch_w%
SET buf1=%buf1w%
SET buf2=%buf2w%
GOTO NO_chang

:: ****************
:: *** secitani ***
:NO_chang
:op_add
:: spolecna cast pro secitani/odecitani
:cykl_emp
:: - pokud oba buffery jsou "prazdne", je mozne zpracovani ukoncit
:: - v opacnem pripade, pokud neexistuje "prenos" a ten ktery buffer je prazdny,
::   staci zbyle cifry z "opacneho" bufferu pridat k vysledku a zpracovani ukoncit
IF %em1% == Y IF %em2% == Y GOTO emp_buff
IF %I_tra% == Y GOTO next_a_s
IF %em1% == Y SET res=%buf2%%res%&GOTO emp_buff
IF %em2% == Y SET res=%buf1%%res%&GOTO emp_buff
GOTO next_a_s

:next_a_s
:: ===================================
IF %I_zer% == Y ECHO "%buf1%" "%buf2%"
:: vyber vzdy poslednich znaku z obou bufferu, odebrani techto znaku a pokud se
:: buffery "vyprazdni", bude nastavena indikace "prazdneho" bufferu
:: a do bufferu umistena "0"
SET ch_w1=%buf1:~-1%
SET buf1=%buf1:~0,-1%
IF "%buf1%" == "" SET em1=Y&SET buf1=0
SET ch_w2=%buf2:~-1%
SET buf2=%buf2:~0,-1%
IF "%buf2%" == "" SET em2=Y&SET buf2=0
:: rozskok podle "add/sub"
GOTO opw_%c_a_s%

:opw_add
:: vnitrni cykl vzajemneho "secitani" cifer "0" az "9"
FOR %%C IN (0  1  2  3  4  5  6  7  8  9) DO (
   IF %ch_w2% EQU %%C GOTO add_%ch_w1%%%C
)
:: tabulka souctu cifer "0" az "9" s prislusnymi prenosy:
::  - nulty-znak - "prenos N/Y", ktery se nastavi, pokud existuje "prenos" z minuleho
::                 zpracovani (ma vyssi prioritu, nez "prenos" nize) 
::  - prvni-znak - "prenos N/Y", nastaveny na zaklade souctu cifer pri zpracovani
::  - druhy-znak - soucet s "prenosem" z minuleho zpracovani
::  - treti-znak - soucet bez "prenosu"
::
:: skupiny bez prenosu
:: *******************
:add_00
SET ch_w=NN10
GOTO fin_tab_add

:add_01
:add_10
SET ch_w=NN21
GOTO fin_tab_add

:add_02
:add_11
:add_20
SET ch_w=NN32
GOTO fin_tab_add

:add_03
:add_12
:add_21
:add_30
SET ch_w=NN43
GOTO fin_tab_add

:add_04
:add_13
:add_22
:add_31
:add_40
SET ch_w=NN54
GOTO fin_tab_add

:add_05
:add_14
:add_23
:add_32
:add_41
:add_50
SET ch_w=NN65
GOTO fin_tab_add

:add_06
:add_15
:add_24
:add_33
:add_42
:add_51
:add_60
SET ch_w=NN76
GOTO fin_tab_add

:add_07
:add_16
:add_25
:add_34
:add_43
:add_52
:add_61
:add_70
SET ch_w=NN87
GOTO fin_tab_add

:add_08
:add_17
:add_26
:add_35
:add_44
:add_53
:add_62
:add_71
:add_80
SET ch_w=NN98
GOTO fin_tab_add

:: skupina s "prenosem/neprenosem"
:: *******************************
:add_09
:add_18
:add_27
:add_36
:add_45
:add_54
:add_63
:add_72
:add_81
:add_90
SET ch_w=YN09
GOTO fin_tab_add

:: skupiny s "prenosem"
:: ********************
:add_19
:add_28
:add_37
:add_46
:add_55
:add_64
:add_73
:add_82
:add_91
SET ch_w=YY10
GOTO fin_tab_add

:add_29
:add_38
:add_47
:add_56
:add_65
:add_74
:add_83
:add_92
SET ch_w=YY21
GOTO fin_tab_add

:add_39
:add_48
:add_57
:add_66
:add_75
:add_84
:add_93
SET ch_w=YY32
GOTO fin_tab_add

:add_49
:add_58
:add_67
:add_76
:add_85
:add_94
SET ch_w=YY43
GOTO fin_tab_add

:add_59
:add_68
:add_77
:add_86
:add_95
SET ch_w=YY54
GOTO fin_tab_add

:add_69
:add_78
:add_87
:add_96
SET ch_w=YY65
GOTO fin_tab_add

:add_79
:add_88
:add_97
SET ch_w=YY76
GOTO fin_tab_add

:add_89
:add_98
SET ch_w=YY87
GOTO fin_tab_add

:add_99
SET ch_w=YY98
GOTO fin_tab_add

:fin_tab_add
:: - vysledkem operace je "treti-znak" obrazu
:: - pokud z minuleho zpracovani existuje "prenos", bude vysledek operace
::   "druhy-znak" obrazu a nova indikace "prenosu" bude "nulty-znak" obrazu
:: - jestlize "prenos" z minuleho zpracovani neexistuje, bude indikace
::   "prenosu" "prvni-znak" obrazu
SET ch_ww=%ch_w:~3,1%
IF %I_tra% == Y (
  SET ch_ww=%ch_w:~2,1%&SET I_tra=%ch_w:~0,1%
) ELSE (
  SET I_tra=%ch_w:~1,1%
)
GOTO save_res

:opw_sub
:: vnitrni cykl vzajemneho "odecitani" cifer "0" az "9"
FOR %%C IN (0 1 2 3 4 5 6 7 8 9) DO (
  IF %ch_w2% EQU %%C GOTO sub_%ch_w1%%%C
)
:: tabulka rozdilu cifer "0" az "9" s prislusnymi "prenosy":
::  - nulty-znak - nastaveni "prenosu N/Y", existuje-li "prenos" z minuleho
::                 zpracovani (ma vyssi prioritu, nez "prenos" nize) 
::  - prvni-znak - "prenos N/Y", ktery se nastavi na zaklade rozdilu cifer
::                 pri zpracovani
::  - druhy-znak - rozdil s "prenosem" z minuleho zpracovani
::  - treti-znak - rozdil bez "prenosu"
::
:: skupiny s "prenosy/neprenosy"
:: *****************************
:sub_99
:sub_88
:sub_77
:sub_66
:sub_55
:sub_44
:sub_33
:sub_22
:sub_11
:sub_00
SET ch_w=YN90
GOTO fin_tab_sub

:sub_90
SET ch_w=NN89
GOTO fin_tab_sub
:sub_89
:sub_78
:sub_67
:sub_56
:sub_45
:sub_34
:sub_23
:sub_12
:sub_01
SET ch_w=YY89
GOTO fin_tab_sub

:sub_91
:sub_80
SET ch_w=NN78
GOTO fin_tab_sub
:sub_79
:sub_68
:sub_57
:sub_46
:sub_35
:sub_24
:sub_13
:sub_02
SET ch_w=YY78
GOTO fin_tab_sub

:sub_92
:sub_81
:sub_70
SET ch_w=NN67
GOTO fin_tab_sub
:sub_69
:sub_58
:sub_47
:sub_36
:sub_25
:sub_14
:sub_03
SET ch_w=YY67
GOTO fin_tab_sub

:sub_93
:sub_82
:sub_71
:sub_60
SET ch_w=NN56
GOTO fin_tab_sub
:sub_59
:sub_48
:sub_37
:sub_26
:sub_15
:sub_04
SET ch_w=YY56
GOTO fin_tab_sub

:sub_94
:sub_83
:sub_72
:sub_61
:sub_50
SET ch_w=NN45
GOTO fin_tab_sub
:sub_49
:sub_38
:sub_27
:sub_16
:sub_05
SET ch_w=YY45
GOTO fin_tab_sub

:sub_95
:sub_84
:sub_73
:sub_62
:sub_51
:sub_40
SET ch_w=NN34
GOTO fin_tab_sub
:sub_39
:sub_28
:sub_17
:sub_06
SET ch_w=YY34
GOTO fin_tab_sub

:sub_96
:sub_85
:sub_74
:sub_63
:sub_52
:sub_41
:sub_30
SET ch_w=NN23
GOTO fin_tab_sub
:sub_29
:sub_18
:sub_07
SET ch_w=YY23
GOTO fin_tab_sub

:sub_97
:sub_86
:sub_75
:sub_64
:sub_53
:sub_42
:sub_31
:sub_20
SET ch_w=NN12
GOTO fin_tab_sub
:sub_19
:sub_08
SET ch_w=YY12
GOTO fin_tab_sub

:sub_98
:sub_87
:sub_76
:sub_65
:sub_54
:sub_43
:sub_32
:sub_21
:sub_10
SET ch_w=NN01
GOTO fin_tab_sub
:sub_09
SET ch_w=YY01
GOTO fin_tab_sub

:fin_tab_sub
:: - vysledek operace je "treti-znak" obrazu
:: - pokud z minuleho zpracovani existuje "prenos", bude vysledek operace
::   "druhy-znak" obrazu a nova indikace "prenosu" bude "nulty-znak" obrazu
:: - jestlize "prenos" z minuleho zpracovani neexistuje, bude indikace
::   "prenosu" "prvni-znak" obrazu
SET ch_ww=%ch_w:~3,1%
IF %I_tra% == Y (
  SET ch_ww=%ch_w:~2,1%&SET I_tra=%ch_w:~0,1%
) ELSE (
  SET I_tra=%ch_w:~1,1%
)
GOTO save_res

:save_res
:: umisteni vysledku do bufferu
SET res=%ch_ww%%res%
GOTO cykl_emp

:emp_buff
:: rozskok podle "add/sub"
GOTO opww_%c_a_s%

:opww_add
SET %3=%res%
:: oprava, pokud existuje "prenos" 
IF %I_tra% == Y SET %3=1%res%
GOTO fin_math_CAS

:opww_sub
:: odebrani moznych zbytecnych uvodnich "0"
CALL :NO_zero %res% res
SET %3=%res%
GOTO fin_math_CAS

:fin_math_CAS
SET %4=%buf1w%
SET %5=%buf2w%
GOTO :eof

:: interni subroutine "Math_M"
:: ***************************
:: nasobeni dvou neprazdnych operandu ve "znakovem" tvaru (pocet cifer je
:: neomezeny a muze jakkoliv presahnout moznosti libovolne aritmetiky)
:: **************************************************************************
:: vstupni parametry: - prvni operand - neprazdny retezec "znakovych" cifer 
::                    - druhy   -"-   -               -"-
:: vystupni parametry: - soucin
::                     - prvni operand (bez moznych zbytecnych uvodnich "0")
::                     - druhy                     -"-                      
:: pozn.: - operandy i vysledky jsou chapane jako "cisla" bez znamenek
::        - soucin = nasobenec * nasobitel, kde:
::          - nasobenec = X_n*10**n+X_n-1*10**(n-1)+...+X_1*10**1+X_0*10**0,
::          - nasobitel = Y_m*10**m+Y_m-2*10**(m-2)+...+Y_1*10**1+Y_0*10**0,
::            kde koeficienty "X_i" a "Y_j" nasobence a nasobitele budou
::            "nasobeny" vyberem vysledku z tabulky a "umocnovani" bude
::            realizovane "pripisovanim" "0"
::        - vsechny mozne zbytecne uvodni "0" budou odebirane (operandy
::          obsahujici pouze znakove "0", budou redukovane na znak "0")
::        - pokud vysledek bude mit nulovou hodnotu, bude tvorena znakem "0"
::        - o to, aby vstupni operandy nebyly "prazdne", se stara uzivatel
::        - pri vypoctech je pouzivano interni volani "Math_MC/MA"
::        - pocet cifer operandu je neomezeny
::
:Math_M
:: initializace promennych, odstraneni '"' operandu, odstraneni moznych
:: uvodnich zbytecnych nul a vyreseni relace   
SET m_quot=0
SET m_quot_w=0
SET m_vc=%~1
SET m_vl=%~2
CALL :Math_C "%m_vc%" "%m_vl%" I_com m_vc m_vl
:: zakladni jednoduche "vypocty"
:: test, zda nektery z operandu se rovna "0", pracovni ulozeni obou bufferu,
:: zda nektery z operandu se rovna "1" a vytvoreni "konstant" - exponentu
:: pro simulaci nasobeni mocninou "10" pripisovanim potrebneho mnozstvi "0"
:: pro nasobence i nasobitele 
IF %m_vc% EQU 0 GOTO fin_mul
IF %m_vl% EQU 0 GOTO fin_mul
SET m_vc_w=%m_vc%
SET m_vl_w=%m_vl%
SET m_quot=%m_vc%
IF %m_vl% EQU 1 GOTO fin_mul
SET m_quot=%m_vl%
IF %m_vc% EQU 1 GOTO fin_mul
SET "c10="
GOTO cykl_c

:cykl_c
:: ****
:: odebrani znaku a test prazdneho bufferu operandu_1
SET m_vc_w=%m_vc_w:~1%
CALL :Math_MC "%m_vc_w%" "" I_com 0 0
IF %I_com% == S GOTO cykl_fin_c
SET c10=%c10%0
GOTO cykl_c

:cykl_fin_c
SET "l10="

:cykl_l
:: ****
:: odebrani znaku a test prazdneho bufferu operandu_2
SET m_vl_w=%m_vl_w:~1%
CALL :Math_MC "%m_vl_w%" "" I_com 0 0
IF %I_com% == S GOTO cykl_fin_l
SET l10=%l10%0
GOTO cykl_l

:cykl_fin_l
:: obnova obou pracovnich bufferu a initializace sumacni promenne a exponentu mocniny
SET m_vc_w=%m_vc%
SET m_vl_w=%m_vl%
SET m_quot=0
SET c10_w=%c10%
GOTO cykl_mulo

:cykl_mulo
:: *******
:: dvojity cykl vzajemneho "nasobeni" koeficientu dvou polynomu ve znakovem tvaru
:: vnejsi cykl "nasobeni" - obnova pracovniho bufferu nasobitele a exponentu mocniny
SET m_vl_w=%m_vl%
SET l10_w=%l10%
GOTO cykl_muli

:cykl_muli
:: *******
:: vnitrni cykl vzajemneho "nasobeni" cifer "0" az "9"
FOR %%C IN (0  1  2  3  4  5  6  7  8  9) DO (
  IF %m_vl_w:~0,1% EQU %%C GOTO mul_%m_vc_w:~0,1%%%C
)
:: souciny cifer "0" az "9"
:: skupina, kde minimalne jedna cifra = "0" - vysledek = "0"
:: ********************************************************* 
:mul_00
:mul_01
:mul_02
:mul_03
:mul_04
:mul_05
:mul_06
:mul_07
:mul_08
:mul_09
:mul_10
:mul_20
:mul_30
:mul_40
:mul_50
:mul_60
:mul_70
:mul_80
:mul_90
SET m_quot_w=0
GOTO fin_tab_mul_0

:: skupina, kde jedna z cifer = "1" - vysledek je odpovidajici cifra
:: z "druheho/prvniho" bufferu
:: ***************************************************************** 
:mul_11
:mul_12
:mul_13
:mul_14
:mul_15
:mul_16
:mul_17
:mul_18
:mul_19
SET m_quot_w=%m_vl_w:~0,1%
GOTO fin_tab_mul

:mul_21
:mul_31
:mul_41
:mul_51
:mul_61
:mul_71
:mul_81
:mul_91
SET m_quot_w=%m_vc_w:~0,1%
GOTO fin_tab_mul

:: skupina "beznych" cifer - vysledek = soucin pod navestim s indexem
:: slozenym z techto cifer
:: ******************************************************************
:mul_22
SET m_quot_w=4
GOTO fin_tab_mul
:mul_23
:mul_32
SET m_quot_w=6
GOTO fin_tab_mul
:mul_24
:mul_42
SET m_quot_w=8
GOTO fin_tab_mul
:mul_25
:mul_52
SET m_quot_w=10
GOTO fin_tab_mul
:mul_26
:mul_62
SET m_quot_w=12
GOTO fin_tab_mul
:mul_27
:mul_72
SET m_quot_w=14
GOTO fin_tab_mul
:mul_28
:mul_82
SET m_quot_w=16
GOTO fin_tab_mul
:mul_29
:mul_92
SET m_quot_w=18
GOTO fin_tab_mul

:mul_33
SET m_quot_w=9
GOTO fin_tab_mul
:mul_34
:mul_43
SET m_quot_w=12
GOTO fin_tab_mul
:mul_35
:mul_53
SET m_quot_w=15
GOTO fin_tab_mul
:mul_36
:mul_63
SET m_quot_w=18
GOTO fin_tab_mul
:mul_37
:mul_73
SET m_quot_w=21
GOTO fin_tab_mul
:mul_38
:mul_83
SET m_quot_w=24
GOTO fin_tab_mul
:mul_39
:mul_93
SET m_quot_w=27
GOTO fin_tab_mul

:mul_44
SET m_quot_w=16
GOTO fin_tab_mul
:mul_45
:mul_54
SET m_quot_w=20
GOTO fin_tab_mul
:mul_46
:mul_64
SET m_quot_w=24
GOTO fin_tab_mul
:mul_47
:mul_74
SET m_quot_w=28
GOTO fin_tab_mul
:mul_48
:mul_84
SET m_quot_w=32
GOTO fin_tab_mul
:mul_49
:mul_94
SET m_quot_w=36
GOTO fin_tab_mul

:mul_55
SET m_quot_w=25
GOTO fin_tab_mul
:mul_56
:mul_65
SET m_quot_w=30
GOTO fin_tab_mul
:mul_57
:mul_75
SET m_quot_w=35
GOTO fin_tab_mul
:mul_58
:mul_85
SET m_quot_w=40
GOTO fin_tab_mul
:mul_59
:mul_95
SET m_quot_w=45
GOTO fin_tab_mul

:mul_66
SET m_quot_w=36
GOTO fin_tab_mul
:mul_67
:mul_76
SET m_quot_w=42
GOTO fin_tab_mul
:mul_68
:mul_86
SET m_quot_w=48
GOTO fin_tab_mul
:mul_69
:mul_96
SET m_quot_w=54
GOTO fin_tab_mul

:mul_77
SET m_quot_w=49
GOTO fin_tab_mul
:mul_78
:mul_87
SET m_quot_w=56
GOTO fin_tab_mul
:mul_79
:mul_97
SET m_quot_w=63
GOTO fin_tab_mul

:mul_88
SET m_quot_w=64
GOTO fin_tab_mul
:mul_89
:mul_98
SET m_quot_w=72
GOTO fin_tab_mul

:mul_99
SET m_quot_w=81
GOTO fin_tab_mul

:fin_tab_mul
:: "umocneni" prubezneho vysledku pripsanim "0" a sumace prubezneho soucinu
SET m_quot_w=%m_quot_w%%c10_w%%l10_w%
CALL :Math_MA %m_quot% %m_quot_w% m_quot 0 0
:: ============================================
IF %I_mul% == Y ECHO %m_quot% %m_vc_w% %m_vl_w%
GOTO fin_tab_mul_0

:fin_tab_mul_0
:: je-li prubezny vysledek = "0" (sumace je tedy zbytecna), lze sem provest primy
:: skok, odebrani cifry z bufferu nasobitele a pokud je vnitrni cykl hotovy,
:: odebrani jedne "0" exponentu a opakovani cyklu
SET m_vl_w=%m_vl_w:~1%
CALL :Math_MC "%m_vl_w%" "" I_com 0 0
IF %I_com% == S GOTO fin_cykl_muli
SET l10_w=%l10_w:~1%
GOTO cykl_muli

:fin_cykl_muli
:: odebrani jedne "0" exponentu a cifry z bufferu nasobence a pokud vnejsi cykl
:: neni hotovy, bude opakovan
SET c10_w=%c10_w:~1%
SET m_vc_w=%m_vc_w:~1%
CALL :Math_MC "%m_vc_w%" "" I_com 0 0
IF %I_com% == S GOTO fin_cykl_mulo
GOTO cykl_mulo

:fin_cykl_mulo
GOTO fin_mul

:fin_mul
SET %3=%m_quot%
:: navraceni puvodnich stavu bufferu
SET %4=%m_vc%
SET %5=%m_vl%
GOTO all_mul

:all_mul
GOTO :eof

:: interni subroutine "Math_D"
:: ***************************
:: deleni dvou neprazdnych operandu ve "znakovem" tvaru (pocet cifer neni omezen
:: a muze jakkoliv presahovat moznosti libovolne aritmetiky)
:: *****************************************************************************
:: vstupni parametry: - prvni operand - neprazdny retezec "znakovych" cifer 
::                    - druhy   -"-   -               -"-
:: vystupni parametry: - podil
::                     - zbytek
::                     - prvni operand (bez moznych zbytecnych uvodnich "0")
::                     - druhy                     -"-                      
:: pozn.: - operandy i vysledky jsou chapane jako "cisla" bez znamenek
::        - algoritmus: - "deleni" je realizovano opakovanym odecitanim
::                      - zpetne "nasobeni" a odecitani pro ziskani zbytku
::                        neexistuje, prubezny vysledek resen vypoctem
::                        prislusneho poctu "0" exponentu mociny "10"
::                        a "sepisovanim" dalsich cifer "za" zbytek, pokud
::                        jeste cifry existuji
::                      - prubezny podil - soucet "jednotek" v kazdem kroku
::                        odecitani, je pak "nasoben" mocninou "10", co je
::                        realizovano pripsanim prislusneho poctu "0" a tento
::                        prubezny soucin je postupne nacitan (a zajisten
::                        zbyteku)
::        - vsechny mozne zbytecne uvodni "0" budou odebrane (operandy
::          obsahujici pouze znakove "0", budou redukovany na znak "0")
::        - pokud posledni znaky obou operandu jsou "0", budou odebirane
::        - vysledek (zbytek) s nulovou hodnotou, bude nastaven na znak "0"
::        - o to, aby vstupni operandy nebyly "prazdne", se stara uzivatel
::        - pri vypoctech je pouzivano interni volani "Math_DC/DA/DS"
::        - pocet cifer operandu je neomezeny
::
:Math_D
:: initializace promennych, odstraneni '"' operandu, odstraneni moznych
:: uvodnich zbytecnych nul a vyreseni relace
SET I_ze=N
SET d_quot=0
SET d_quot_w=0
SET rest=0
SET "d_vc_w="
SET d_vc=%~1
SET d_vl=%~2
CALL :Math_C "%d_vc%" "%d_vl%" I_com d_vc d_vl
SET d_d_vc=%d_vc%
SET d_d_vl=%d_vl%
:: odstraneni "0" na konci operandu, pokud je jich stejny pocet
:cyk_fin_zero
:: promenna je pouze "0"?
IF "%d_vc%" == "0" GOTO fin_zero
IF "%d_vl%" == "0" GOTO fin_zero
:: promenne nejsou "0?
SET w_vcvl=%d_vc:~-1%
IF NOT "%w_vcvl%" == "0" GOTO fin_zero
SET w_vcvl=%d_vl:~-1%
IF NOT "%w_vcvl%" == "0" GOTO fin_zero
:: oba dva posledni znaky jsou "0"?
IF %d_vc:~-1% EQU 0 IF %d_vl:~-1% EQU 0 GOTO del_zero
goto fin_zero

:del_zero
:: odebrani "0"
SET d_vc=%d_vc:~0,-1%
SET d_vl=%d_vl:~0,-1%
GOTO cyk_fin_zero

:fin_zero
:: zakladni jednoduche "vypocty"
:: testy, zda delenec se rovna "0", delitel se rovna "0/1", zda se rovnaji
:: operandy a zda delenec je mensi nez delitel
IF %d_vc% == 0 GOTO fin_div
IF %d_vl% == 0 GOTO fin_div
SET d_quot=%d_vc%
IF %d_vl% == 1 GOTO fin_div
SET d_quot=1
IF %d_vc% == %d_vl% GOTO fin_div
CALL :Math_DC "%d_vc%" "%d_vl%" I_com 0 0
IF %I_com% == L (
  GOTO YES_small
) ELSE (
  GOTO YES_equ_big
)

:YES_small
SET d_quot=0
SET rest=%d_vc%
GOTO fin_div

:YES_equ_big
:: pocatecni initializace promenne podilu, zbytku a pracovniho bufferu,
:: symbolicky vytvoreneho z "0", ktery bude potreba jako "pocitadlo"
:: cyklu pri urceni rozdilu maximalniho poctu "0" a poctu "sepsanych"
:: cifer tak, aby tento rozdil nakonec byl dalsim "pocitadlem" cyklu
:: pro urceni exponentu, potrebneho pro nasobeni prubezneho soucinu
:: tech kterych koeficientu polynomu nasobence a nasobitele mocninou "10"
SET d_quot=0
SET "rest="
SET "zero_max="
SET abac=%d_vc%
GOTO cykl_buff_ze

:: cykl vytvareni bufferu ze samych "0" - obsahuje tolik "0", kolik cifer
:: ma delenec
:: **********************************************************************
:cykl_buff_ze
:: pokud neni "pocitadlo" (buffer) vyprazdneno, je tvoren buffer ze samych "0"
CALL :Math_DC "%abac%" "" I_com 0 0
IF %I_com% == S GOTO fin_cykl_buf_ze
SET zero_max=%zero_max%0
SET abac=%abac:~1%
GOTO cykl_buff_ze

:fin_cykl_buf_ze
:: pracovni promenna pro pripravu vypoctu exponentu - vysledny exponent je
:: rozdil poctu cifer delence a poctu postupne "sepisovanych" cifer - rozdil
:: je pocitan v kazdem prubeznem "deleni" a je zrejme, ze postupne klesa 
SET "zero_w="
GOTO cykl_div

:: cykl "deleni"
:: *************
:cykl_div
:: pracovni buffer pro delence a pracovni promenna pro sumaci "jednotek"
:: prubezneho podilu (pri opakovanem odecitani delence)
SET "d_vc_w="
SET d_quot_w=0
GOTO cykl_list

:: cykl "sepisovani" cifer
:: ***********************
:cykl_list
:: pokud uz neexistuje cifra k "sepsani", "deleni" je u konce - jinak je
:: vytvaren buffer znaku "0" (odpovida zpracovani cifry bufferu alias "zvyseni"
:: exponentu o "1") a vybirana cifra pro testovani
CALL :Math_DC "%d_vc%" "" I_com 0 0
IF %I_com% == S GOTO fin_div
SET zero_w=%zero_w%0
SET cif_0=%d_vc:~0,1%
:: - pokud je cifra nenulova, bude ulozena do pracovniho bufferu - v opacnem
::   pripade tam bude ulozena pouze tehdy, pokud uz byla "sepsana" alespon
::   jedna nenulova cifra
:: - jestlize zatim "nenulova" cifra sepsana nebyla, tak cifra k "testovani"
::   do pracovniho bufferu ulozena nebude
:: - ve skutecnosti jde o blize neurceny pocet "0", ktere byly "sepisovane"
::   po prubeznem deleni, ktere skoncilo beze zbytku a je nastavovan priznak
::   sepsani "nenulove" cifry
IF NOT %cif_0% EQU 0 SET I_ze=N&SET d_vc_w=%d_vc_w%%d_vc:~0,1%&GOTO NO_cif_zero
IF %I_ze% == N SET d_vc_w=%d_vc_w%%d_vc:~0,1%&GOTO NO_cif_zero
GOTO NO_cif_zero

:NO_cif_zero
:: - cifra je odebrana ze vstupniho bufferu a pokud se nerovna "0", nastavi
::   se indikace
:: - pokracuje na test, kde se zjistuje, zda " delenec < delitel", pokud cifra
::   je "0" (a je "neplatna", delenec by ji zacinal) a pokracuje se se dalsi
::   cifrou 
:: - jinak se zjistuje, zda "pracovni delenec < delitel"
SET d_vc=%d_vc:~1%
IF NOT %cif_0% EQU 0 SET I_ze=N&GOTO test_rel
IF %I_ze% == Y (
  GOTO cykl_list
) ELSE (
  GOTO test_rel
)

:test_rel
:: - "slozeni" zbytku s prubeznym delenecem a test relace "delenec < delitel"
:: - je-li mensi, pokracuje se "sepsanim" dalsi cifry, jinak od "slozeneho
::   delence" se bude postupne odecitat delitel (realizace "deleni")
SET d_vc_ww=%rest%%d_vc_w%
CALL :Math_DC "%d_vc_ww%" "%d_vl%" I_com 0 0
IF %I_com% == L GOTO cykl_list
SET d_vc_w=%rest%%d_vc_w%
GOTO cykl_sub_div

:cykl_sub_div
:: **********
:: - cykl "deleni" - pokud plati relace "delenec >= delitel", je v cyklu
::   od delence odecitan delitel a zaroven pripocitana "jednotka" podilu
:: - po ukonceni cyklu odectu budou nastaveny hodnoty pro cykl, ktery
::   zjisti rozdil mezi maximalnim poctem znaku puvodniho delence a poctem "0",
::   ktery byl nastaven v prubeznem deleni (a ktery korespondoval s poctem
::   "sepsanych" cifer)
:: - tento rozdil bude predstavovat hodnotu exponentu mocniny "10", potrebneho
::   pro nasobeni soucinu dvou koeficientu prubezneho deleni (tento rozdil
::   bude pouze pouzity jako "pocitadlo" v cyklu, ktery nastavi velikost
::   bufferu "0" (jde o buffer slozeny ze samych znaku "0")
CALL :Math_DS "%d_vc_w%" "%d_vl%" d_vc_w 0 0
CALL :Math_DA %d_quot_w% 1 d_quot_w 0 0
CALL :Math_DC "%d_vc_w%" "%d_vl%" I_com 0 0
:: ==============================================
IF %I_div% == Y ECHO %d_quot% %d_vc_w% %d_quot_w%
IF NOT %I_com% == L GOTO cykl_sub_div
:: initializace promennych pro cykl pripravy vypoctu exponentu
SET zero_ww=%zero_max%
SET abac=%zero_w%
GOTO cykl_zero_cour

:cykl_zero_cour
:: ************
:: pokud buffer neni "prazdny", jsou cifry z bufferu delence postupne odebirane
:: a zbyly pocet znaku je "pocitadlem" cyklu, ktery vytvori buffer znaku "0"
:: exponentu
CALL :Math_DC "%abac%" "" I_com 0 0
IF %I_com% == S GOTO fin_zero_cour
SET zero_ww=%zero_ww:~1%
SET abac=%abac:~1%
GOTO cykl_zero_cour

:fin_zero_cour
:: "vynasobeni poctu jednotek" prubezneho podilu mocninou "10" (realizovane
:: prostym pripsanim vypocitanych "0") a pripocitani tohoto prubezneho podilu
:: do sumacni promenne
SET d_quot_w=%d_quot_w%%zero_ww%
CALL :Math_DA %d_quot% %d_quot_w% d_quot 0 0
:: pokud je prubezny zbytek roven "0", bude promenna zbytku prestavena
:: na "prazdnou" a indikace cifry "0" nastavena/nenastavena (prakticky stav,
:: kdy buffer pro "sepsane" cifry by zacinal znakem "0", protoze "deleni"
:: proste vyslo "na knop") a pokracuje se dalsim prubeznym delenim
SET rest=%d_vc_w%
IF %rest% EQU 0 (
  SET "rest="&SET I_ze=Y
) ELSE (
  SET I_ze=N
)
GOTO cykl_div

:fin_div
:: slozeni predchazejiciho zbytku s moznymi "sepsanymi" ciframi a pokud je
:: zbytek "prazdny", bude nahrazen "0"
SET rest=%rest%%d_vc_w%
IF "%rest%" EQU "" SET rest=0
:: podil, zbytek a navraceni puvodnich bufferu
SET %3=%d_quot%
SET %4=%rest%
SET %5=%d_d_vc%
SET %6=%d_d_vl%
GOTO :eof

:: interni subroutine "compar"
:: ***************************
:: pro dva retezce - "operand_1" a "operand_2" - neomezene delky, slozene
:: ze "znakovych" cifer se rozhoduje, zda jsou shodne nebo ze libovolny z nich
:: je vetsi ci mensi "znakove cislo"
:: ***************************************************************************
:: vstupni parametry: - operand_1
::                    - operand_2
:: vystupni parametry: G/L/S - vysledek relace po vyhodnoceni vztahu
::                             "operand_1" >/</= "operand_2"
:: pozn.: - relace ">/</=" vztah "znakovych" retezcu cifer urcuje presne,
::          i kdyz jde o srovnani alfabeticke, kde napr. plati "102" < "8"
::          (ciselna interpretace by byla jiste znehodnocena, ale zde je vse
::          osetreno samozrejme spravne)
::        - retezec obsahujici alespon jeden znak " ", musi byt "obalen"
::          dvojici znaku '"'
::        - pouzite znaky: - !(21) <= hh <= ~(7E) a hlavne cislice "012...9"
::                           (30-39) a mala (61-7A)/velka pismena (41-5A),
::                           znak (128) a dalsi znaky (napr. "/)]&...")
::                         - znak '"' (22-uvozovky) je filtrovany ridici
::                           znak, ktery neni do zpracovani zahrnut
::                         - se znakem " " se zachazi jako s jakymkoliv
::                           jinym nefiltrovanym znakem
::        - mozne zbytecne uvodni "0" operandu az na jedinou vzdy odebrane
::        - pocty znaku retezcu jsou neomezene
::
:compar
:: operandy a odstraneni '"', pracovni ulozeni bufferu, indikace "prazdnych"
:: bufferu a promenna pro srovnavani
SET buf1c=%~1
SET buf2c=%~2
SET buf1cw=%~1
SET buf2cw=%~2
SET em1c=N
SET em2c=N
:: jsou-li obsahy obou bufferu "prazdne", vysledkem je "S", je-li prazdny jeden
:: z nich, vysledkem je "L/G"
IF "%buf1c%" == "" IF "%buf2c%" == "" SET %3=S&GOTO fin_compar
IF "%buf1c%" == "" SET %3=L&GOTO fin_compar
IF "%buf2c%" == "" SET %3=G&GOTO fin_compar
GOTO cykl_emp1

:cykl_emp1
:: pokud oba buffery jsou "prazdne", zpracovani pokracuje detailnim srovnavanim
IF %em1c% == Y IF %em2c% == Y GOTO same_buf
:: =====================================
IF %I_zer% == Y ECHO "%buf1c%" "%buf2c%"
:: pokud je prvni/druhy buffer "prazdny", zpracovani konci - jinak je znak
:: vybran a odebran z bufferu - pokud by se buffer stal prazdnym, je nastavena
:: indikace
IF %em1c% == Y SET %3=L%&GOTO fin_compar
SET ch_wc=%buf1c:~0,1%
SET buf1c=%buf1c:~1%
IF "%buf1c%" == "" SET em1c=Y
IF %em2c% == Y SET %3=G%&GOTO fin_compar
SET ch_wc=%buf2c:~0,1%
SET buf2c=%buf2c:~1%
IF "%buf2c%" == "" SET em2c=Y
GOTO cykl_emp1

:same_buf
:: obnova bufferu
SET buf1c=%buf1cw%
SET buf2c=%buf2cw%
GOTO cykl_emp2

:cykl_emp2
:: pokud prvni znaky obou bufferu splnuji relaci "LSS", je prvni buffer "mensi"
::                       -"-                     "GTR"        -"-       "vetsi"
:: znaku z obou bufferu jsou odstranene a pokud jsou buffery "prazdne" (staci
:: testovat jediny), rovnaji se jejich obsahy
IF %buf1c:~0,1% LSS %buf2c:~0,1% SET %3=L&GOTO fin_compar
IF %buf1c:~0,1% GTR %buf2c:~0,1% SET %3=G&GOTO fin_compar
SET buf1c=%buf1c:~1%
SET buf2c=%buf2c:~1%
IF "%buf1c%" == "" SET %3=S&GOTO fin_compar
GOTO cykl_emp2

:fin_compar
GOTO :eof

:: interni subroutine "NO_zero"
:: ****************************
:: odstraneni moznych zbytecnych uvodnich "0" z retezce cifer ve "znakovem" tvaru
:: ******************************************************************************
:: vstupni parametry: retezec znaku 
:: vystupni parametry: retezec bez moznych zbytecnych uvodnich "0"
:: pozn.: - z bufferu jsou predem odstraneny vsechny znaky '"'
::        - je-li v retezci alespon jedna " " nebo je "prazdny", je nutne ho pred
::          volanim "balit" do dvojice znaku '"'
::        - vysledny retezec je: - tentyz
::                               -   -"-  bez uvodnich "0"
::                               - tvoreny jednou znakovou "0"
::                               - "prazdny"
::
:NO_zero
:: odstraneni '"'
SET no_ze=%~1
GOTO cykl_no_ze

:cykl_no_ze
:: - pokud je retezec prazdny nebo se znak nerovna "0" nebo se rovna a je jediny,
::   cykl konci
:: - jinak je znak odstranen a zpracovava se dalsi
IF "%no_ze%" == "" SET "no_ze="&GOTO fin_zero
IF NOT "%no_ze:~0,1%" == "0" GOTO fin_zero
IF "%no_ze:~1,1%" == "" GOTO fin_zero
:: =========================
IF %I_zer% == Y ECHO %no_ze%
:: odstraneni znaku a pokracovani cyklu proverenim dalsi mozne "0"
SET no_ze=%no_ze:~1%
GOTO cykl_no_ze

:fin_zero
SET %2=%no_ze%
GOTO :eof

:: **************************************************************************
:: obe skupiny subroutine tvori celek, pouzitelny jako zaklad tvorby souboru
:: typu ".bat" (dalsi radek "*" obe predesle skupiny subroutine ukoncuje)
:: **************************************************************************

:: **************************************************************************
:: pokracovani modulu
:: **************************************************************************
:tx_Press
:: "pause-en"
SET "pause_w=*** press ....."
:: "cmd.exe" je sice vzdy v anglicke mutaci, ale SW v "cz" mutaci bude presto
:: vypisovat text "stiskni ..." - "ulitba" ceskemu prostredi
IF %I_mut% == cz SET "pause_w=*** stiskni ..."
SET YA=Y^|y
SET charYA=Y
SET DA_w=Dir
GOTO all_pause

:tx_Pokra
:: "pause-cz"
SET "pause_w=*** stiskni ..."
SET YA=A^|a
SET charYA=A
SET DA_w=Adr
GOTO all_pause

:all_pause
:: datum a cas, specialni verze "pause", pouzita v pripade zadosti
:: o vypis dokumentace a nastaveni titulniho radku okna spousteneho SW
CALL :DA_TI s
SET pause_ww=%pause_w% "Enter | {Ctrl+C + {%YA% | N|n} + Enter}"

:: *********************************************************************
:: vcetne dalsiho radku s "*" je vse mezi "Diver_SysFol" a "Math" shodne
:: *********************************************************************

:: uprava nazvu SW - odstraneni '"' a pripadnych znaku "_en" a ".bat"
SET nam_SW=%~0
SET nam_SW=%nam_SW:_en=%
SET nam_SW=%nam_SW:.bat=%
title "%nam_SW%_%I_mut%"

:: zakladni konstanty
SET DJ=Data_Jun\
SET I_rob=/E /B /EFSRAW /COPY:DATSO /XJ /XJD /XJF /R:1 /W:0 /V /BYTES /NP /NJH
SET L_rob=%I_rob% /NS /NC /NFL /NDL /L
:: setridena pismena periferii
SET oknemsip=c d e f g h i j k l m n o p q r s t u v w x y z
SET I_EnvOS=N
SET err_l=0
SET I_OS_same=NO

:: "povolene" slozky - root (slozka "config_x" musi byt posledni)
SET Us=Users
SET PD=ProgramData
SET PF="Program Files"
SET PFx="Program Files (x86)"
SET DaS="Documents and Settings"
SET AD="Application Data"
:: Windows\
SET Lo=Logs
SET Pr=Prefetch
SET SD=SoftwareDistribution
SET SP=ServiceProfiles
SET Te=Temp
SET auth_win_NO_WXP=%Lo% %Pr% %SD% %SP% %Te%
SET auth_win_WXP=%Pr% %SD% %Te%
:: Windows\System32\
SET oo=oobe
SET sr=sru
SET wb=wbem
SET WD=WDI
SET wi=winevt
SET auth_s32_NO_WXP=%oo% %sr% %wb% %WD% %wi% config config_new config_old
SET auth_s32_WXP=%oo% %wb% config config_new config_old
SET auth_OS_NO_WXP=%Us% %PD% %PF% %PFx% %DaS% %auth_win_NO_WXP% %auth_s32_NO_WXP%
SET auth_OS_WXP=%DaS% %PF% %auth_win_WXP% %auth_s32_WXP%

:: vylouceno z diverzifikace (pro rezim "Sm", operaci "c/r" a parametr "all")
SET BinE=$RECYCLE.BIN
SET BinR=RECYCLER
SET BinS="Recycle Bin.sys"
SET hib=hiberfil.sys
SET pag=pagefile.sys
SET swa=swapfile.sys

:: konstanty pro kontrolu parametru
SET sc=a b c d e f g h i j k l m n o p q r s t u v w x y z
SET BC=A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
SET nc=0 1 2 3 4 5 6 7 8 9 _
SET nc_w=$ % ' ~ - [ ] # ! { } &
SET all_c=%sc% %BC% %nc%
SET all_cw=%all_c% %nc_w%
SET lrou_bra=(
SET rrou_bra=)
SET I_space=""

:: parametry spousteciho prikazu
SET p_w0=%0
SET p_w1=%1
SET p_w2=%2
SET p_w3=%3
SET p_w4=%4
SET p_w5=%5
SET p_w6=%6
SET p_w7=%7
:: - ulozeni moznych parametru "8" a "9" ("debugging" a "cekaci smycka")
:: - tyto parametry se pri schvalovani nezobrazuji
SET p_w8=%8
SET p_w9=%9

:: deklarace globalnich promennych, pouzitych pri volani subroutine:
:: - je-li pri volani subroutine prikazem CALL pouzit parametr, ktery
::   bude parametrem vystupnim, musi byt pred volanim deklarovan (a pri
::   volani musi byt pouzito jeho jmeno)
:: - ciselne poradi "p" parametru pri volani subroutine je pak pouzite
::   v prikazu "SET %p=...", kde pro "p" musi platit 0 < "p" <= 9 a musi
::   odpovidat poradi parametru pri volani
:: - opomenuti deklarace parametru pred volanim "CALL" (napr. prikazem
::   SET "nazev=" nebo SET nazev=0) vyvola chybu
:: - ve volane subroutine je vzdy mozne vracet hodnotu primo prikazem
::   "SET=..." s "procentovou" promennou "%p" ("0 < "p" <= 9")
SET "out_NUL="
SET "NI_ER="
SET "str_att="

:: specialni konstanta - buffer o delce ctyr znaku "ferda" pro testovani,
:: zda "cesta" oznacuje pouze oddil ("pismenko:\" - retezec je prave
:: o "1 znak" kratsi nez testovany buffer)
SET str_4=####
SET siz_OU=0
SET siz_IN=0
SET siz_ALL=0
SET "I_ts="
SET "name_w="
:: nastaveni pocitadel prejmenovanych a zpetne kopirovanych slozek
:: pro rezim "Bm"
SET f_ren=0 
SET f_ren_cop=0
:: promenna pro osetreni chyby v procesu vytvareni "junction" pro
:: "Users/ProgramData"
SET err_UP=N
:: promenna pro hlaseni chyby "neprevzeti vlastnictvi a nenastaveni prav"
SET I_err_taow=N
:: soubor "NUL_t h e q u i c k f o x l z y g s p j n m w r v d.txt"
:: (prazdny), vzdy zalozeny v domovske slozce
TYPE NUL > "NUL_%pismenko%.txt"

:: *****
:: START
:: *****

CLS
:: pocet parametru a zakladni testy jejich obsahu:
:: - je-li pocet parametru roven "0", bude na display zobrazen cely popis
::   "Diver_SysFol.bat" a zapnut modul pro hledani pismen a nazvu oddilu,
::   ktery praci ukonci ohlasenim chyby "pocet parametru = "0" ..." 
:: - pokud uzivatel vklada - z hlediska validity parametru - exoticke
::   udaje, muze se objevit oznameni o chybe syntaxe
:: - jsou kontrolovany i dva neverejne parametry - implicitni spousteni
::   casove smycky a "nespousteni" "debugging"
:: zpracovavani parametru:
::   - 9   parametru - "casova smycka", "debugging", "all" (povinny)
::   - 8      -"-    - "casova smycka", "debugging" ("all" zakazany)
::   - 7      -"-    - "all" (posledni, povinny, bezna situace)
::   - 6      -"-    - bezna situace
::   - 1-5    -"-    - chyba
::   - 0      -"-    - vypis dokumentace + simulovana chyba jako konec vypisu
:: "casova smycka" - existence, povolene hodnoty "Y/N"
IF %p_w9%. == . GOTO test_p_w8
IF %p_w9% == Y GOTO Y_p98
SET Ind_p=9
IF NOT %p_w9% == N GOTO err_all_parNY
SET wait_YN=N
GOTO Y_p98

:: "debugging" - povolene hodnoty "Y/N"
:Y_p98
IF %p_w8% == N GOTO Y_p97
SET Ind_p=8
IF NOT %p_w8% == Y GOTO err_all_parNY
SET I_cyklNY=Y
GOTO Y_p97

:: "all" - povolena hodnota "all"
:Y_p97
SET Ind_p=7
IF NOT %p_w7% == all GOTO err_all_par
GOTO con_Nam_fol

:: "casova smycka" - existence, povolene hodnoty "Y/N"
:test_p_w8
IF %p_w8%. == . GOTO test_p_w7
IF %p_w8% == Y GOTO Y_p87
SET Ind_p=8
IF NOT %p_w8% == N GOTO err_all_parNY
SET wait_YN=N
GOTO Y_p87

:: "debugging" - povolene hodnoty "Y/N"
:Y_p87
SET Ind_p=6
IF %p_w7% == N GOTO con_Nam_fol
IF NOT %p_w7% == Y SET Ind_p=7&GOTO err_all_parNY
SET I_cyklNY=Y
GOTO con_Nam_fol

:: "all" - povolena hodnota "all"
:test_p_w7
IF %p_w7%. == . GOTO test_p_w6
SET Ind_p=7
IF NOT %p_w7% == all GOTO err_all_par
GOTO con_Nam_fol

:: existence parametru 6
:test_p_w6
IF NOT %p_w6%. == . SET Ind_p=6&GOTO con_Nam_fol
:: existence zbylych parametru
IF NOT %p_w1%. == . SET Ind_p=1&GOTO err_sum_par
SET Ind_p=0
CLS
ECHO *******************************************************************************
ECHO *    "Diver_SysFol.bat" is an efficient software to diversify system folders  *
ECHO * to a partition that differs  from the system partition, which greatly limits*
ECHO * the quantity and intensity of writing to the system partition, and          *
ECHO *                                                                             *
ECHO *    significantly increases the OS security and immunity against failure     *
ECHO *                                                                             *
ECHO * and frees up the space of such system partition, as well (naturally, at the *
ECHO * expense of another space needed).                                           *
ECHO *    SW type ".bat" is almost independent of the OS configuration, its changes*
ECHO * and updates. For system folder diversified by using a command "robocopy" (it*
ECHO * is often even tens of gigabytes of data) exist another special command      *
ECHO * "mklink" created "junction" of the original and current folders locations in*
ECHO * the repository, selected by the user.                                       *
ECHO *   This software, under certain assumptions, prove OS returning to the       *
ECHO * original state before diversification (but not on the re clone OS - the     *
ECHO * method is different).                                                       *
ECHO *    First start "Diver_SysFol.bat" is necessary - and repeatedly - to perform*
ECHO * without a parameter. It is highly recommended to lunch this software from   *
ECHO * an external flash-media.                                                    *
ECHO *******************************************************************************
ECHO %pause_ww%
PAUSE>NUL
CLS
ECHO *******************************************************************************
ECHO *    Important: flawless service will be provided only starting in the "boot" *
ECHO * installation environment minimum that level, which will then have a working *
ECHO * OS (starting with Windows 7) or in an Active Boot Disk (ABD) and it is not  *
ECHO * the mistake of previous disk clone. At the same PC SW can handle more OS,   *
ECHO * for example. W7, W10 (even WXP), partition(s) for storage have to be        *
ECHO * formatted (s) as NTFS and SW "dangerous" like as another disk cloning SW.   *
ECHO *                                                                             *
ECHO *      "Diver_SysFol.bat" launching options:                                  *
ECHO *      Diver_SysFol[.bat] [I_r  O_r  X_m  I_mod  Nam_Fol  I_ope  [all]]       *
ECHO *                                                                             *
ECHO *    A local output partition for diversified folders, user-selected          *
ECHO * beforehand, should have enough free space (tens of GB).                     *
ECHO *    No options "Diver_SysFol.bat" run, calls a module typing important       *
ECHO * information: letters corresponding to the partitions names, which are       *
ECHO * otherwise in a "boot" installations (ABD) environment are detected difficult*
ECHO * enough (the exact procedure found letters and partition name, see note).    *
ECHO *    Search ends error list "*** Error: the number of parameters is ....".    *
ECHO *    SW flawless functionality is guaranteed in installation environment or   *
ECHO * ABD only.                                                                   *
ECHO *******************************************************************************
ECHO %pause_ww%
PAUSE>NUL
CLS
ECHO *******************************************************************************
ECHO *     "Diver_Sysfol.bat" operates in three modes: - normal,                   *
ECHO *                                                 - special and               *
ECHO *                                                 - "back"                    *
ECHO *     In "normal" mode, as instructed by the user, is for diversified system  *
ECHO * folders assured repository, they are transferred, they is created "junction"*
ECHO * and from their original location these folders are removed or renamed and   *
ECHO * left.                                                                       *
ECHO *     Mode "special" diversifies any folder or partition anywhere and any     *
ECHO * folder or partition content can be remove.                               *
ECHO *     And finally - the "back" mode, can return everything to its original    *
ECHO * state.                                                                      *
ECHO *     This mighty and thorough SW in the "full" release contains the original *
ECHO * author algorithm to operate the object "junction", which can not be copied  *
ECHO * using the OS means (see details in the Manual, Chapter 1. and 4.).          *
ECHO *     Performance of SW "Diver_Sysfol.bat" is multiplied using the parameter  *
ECHO * "all".                                                                      *
ECHO *     The time-consuming situation (e.g. in diversification, removing the     *
ECHO * contents of the partition or large folder), can be opened next window/s,    *
ECHO * giving details on the ongoing activities and highlighting the ongoing time  *
ECHO * loop/s SW "Diver_SysFol.bat".                                               *
ECHO *******************************************************************************
ECHO %pause_ww%
PAUSE >NUL
CLS
:: spusteni "wait" smycky, hlavicka seznamu oddilu s pismeny, vystup seznamu,
:: ukonceni "casove smycky" a pokracovani ve vypisu dokumentace
CALL :flag_file_WD W sort %I_mut% %charYA% %wait_YN%
SET "vol_w="
FOR %%x IN (%oknemsip%) DO (CALL :sea_vol all %%x:\ vol_w)
ECHO ***
ECHO    The letters and partition names:
ECHO.
COPY "fipa_%pismenko%.txt" CON %stream%
CALL :flag_file_WD D sort %I_mut% %charYA% %wait_YN%
GOTO err_sum_par

:con_Nam_fol
ECHO.
ECHO *************************************************************************
ECHO *** www.nemohouci.cz                     %w_da%  %w_ti%  %stopwatch%
ECHO *************************************************************************
:: spusteni "wait" smycky
CALL :flag_file_WD W tenv %I_mut% %charYA% %wait_YN%
:: initializace parametru pro "dubugging"
SET I_zer=%I_cyklNY%
SET I_mul=%I_cyklNY%
SET I_div=%I_cyklNY%
:: zpracovani a kontrola vsech parametru
:: *************************************
:: parametry 1-4
:: *************
SET I_all=""
:: odstraneni znaku '"', "," ")", "(",  a ":"
CALL :pure %p_w1% 1
IF %I_err% == Y GOTO finn
SET p1=%pww%
CALL :pure %p_w2% 2
IF %I_err% == Y GOTO finn
SET p2=%pww%
CALL :pure %p_w3% 3
IF %I_err% == Y GOTO finn
SET p3=%pww%
CALL :pure %p_w4% 4
IF %I_err% == Y GOTO finn
SET p4=%pww%
SET W_nam_fol=%p_w5%
:: parametr 6
:: **********
CALL :pure %p_w6% 6
IF %I_err% == Y GOTO finn
SET p6=%pww%
IF %Ind_p% == 6 GOTO par_OK
:: parametr 7
:: **********
CALL :pure %p_w7% 7
IF %I_err% == Y GOTO finn
SET p7=%pww%
SET I_all=""
:: parametr "all"
IF %p7% == all SET I_all=all&GOTO OK_p_w7
IF %p7% == N GOTO OK_p_w7
IF %p7% == Y GOTO OK_p_w7
GOTO err_all_par

:OK_p_w7
SET I_space=""
GOTO NO_con_Nam_fol

:: parametr 5
:: **********
:par_OK 
SET p5=%p_w5%
:: odstraneni znaku '"', ocisteni parametru a provereni vsech znaku parametru
SET p5=%p5:"=%
IF "%p5%". == "". SET Ind_p=5&GOTO err_sum_par
SET W_nam_fol=%p5%
SET n_ch=0
GOTO c_ch5

:c_ch5
IF NOT %n_ch% == 256 GOTO OK_ch51
CALL :err_n_ch
GOTO finn

:OK_ch51
SET I_ch=""
:: vyber nejlevejsiho znaku, jeho odstraneni z bufferu, provereni existence
:: leve/prave kulate zavorky a znaku " " 
SET lc=%p5:~0,1%
SET p5=%p5:~1%
IF "%lc%" == "%lrou_bra%" GOTO lrou_bra_yes
IF "%lc%" == "%rrou_bra%" GOTO rrou_bra_yes
IF "%lc%" == "\" GOTO NO_test_sla
IF NOT "%lc%" == " " GOTO test_c
SET I_space=" "
GOTO space_yes

:test_c
:: provereni znaku v "Nam_fol" pomoci seznamu znaku
FOR %%x IN (%all_cw%) DO (IF "%lc%" == "%%x" SET I_ch=%%x&GOTO fin_forNF)

:fin_forNF
IF NOT %I_ch% == "" GOTO OK_ch52
CALL :err_ch 5
GOTO finn

:OK_ch52
:lrou_bra_yes
:rrou_bra_yes
:NO_test_sla
:space_yes
:: sumace znaku, provereni existence dalsiho znaku a test, zda retezec zacina
:: znakem " "
CALL :Math_A %n_ch% 1 n_ch 0 0
IF NOT "%p5%". == "". GOTO c_ch5
SET I_ch=%W_nam_fol:~0,1%
IF "%I_ch%" == " " GOTO err_space
GOTO NO_con_Nam_fol

:NO_con_Nam_fol
IF NOT %I_space% == " " GOTO No_space
:: odstraneni '"'
SET W_nam_fol="%W_nam_fol:"=%"
GOTO NO_space

:No_space
:: nazev "\" predstavujici cely oddil - test existence jednoho/dvou znaku "\"
IF /I %W_nam_fol% == "\" GOTO slash_one
:: znak "\" na pocatku retezce, ktery obsahuje minimalne jeden dalsi znak?
IF /I "%W_nam_fol:~1,1%" == "\" IF /I NOT %W_nam_fol:\=% == "" GOTO :err_space
SET lc=\\
IF /I NOT %W_nam_fol:\\=% == %W_nam_fol% GOTO err_slash_two
GOTO slash_ok

:err_slash_two
CALL :err_ch 5
GOTO finn

:slash_ok
:slash_one
:: ukonceni "wait" smycky, pokud se vyskytla chyba
CALL :flag_file_WD D tenv %I_mut% %charYA% %wait_YN%

:: initializace parametru "Nam_fol" (dukladne kontrolovany parametr 5) a prvni
:: schvalovani vystupu parametru 
SET Nam_fol=""
ECHO.
ECHO *** Input parameters (possibly after editing):
IF %Ind_p% == 6 (
  ECHO          %p1%   %p2%   %p3%   %p4%   %W_nam_fol%   %p6%
) ELSE IF %Ind_p% == 7 (
  ECHO          %p1%   %p2%   %p3%   %p4%   %W_nam_fol%   %p6%   %p7%
) ELSE (
  GOTO finn
)
CALL :any
IF %I_space% == "" GOTO YES_sp

:: odstraneni '"' a test existence alespon jedne skupiny minimalne dvou
:: sousednich mezer
SET W_nam_fol="%W_nam_fol:"=%"
IF NOT %W_nam_fol:  =% == %W_nam_fol% (
  GOTO :err_nam_fol
) ELSE (
  GOTO W_nam_fol_OK
)

:W_nam_fol_OK
:YES_sp
:: kontroly: - existence a pripustnosti pismen oddilu
::           - shody vstupniho a vystupniho oddilu
::           - rezimu 
::           - operaci
::           - existence "NTFS" (povoleny zapis?)
::           - spousteciho oddilu 
:: **************************************************

:: pocatecni initializace oznaceni oddilu
SET I_r=""
SET O_r=""
SET X_m=""
:: pripustnost pismen oddilu vstupujicich do operace
FOR %%x IN (%pismenko%) DO (IF %p1% == %%x SET I_r=%%x:\&GOTO fin_forPA1)
IF %I_r% == "" GOTO err_i_Ir
GOTO fin_forPA1

:fin_forPA1
FOR %%x IN (%pismenko%) DO (IF %p2% == %%x SET O_r=%%x:\&GOTO fin_forPA2)
IF %O_r% == "" GOTO err_o_Or
GOTO fin_forPA2

:fin_forPA2
FOR %%x IN (%pismenko%) DO (IF %p3% == %%x SET X_m=%%x:\&GOTO fin_forPA3)
IF %X_m% == "" GOTO err_o_Om
GOTO fin_forPA3

:fin_forPA3
:: vstupni oddily "robocopy" a "mklink" se vzdy rovnaji a uschova oznaceni
:: oddilu pro pozdejsi odstraneni pracovniho souboru z doby testovani
:: vhodnosti "cmd.exe" 
SET O_r_del=%O_r%
SET I_mr=%I_r%
:: shoda oddilu
IF /I NOT %I_r% == %O_r% GOTO OK_part_IO
ECHO.
ECHO *** Error: conformity input and output partition "%I_r%" 
ECHO            for "robocopy" is not allowed
GOTO finn

:OK_part_IO
:: rezim
SET I_mod=""
FOR %%x IN (Nm Bm Sm) DO (IF %p4% == %%x SET I_mod=%%x&GOTO fin_forMO)
IF %I_mod% == "" GOTO err_mode
GOTO fin_forMO

:fin_forMO
:: operace
SET I_ope=""
FOR %%x IN (c r d) DO (IF %p6% == %%x SET I_ope=%%x&GOTO fin_forOP)
IF %I_ope% == "" GOTO err_ope_crd
GOTO fin_forOP

:fin_forOP
:: spusteni "wait" smycky, vytvoreni dat pro praci prikazu DISKPART pri
:: zjistovani nazvu a pismen vsech oddilu, vytvoreni seznamu a test
:: existence "NTFS" na oddilech
CALL :flag_file_WD W tenv %I_mut% %charYA% %wait_YN%
ECHO list volume > "s_li_%pismenko%.txt"
DISKPART /S "s_li_%pismenko%.txt" > "lisp_%pismenko%.txt"
CALL :ex_NTFS %I_r% 1
IF %I_err% == Y GOTO err_NTFS
CALL :ex_NTFS %O_r% 2
IF %I_err% == Y GOTO err_NTFS
CALL :ex_NTFS %X_m% 3
IF %I_err% == Y GOTO err_NTFS
:: pismeno spousteciho oddilu a test, zda v rezimu "Nm" neni vstupni
:: oddil "spoustecim" (tedy zda neobsahuje slozku s "Diver_SysFol.bat")
SET lett_SP=%CD:~0,3%
IF /I NOT %lett_SP% == %I_r% GOTO sea_l_n
IF NOT %I_mod% == Nm GOTO sea_l_n
ECHO.
ECHO *** Error: letter equality the selected partition %lett_SP% 
ECHO            and boot partition containing SW "Diver_SysFol.bat" 
ECHO            in mode "Nm" is not allowed
GOTO err_NTFS

:err_NTFS
:: ukonceni "wait" smycky, pokud se vyskytla chyba
CALL :flag_file_WD D tenv %I_mut% %charYA% %wait_YN%
GOTO finn

:sea_l_n
:: nalezeni nazvu oddilu vstupujicich do operaci podle pismen oddilu,
:: zalozeni prazdneho souboru ve "vstupnim/vystupnim" oddilu, vytvoreni
:: dat pro prikaz DISKPART a provereni prostredi, ve kterem bude SW
:: "Diver_SysFol.bat" spusten
SET "vol_I_r="
SET "vol_O_r="
SET "vol_X_m="
CALL :sea_vol one %I_r% vol_I_r
CALL :sea_vol one %O_r% vol_O_r
CALL :sea_vol one %X_m% vol_X_m
TYPE NUL > "%I_r%NUL_%pismenko%.txt"
TYPE NUL > "%O_r%NUL_%pismenko%.txt"
ECHO select volume c > "s_OS_%pismenko%.txt"
ECHO remove letter c >> "s_OS_%pismenko%.txt"
ECHO assign letter c >> "s_OS_%pismenko%.txt"
DISKPART /S "s_OS_%pismenko%.txt" >NUL
IF NOT %ERRORLEVEL% == 0 SET I_envOS=Y
:: vytvoreni dat pro prikaz DISKPART - pro zamenu pismena vstupniho
:: oddilu "I_r" na pismeno "c" a jeho navraceni (pismeno "a" slouzi
:: jako pomocne)
ECHO select volume c > "s_ch_%pismenko%.txt"
ECHO remove letter c >> "s_ch_%pismenko%.txt"
ECHO assign letter a >> "s_ch_%pismenko%.txt"
ECHO select volume %I_r:~0,1% >> "s_ch_%pismenko%.txt"
ECHO remove letter %I_r:~0,1% >> "s_ch_%pismenko%.txt"
ECHO assign letter c >> "s_ch_%pismenko%.txt"
ECHO select volume a >> "s_ch_%pismenko%.txt"
ECHO remove letter a >> "s_ch_%pismenko%.txt"
ECHO assign letter %I_r:~0,1% >> "s_ch_%pismenko%.txt"
:: ukonceni "wait" smycky, pokud se chyba nevyskytla
CALL :flag_file_WD D tenv %I_mut% %charYA% %wait_YN%

:: druhe schvalovani parametru
ECHO.
ECHO *** Basic (important) approval of the selected input output partitions,
ECHO     which with will be implementation elected and allowed operations:
ECHO     I_r: %I_r% - %vol_I_r%
ECHO     O_r: %O_r% - %vol_O_r%
ECHO     X_m: %X_m% - %vol_O_r% (at the moment %vol_X_m%)
CALL :any

:: kontroly: - pripustnost rezimu vuci prostredi OS
::           - zpracovani oddilu v rezimech
::           - existence typu OS
::           - existence uloziste
::           - konstituce OS a existence slozek
::           - existence "config"
::           - zpracovani jedne/vsech slozek 
:: test prace v prostredi OS, rezimu Sm a vystup chyby s ukoncenim prace
IF %I_envOS% == N GOTO OK_env
IF %I_mod% == Sm GOTO OK_env_Sm
:: ohlaseni chyby "nepovoleni " rezimu "Nm/Bm" v prostredi OS
CALL :err_env 
GOTO finn

:OK_env_Sm
:: test, zda vystupni oddil je systemovy, zda jde o operaci diverzifikace
:: a existence parametru "all"
IF /I NOT %O_r% == C:\ GOTO OK_env
IF %I_ope% == c GOTO OK_env
IF NOT %I_all% == all GOTO OK_env
ECHO.
ECHO *** Error: output system partition processing %vol_O_r% in mode "Sm"
ECHO            permitted in installation or in ABD environment only (in
ECHO            the OS environment with operation "c" and without "all" only)
GOTO finn

:OK_env
:: cesta k ulozisti "Data_Jun\", sestaveni nazvu nadrizene slozky "F_?\"
:: pro diverzifikovane slozky ("?" = nazev vstupniho oddilu), odstraneni
:: '"' a hlavni rozskok podle rezimu "Nm/Bm/Sm" (v rezimu Sm" neni
:: "existence" OS pro kriticka zpracovani podstatna a nevadi) 
SET O_r=%O_r%%DJ%
SET X_m=%X_m%%DJ%
SET F_xy=F_%vol_I_r%\
SET F_xy=%F_xy:"=%
SET I_OS=""
:: rozskok podle "Nm/Bm/Sm"
GOTO test_%I_mod%

:test_Nm
:: testovani existence OS na vstupu
CALL :exist_OS "%I_r%" input I_OS
IF %I_err% == Y GOTO finn
GOTO fin_test_Nm

:test_Bm
:: testovani existence "OS" na vystupu a existence uloziste "Data_Jun\" na vstupu
CALL :exist_OS "%I_r%" output I_OS
IF %I_err% == Y GOTO finn
CALL :exist_OS "%O_r%%F_xy%" vstupu I_OS
IF %I_err% == Y GOTO finn

SET I_OSw=%I_OS%
:: test existence "OS" na vystupu a test shodnych typu OS 
CALL :att_exi Ff "%I_r%Windows\System32\config\systemprofile" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_r%Windows\System32\config\systemprofile" F
IF %NI_ER% == NI GOTO err_NO_OS
IF %I_OS% == %I_OSw% GOTO fin_test_Bm
ECHO.
ECHO *** Error: input folders from %O_r:~0,3%F_%vol_I_r%\ not belong 
ECHO            to the OS installed on the partition "%vol_I_r%"   
GOTO finn

:err_NO_OS
ECHO.
ECHO *** Error: in output partition %vol_I_r% either does not 
ECHO            exist installed proper OS or is major corrupted
GOTO finn

:test_Sm
:: rezim "Sm" je zpracovavan zvlast 
GOTO S_mode

:fin_test_Nm
:: operace "d"?
IF %I_ope% == d GOTO err_ope_crd
:: uloziste "Data_Jun\F_?" se zaklada pouze v rezimu "Nm"
IF NOT %I_mod% == Nm GOTO automat_Yes
CALL :att_exi Ff "%O_r%%F_xy%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%" F
IF %NI_ER% == NI MKDIR "%O_r%%F_xy%" %stream%
IF NOT ERRORLEVEL 1 GOTO automat_Yes
GOTO err_DJ

:fin_test_Bm
:: operace "c"?
IF %I_ope% == c GOTO automat_Yes
GOTO err_ope_crd

:automat_Yes
:: rozhodnuti o zpracovani jedne/vsech slozek (auto-rezim)
IF NOT %I_all% == all GOTO automat_NO
:: zpracovani "normalnich" slozek v "simulovane" subroutine
:: ********************************************************
:: kontrola existence vsech "normalnich" slozek a vypocet celkove velikosti
:: potrebneho volneho prostoru na vystupu/vstupu:
:: - pokud tato velikost, kterou slozky pro diverzifikaci (zpetnou
::   diverzifikaci) potrebuji, neni dostatecna, bude prace SW okamzite
::   ukoncena
:: - kontrola je provadena v rezimu "Nm/Bm" a v rezimu "Bm" je navic
::   testovano pomoci existence slozky "Program Files_pismenko" (ktera je
::   pritomna ve vsech typech zpracovavanych OS, vcetne WXP), zda slozky
::   nebudou pouze zpetne prejmenovavane
:: - pokud ano, kontrola provedena nebude
SET siz_ALLwww=0
:: nastaveni seznam slozek podle "typu" OS
IF %I_OS% == NO_WXP SET div_fol=%auth_OS_NO_WXP: config_new config_old=%
IF %I_OS% == WXP SET div_fol=%auth_OS_WXP: config_new config_old=%
IF %I_mod% == Nm SET con_IO=%O_r%&GOTO con_IONmBm
CALL :att_exi Ff "%I_r%Program Files_%pismenko%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_r%Program Files_%pismenko%" F
IF %NI_ER% == OK GOTO :NO_size_free
SET con_IO=%I_r%
GOTO con_IONmBm

:con_IONmBm
FOR %%E IN (%div_fol%) DO (SET Nam_fol=%%E&CALL :ex_si !Nam_fol! !siz_ALLwww! siz_ALLwww)
CALL :test_size "%con_IO%" NUL NenOF %DA_w% siz_OU siz_IN I_ts siz_ALL
IF %I_ts% == OK GOTO next_test0
IF %I_ts% == Eo CALL :err_tak_own "%con_IO%" F
IF %I_ts% == ER CALL :err_tak_own "%con_IO%" F
GOTO next_test0

:next_test0
:: porovnani souctu velikosti vsech vstupnich slozek s velikosti prostoru na vystupu
CALL :Math_C %siz_OU% %siz_ALLwww% I_com 0 0
IF %I_com% == L CALL :err_insu %O_r%
GOTO NO_size_free

:NO_size_free
:: automaticke zpracovani "normalnich" slozek v rezimu "Nm" a "Bm"
:: (je nastavena zpetna adresa)
SET Adr_after=after_Us
SET Nam_fol=%Us%
GOTO kernel

:after_Us
SET Adr_after=after_PD
SET Nam_fol=%PD%
GOTO kernel

:after_PD
IF %I_mod% == Bm GOTO NO_rend
:: zpracovani "junction" tandemu slozek "Users/ProgramData" v rezimu "Nm"
CALL :rendel_UP err_UP
IF %err_UP% == Y CALL :err_tak_own "%I_r%%Ws32w%Users/ProgramData" F&GOTO finn

:NO_rend
SET Adr_after=after_PF
SET Nam_fol=%PF%
GOTO kernel

:after_PF
SET Adr_after=after_PFx
SET Nam_fol=%PFx%
GOTO kernel

:after_PFx
SET Adr_after=after_DaS
SET Nam_fol=%DaS%
GOTO kernel

:after_DaS
SET Adr_after=after_Lo
SET Nam_fol=%Lo%
GOTO kernel

:after_Lo
SET Adr_after=after_Pr
SET Nam_fol=%Pr%
GOTO kernel

:after_Pr
SET Adr_after=after_SD
SET Nam_fol=%SD%
GOTO kernel

:after_SD
SET Adr_after=after_SP
SET Nam_fol=%SP%
GOTO kernel

:after_SP
SET Adr_after=after_Te
SET Nam_fol=%Te%
GOTO kernel

:after_Te
SET Adr_after=after_oo
SET Nam_fol=%oo%
GOTO kernel

:after_oo
SET Adr_after=after_sr
SET Nam_fol=%sr%
GOTO kernel

:after_sr
SET Adr_after=after_wb
SET Nam_fol=%wb%
GOTO kernel

:after_wb
SET Adr_after=after_WD
SET Nam_fol=%WD%
GOTO kernel

:after_WD
SET Adr_after=after_wi
SET Nam_fol=%wi%
GOTO kernel

:after_wi
SET Adr_after=after_con
SET Nam_fol=config
GOTO kernel

:after_con
:: ukonceni prace v "automatickem" rezimu
:: **************************************
:: rozskok podle "Nm/Bm"
GOTO fin_%I_mod%

:fin_Nm
ECHO.
ECHO *** "Normal" mode "%I_mod%": 
ECHO     - automatic system folders diversification finished 
:: rozskok podle "r/c"
GOTO :fol_all_%I_ope%

:fol_all_r 
ECHO     - all system folders were removed and the space on 
ECHO       the partition with the OS was released 
GOTO fol_cr_all

:fol_all_c
ECHO     - folders in the original location remained, but were renamed 
ECHO       (necessary preconditions for success mastering the reverse
ECHO       clone in mode "Bm" if the user so chooses in the future).
ECHO          Reverse clone can be done whenever if diversified 
ECHO       folders exists unnamed (original) and their number 
ECHO       is equal to the number of folders diversified. 
ECHO          Otherwise, it is almost certain, that there was an
ECHO       desynchronization OS with the "Registry" and a return of
ECHO       diversified components in fact is always possible not with
ECHO       with certainty determine, how and whether the OS will operate
GOTO fol_cr_all

:fol_cr_all
ECHO     - "junction", which can not be copied, was restored
ECHO       with original algorithm of author, see "log-files"
GOTO finn

:fin_Bm
ECHO.
ECHO *** Mode "back" "%I_mod%": 
ECHO     - ended diversify backward copying folders from the repository  
ECHO       "%DJ%%F_xy%" partition %vol_O_r% to partition %vol_I_r% 
ECHO       or was  made their retroactively renaming only
ECHO     - conditionally was returned even the folder "config" with 
ECHO       the "Registry"
IF %I_OS_same% == NO GOTO OS_same_NO 
ECHO     - this statement exists only, if in "normal" mode the folders 
ECHO       were preserved to renamed (to stay original) and its renaming 
ECHO       and its creation made a favorable condition for the possible 
ECHO       return of these renamed system folder partitions (and right 
ECHO       now not spared the space on the partition with the OS)
ECHO     - if restoration "config" (original folder "config_old") is 
ECHO       enabled, the OS will be restored to the state before 
ECHO       the diversify (this is actually a callback function clone and
ECHO       all "junction" will be re set by the original algorithm author,
ECHO       see "log-files")
GOTO finn

:OS_same_NO
ECHO     - OS not in the original state, because in the course of work 
ECHO       certainly there are substantial OS changes and desynchronized
ECHO       "Registry" with the OS. That does not mean that the OS will 
ECHO       not work properly, see "log-files"
GOTO finn

:automat_NO
:: zpracovani jedne "normalni" slozky
:: **********************************
:: je slozka "nenastavena automatikou" v seznamu povolenych "normalnich" slozek?
FOR %%N IN (%auth_OS%) DO (IF %W_nam_fol% == %%N SET Nam_fol=%%N&GOTO fin_forFO)
IF %Nam_fol% == "" GOTO err_nam_fol
GOTO fin_forFO

:fin_forFO
:: nastaveni casti cest
CALL :Ws32w_ini "%Nam_fol:"=%"
:: rezim "Bm"?
IF %I_mod% == Bm GOTO Yes_Bm1
SET I_UP=X
:: - pokud ma byt prave zpracovana slozka "ProgramData", bude zpracovana
:: - pokud ale slozka "Users", bude zpracovana slozka "ProgramData" - ma
::   prednost, duvodem je cas
:: - pokud jina slozka, bude proste zpracovana
IF "%Nam_fol%" == "%PD%" GOTO jump
IF "%Nam_fol%" == "%Us%" SET Nam_fol=%PD%&GOTO jump
GOTO jump  

:Yes_Bm1
SET I_Us=N
SET I_PD=N
:: ma byt prave zpracovana slozka "Users/ProgramData"?
IF "%Nam_fol%" == "%Us%" SET I_Us=Y&GOTO jump
IF "%Nam_fol%" == "%PD%" SET I_PD=Y&GOTO jump
GOTO jump

:jump
SET Adr_after=after_jump
GOTO kernel

:after_jump
:: rezim "Bm"?
IF %I_mod% == Bm GOTO Yes_Bm2
:: pokud byla zpracovana "normalni-obycejna" slozka, ktera nepatri
:: do "tandemu Users/ProgramData", prace skonci
IF %I_UP% == X GOTO finn
IF %I_UP% == N GOTO fin_UP
:: protoze ale byla prave zpracovana slozka "ProgramData", bude nyni
:: zpracovana druha slozka z "tandemu", tedy "Users" a prace pak skonci
SET I_UP=N
SET Nam_fol=%Us%
GOTO jump

:fin_UP
:: zpracovani "junction" slozek "Users/ProgramData"
SET err_UP=N
CALL :rendel_UP err_UP
IF %err_UP% == Y CALL :err_tak_own "%I_r%Users/ProgramData" F&GOTO finn
GOTO finn

:Yes_Bm2
:: - byla zpracovana "normalni-obycejna" slozka nebo slozka z "tandemu"
::   "Users/ProgramData"
:: - po zpracovani "tandemu" slozek prace skonci
IF %I_Us% == Y IF %I_PD% == Y GOTO finn
:: pokud byla prave zpracovana slozka "Users/ProgramData", bude zamenen
:: nazev slozky a zpracovana druha slozka z "tandemu"
IF "%Nam_fol%" == "%Us%" SET Nam_fol=%PD%&SET I_PD=Y&GOTO jump
IF "%Nam_fol%" == "%PD%" SET Nam_fol=%Us%&SET I_Us=Y&GOTO jump
GOTO finn

:: simulovana subroutine "kernel" (zpetna adresa ulozena)
:: ******************************************************
:: vstupni parametry: cesta ke slozce
:: vystupni parametry:
::
:kernel
:: "normalni"/"back" rezim (rezim "Sm" je zpracovavan jinde)?
:: rozskok podle "Nm/Bm"
GOTO %I_mod%_mode

:: **************************************************
:: "normalni" rezim *********************************
:: **************************************************
:Nm_mode
:: nastaveni casti cest
CALL :Ws32w_ini "%Nam_fol:"=%"
:: diverzifikace slozky "config", pokud zatim nebyla na vystup premistena
CALL :att_exi Ff "%O_r%%F_xy%Windows\System32\config" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%Windows\System32\config" F
IF NOT %NI_ER% == NI GOTO OK_conf_out
CALL :copy_conf all
IF %I_err% == Y GOTO finn
GOTO OK_conf_out

:OK_conf_out
:: filtr zpracovani slozek v prostredi OS WXP
IF NOT %I_OS% == WXP GOTO OK_OSn_NO_WXP
IF "%Nam_fol%" == %DaS% GOTO OK_OSn
IF "%Nam_fol%" == %PF% GOTO OK_OSn
IF "%Nam_fol%" == "%Pr%" GOTO OK_OSn
IF "%Nam_fol%" == "%SD%" GOTO OK_OSn
IF "%Nam_fol%" == "%Te%" GOTO OK_OSn
IF "%Nam_fol%" == "%oo%" GOTO OK_OSn
IF "%Nam_fol%" == "%wb%" GOTO OK_OSn
IF "%Nam_fol%" == "config" GOTO OK_OSn
IF "%Nam_fol%" == "config_new" GOTO OK_OSn
IF "%Nam_fol%" == "config_old" GOTO OK_OSn
GOTO all_con_err

:OK_OSn_NO_WXP
IF NOT "%Nam_fol%" == %DaS% GOTO OK_OSN
GOTO OK_OSnDas 

:OK_OSnDas
:: zpracovavani "DaS"
CALL :att_exi Ff "%O_r%%F_xy%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%%Nam_fol%" F
IF NOT %NI_ER% == NI GOTO err_fol_DaS
:: specialne vytvorena "vnejsi junction" pouze pro "DaS"
MKLINK "%O_r%%F_xy%%Nam_fol%" "%X_m%%F_xy%Users" /J %stream%
IF %ERRORLEVEL% == 0 GOTO OK_tarDaS
CALL :warerr_targ "Users" "%X_m%%F_xy%" n
GOTO folder_nextN

:OK_tarDaS
:: "uklid", ziskani prav vstupu a jejich premisteni na vystup
CALL :TO_law "%I_r%%Nam_fol%" s - - J %I_err_taow%
IF %I_err_taow% == Y CALL :err_tak_own "%I_r%%Nam_fol%" F&GOTO all_con_err
CALL :TO_law "%O_r%%F_xy%%Nam_fol%" r - - J %I_err_taow%
IF %I_err_taow% == Y CALL :err_tak_own "%O_r%%F_xy%%Nam_fol%" F&GOTO all_con_err
ECHO.
ECHO *** Folder "%Nam_fol%" - "normal" mode:
ECHO     - in the repository "%O_r%%F_xy%" was establishing a "junction" with the name
ECHO       "%Nam_fol%", pointing to the partition %vol_O_r% ("%X_m:~0,3%")
ECHO.
GOTO folder_nextN

:err_fol_DaS
ECHO.
ECHO *** Warning: input folder "%I_r%%Nam_fol%", 
ECHO              in the OS different from WXP had been processed, 
ECHO              see folder "%O_r%%F_xy%%Nam_fol%"
GOTO folder_nextN

:OK_OSN
IF %I_all% == all GOTO con_queN
:: diverzifikace samostatne slozky "config"
IF "%Nam_fol%" == "config" SET Nx=new&GOTO YES_confN
IF "%Nam_fol%" == "config_new" SET Nx=new&GOTO YES_confN 
IF "%Nam_fol%" == "config_old" SET Nx=old&GOTO YES_confN
GOTO con_queN

:YES_confN
:: dulezite rozhodnuti uzivatele
CALL :copy_conf %Nx%
IF %I_err% == Y GOTO finn
GOTO folder_nextN

:con_queN
:: existuje "prejmenovana" slozka?
CALL :att_exi Ff "%I_r%%Ws32w%%Nam_fol%_%pismenko%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%Ws32w%%Nam_fol%_%pismenko%" F
IF %NI_ER% == NI GOTO NO_ex_ren
CALL :err_ren_del "%I_r%%Ws32w%%Nam_fol%_%pismenko%"
GOTO all_con_err

:NO_ex_ren
:: existuje vstupni slozka?
CALL :att_exi Ff "%I_r%%Ws32w%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%Ws32w%%Nam_fol%" F
IF NOT %NI_ER% == NI GOTO YES_ex_in
CALL :errwar_fol_in "%I_r%%Ws32w%%Nam_fol%"
GOTO all_con_err

:YES_ex_in
:: existuje na vystupu uz drive diverzifikovana slozka?
CALL :att_exi Ff "%O_r%%F_xy%%Ws32w%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%%Ws32w%%Nam_fol%" F
IF %NI_ER% == NI GOTO NO_ex_div_ouN
IF "%Nam_fol%" == "config" GOTO all_con_err
CALL :err_ren_del "%O_r%%F_xy%%Ws32w%%Nam_fol%"
GOTO all_con_err

:all_con_err
:folder_nextN
:: automaticke zpracovani?
IF %I_all% == all GOTO %Adr_after%
GOTO finn

:NO_ex_div_ouN
:: - indikace zpracovani slozek "Users" nebo "ProgramData" a testovani, zda je prave
::   zpracovavana slozka "ProgramData"
:: - pokud ano, bude nastavena jeji "viditelnost" 
IF NOT "%Nam_fol%" == "%PD%" goto NO_CA1
CALL :att_exi SRh "%I_r%%Ws32w%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%Ws32w%%Nam_fol%" F
IF %NI_ER% == NI CALL :err_attrib "%I_r%%Ws32w%%Nam_fol%"
GOTO NO_CA1

:NO_CA1
:: je-li pouzit parametr "all", velikost potrebneho prostoru se uz netestuje
IF %I_all% == all GOTO NO_spaceN
CALL :test_size "%O_r:~0,3%" "%I_r%%Ws32w%%Nam_fol%" NenTC %DA_w% siz_OU siz_IN I_ts siz_ALL
IF %I_ts% == G GOTO NO_spaceN
IF %I_ts% == Eo CALL :err_tak_own "%O_r:~0,3%" F
IF %I_ts% == Ei CALL :err_tak_own "%I_r%%Ws32w%%Nam_fol%" F
IF %I_ts% == ER CALL :err_tak_own "%I_r%%Ws32w%%Nam_fol%" F
GOTO NO_spaceN

:NO_spaceN
:: spusteni "wait" smycky
CALL :flag_file_WD W rof %I_mut% %charYA% %wait_YN%
:: pred nazev slozky prijde "nazev oddilu_", prida se "_N.txt", znaky " "
:: se nahradi znakem "_" a odstraneni '"'
SET Nam_folw=%vol_I_r%_%Nam_fol%_N.txt
SET Nam_folw=%Nam_folw: =_%
ROBOCOPY "%I_r%%Ws32w%%Nam_fol%" "%O_r%%F_xy%%Ws32w%%Nam_fol%" %I_rob% /LOG:Log_%Nam_folw:"=% %stream%
SET err_l=%ERRORLEVEL%
:: ukonceni "wait" smycky
CALL :flag_file_WD D rof %I_mut% %charYA% %wait_YN%
IF %err_l% GEQ 10 GOTO :err_robo
IF %I_OS% == WXP GOTO NO_coll_UP
:: - "sesbirani" a vytvoreni vnitrnich "junction" slozek "Users/ProgramData"
::   (tyka se i jejich odstraneni v pripade parametru "r"), bude provedeno az
::   teprve tehdy, jakmile obe slozky budou zpracovane
:: - zpracovavaji se vzdy v tandemu, i kdyz je pozadovano zpracovani jen
::   jedne z nich
IF "%Nam_fol%" == "%Us%" GOTO NO_coll_UP
IF "%Nam_fol%" == "%PD%" GOTO NO_coll_UP
CALL :collect_jun "%I_r%%Ws32w%%Nam_fol%" "%Nam_fol%" %O_r:~0,3% %X_m:~0,3% %I_err_taow%
IF %I_err_taow% == Y GOTO all_con_err
GOTO NO_coll_UP

:NO_coll_UP
:: prejmenovani/odstraneni slozek po diverzifikaci 
IF %I_ope% == c GOTO ren_fol
IF "%Nam_fol%" == "%Us%" GOTO ren_fol
IF "%Nam_fol%" == "%PD%" GOTO ren_fol
IF %I_ope% == r GOTO del_fol
GOTO finn

:ren_fol
SET I_txtfin=renamed to
:: prejmenovani vstupni slozky
REN "%I_r%%Ws32w%%Nam_fol%" "%Nam_fol%_%pismenko%" %stream%
GOTO yes_ren_del

:del_fol
:: odstraneni vstupni slozky
SET I_txtfin=removed
RD /S /Q "%I_r%%Ws32w%%Nam_fol%" %stream%
GOTO yes_ren_del

:yes_ren_del
:: vytvoreni "junction" na diverzifikovanou slozku
MKLINK "%I_mr%%Ws32w%%Nam_fol%" "%X_m%%F_xy%%Ws32w%%Nam_fol%" /J %stream%
IF %ERRORLEVEL% == 0 GOTO OK_targNm
CALL :warerr_targ "%Nam_fol%" "%X_m%%F_xy%%Ws32w%" n
IF %I_all% == all GOTO %Adr_after%
GOTO finn

:OK_targNm
:: v pripade slozky "ProgramData" bude nastavena "neviditelnost" pro vystupni
:: i vstupni (uz prejmenovanou), slozku
IF NOT "%Nam_fol%" == "%PD%" GOTO NO_CA2
CALL :att_exi SSh "%O_r%%F_xy%%Ws32w%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%%Ws32w%%Nam_fol%" F
IF %NI_ER% == NI CALL :err_attrib "%O_r%%F_xy%%Ws32w%%Nam_fol%"
IF %I_ope% == r GOTO NO_CA2
CALL :att_exi SSh "%I_r%%Ws32w%%Nam_fol%_%pismenko%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%Ws32w%%Nam_fol%_%pismenko%" F
IF %NI_ER% == NI CALL :err_attrib "%I_r%%Ws32w%%Nam_fol%_%pismenko%"
GOTO NO_CA2

:NO_CA2
:: oznameni o odstraneni/prejmenovani diverzifikovane slozky
ECHO.
ECHO *** Folder "%Nam_fol%" - "normal" mode:
ECHO     - to folder "%Nam_fol%", which was diversified
ECHO       into storage "%O_r%%F_xy%%Ws32W%", was in the folder
ECHO       "%I_m%%Ws32W%" created "junction" with the same name
ECHO       "%Nam_fol%", pointing to the partition %vol_O_r% ("%X_m:~0,3%")
ECHO     - system Folder "%I_r%%Ws32W%%Nam_fol%" then was %I_txtfin%
IF %I_ope% == c ECHO       "%Nam_fol%_%pismenko%"
GOTO %Adr_after%

:: *************************************************
:: "back" rezim ************************************
:: *************************************************
:Bm_mode
:: odstraneni '"'
SET Nam_fol=%Nam_fol:"=%
:: nastaveni casti cest a filtr zpracovani slozek v prostredi OS WXP
CALL :Ws32w_ini "%Nam_fol:"=%"
IF NOT %I_OS% == WXP GOTO OK_OSbNO_WXP
IF "%Nam_fol%" == %DaS% GOTO OK_OSb
IF "%Nam_fol%" == %PF% GOTO OK_OSb
IF "%Nam_fol%" == "%Pr%" GOTO OK_OSb
IF "%Nam_fol%" == "%SD%" GOTO OK_OSb
IF "%Nam_fol%" == "%Te%" GOTO OK_OSb
IF "%Nam_fol%" == "%oo%" GOTO OK_OSb
IF "%Nam_fol%" == "%wb%" GOTO OK_OSb
IF "%Nam_fol%" == "config" GOTO OK_OSb
IF "%Nam_fol%" == "config_new" GOTO OK_OSb
IF "%Nam_fol%" == "config_old" GOTO OK_OSb
GOTO folder_nextB

:OK_OSbNO_WXP
IF NOT "%Nam_fol%" == %DaS% GOTO OK_OSb
:: specialni vystup pouze pro "DaS"
ECHO.
ECHO *** Warning: folder "%O_r%%F_xy%%Nam_fol%" - his return was not
ECHO              in the OS different from the "WXP" processed (folder
ECHO              "%I_r%%Nam_fol%" in the OS %vol_I_r% has not changed)
GOTO folder_nextB

:OK_OSb
SET I_ren=N
IF %I_all% == all GOTO con_queB
:: bezna diverzifikace slozky "config"
IF "%Nam_fol%" == "config" SET Bx=new&GOTO YES_confB 
IF "%Nam_fol%" == "config_new" SET Bx=new&GOTO YES_confB 
IF "%Nam_fol%" == "config_old" SET Bx=old&GOTO YES_confB
GOTO con_queB

:YES_confB
:: zavazne rozhodnuti uzivatele ohledne "config"
CALL :copy_conf %Bx%
IF %I_err% == Y GOTO finn
GOTO folder_nextB

:con_queB
:: posledni slozka "config" ze seznamu "normalnich" slozek?
IF "%Nam_fol%" == "config" GOTO yes_confauto
:: pokud v puvodnim ulozisti existuje vystupni slozka, predpoklada se (ale proveri
:: se to), zda je typu "junction"
CALL :att_exi Ff "%I_r%%Ws32w%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == OK GOTO exist_out
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%Ws32w%%Nam_fol%" F
IF NOT %NI_ER% == NI GOTO exist_out
CALL :warerr_fol_out "%I_r%%Ws32w%%Nam_fol%" "junction" "was not found"
GOTO folder_nextB

:exist_out
:: - nejprve se testuje existence slozky 
:: - pokud slozka je typu "repairs point" a zaroven jde o "Documents and Settings"
::   a pracuje se v prostredi OS WXP, bude slozka zpracovana jako jine slozky
:: - pokud toto neplati a zaroven plati, ze slozka neni typu "repairs point", je
::   prace ukoncena pro hrubou chybu
:: - takze je typu "repairs point", je odstranena a pokud existuje prejmenovana, je
::   prejmenovana na puvodni nazev nebo bude zpetne diverzifikovana slozka
::   z uloziste "Data_Jun\F_?"
CALL :att_exi Fl "%I_r%%Ws32w%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%Ws32w%%Nam_fol%" F
IF %NI_ER% == NI CALL :err_attrib "%I_r%%Ws32w%%Nam_fol%"
IF %str_att% == l IF "%Nam_fol%" == %DaS% IF %I_OS% == WXP GOTO DaS_nextB 
IF NOT %str_att% == l CALL :err_repairs&GOTO finn
GOTO DaS_nextB

:DaS_nextB
RD /S /Q "%I_r%%Ws32w%%Nam_fol%" %stream%
CALL :att_exi Ff "%I_r%%Ws32w%%Nam_fol%_%pismenko%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%Ws32w%%Nam_fol%_%pismenko%" F
IF NOT %NI_ER%  == NI GOTO exist_ren
CALL :warerr_fol_out "%I_r%%Ws32w%%Nam_fol%_%pismenko%" "normal" "was not found"
GOTO copy_back

:exist_ren
SET I_ren=Y
:: pro prejmenovani slozky "ProgramData" musi byt nastavena "viditelnost" 
IF NOT "%Nam_fol%" == "%PD%" goto NO_CA3
CALL :att_exi SRh "%I_r%%Ws32w%%Nam_fol%_%pismenko%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%Ws32w%%Nam_fol%_%pismenko%" F
IF %NI_ER% == NI CALL :err_attrib "%I_r%%Ws32w%%Nam_fol%_%pismenko%"
GOTO NO_CA3

:NO_CA3
REN "%I_r%%Ws32w%%Nam_fol%_%pismenko%" "%Nam_fol%" %stream%
:: pro slozku "ProgramData" bude zpetne nastavena "neviditelnost"
IF NOT "%Nam_fol%" == "%PD%" goto NO_CA4
CALL :att_exi SSh "%I_r%%Ws32w%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%Ws32w%%Nam_fol%_%pismenko%" F
IF %NI_ER% == NI CALL :err_attrib "%I_r%%Ws32w%%Nam_fol%"
GOTO NO_CA4

:NO_CA4
:: zvyseni citace navracenych slozek pomoci "prejmenovani" 
CALL :Math_A %f_ren_cop% 1 f_ren_cop 0 0
ECHO.
ECHO *** Folder "%Nam_fol%" - "back" mode:
ECHO     - the folder was backward "diversified" simply renaming
ECHO       the original name
GOTO folder_nextB

:copy_back
:: existuje vstupni slozka?
CALL :att_exi Ff "%O_r%%F_xy%%Ws32w%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%%Ws32w%%Nam_fol%" F
IF NOT %NI_ER%  == NI GOTO YES_ex_inB
CALL :errwar_fol_in "%O_r%%F_xy%%Ws32w%%Nam_fol%"
IF %I_ren% == Y GOTO OK_next
ECHO.
ECHO *** Error: - severe error in "back" mode - there does not exist
ECHO              the original renamed or input folder, so the folder
ECHO              "%I_r%%Ws32W%%Nam_fol%" (%vol_I_r%)
ECHO              it was not possible to reinstate
CALL :tot_ex

:OK_next
ECHO.
ECHO *** Warning: - although there is no input folder 
ECHO                "%O_r%%F_xy%%Ws32W%%Nam_fol%" (%vol_O_r%) 
ECHO                (severe problem), but there is available original one,
ECHO                so retroactively renaming may save the state  
ECHO              - may/may not occur intrusion OS synchronization 
ECHO                with the "Registry" (desynchronization
ECHO                occured with high probability), it's just about saving
GOTO folder_nextB

:YES_ex_inB
:: pro zpracovani slozky "ProgramData" musi byt nastavena "viditelnost"
IF NOT "%Nam_fol%" == "%PD%" goto NO_CA5
CALL :att_exi SSh "%I_r%%Ws32w%%Nam_fol%" out_NUL NI_ER
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%Ws32w%%Nam_fol%" F
GOTO NO_CA5

:NO_CA5
:: pokud je pouzit parametr "all", velikost potrebneho prostoru se uz netestuje
IF %I_all% == all GOTO NO_spaceB
CALL :test_size "%I_r%" "%O_r%%F_xy%%Ws32w%%Nam_fol%" NenTC %DA_w% siz_OU siz_IN I_ts siz_ALL
:: parametr "e" zajisti ukonceni prace, pokud by prostor pro slozku nebyl dostatecny
IF %I_ts% == G GOTO NO_spaceB
IF %I_ts% == Eo CALL :err_tak_own "%I_r%" F
IF %I_ts% == Ei CALL :err_tak_own "%O_r%%F_xy%%Ws32w%%Nam_fol%" F
IF %I_ts% == ER CALL :err_tak_own "%O_r%%F_xy%%Ws32w%%Nam_fol%" F
GOTO NO_spaceB

:NO_spaceB
:: spusteni "wait" smycky
CALL :flag_file_WD W rof %I_mut% %charYA% %wait_YN%
:: pred nazev slozky prijde "nazev oddilu_", prida se "_B.txt", znaky " " se nahradi znakem
:: "_" a odstraneni '"'
SET Nam_folw=%vol_O_r%_%Nam_fol%_B.txt
SET Nam_folw=%Nam_folw: =_%
ROBOCOPY "%O_r%%F_xy%%Ws32w%%Nam_fol%" "%I_r%%Ws32w%%Nam_fol%" %I_rob% /LOG:Log_%Nam_folw:"=% %stream%
SET err_l=%ERRORLEVEL%
:: ukonceni "wait" smycky
CALL :flag_file_WD D rof %I_mut% %charYA% %wait_YN%
IF %err_l% GEQ 10 GOTO :err_robo
:: zvyseni citace zpetne diverzifikovanych slozek
CALL :Math_A %f_ren% 1 f_ren 0 0
IF %I_OS% == WXP GOTO WXP_NO_col_junB
:: pro zpracovani slozky "ProgramData" bude nastavena "viditelnost"
IF NOT "%Nam_fol%" == "%PD%" goto NO_CA6
CALL :att_exi SRh "%O_r%%F_xy%%Ws32w%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%%Ws32w%%Nam_fol%" F
IF %NI_ER% == NI CALL :err_attrib "%O_r%%F_xy%%Ws32w%%Nam_fol%"
GOTO NO_CA6

:NO_CA6
:: "sesbirani" a vytvoreni "junction" k libovolne slozce a v pripade zpracovani slozky
:: "ProgramData" bude zpetne nastavena "neviditelnost"
CALL :collect_jun "%O_r%%F_xy%%Ws32w%%Nam_fol%" "%Nam_fol%" %I_r:~0,3% %X_m:~0,3% %I_err_taow%
IF %I_err_taow% == Y GOTO finn
IF NOT "%Nam_fol%" == "%PD%" goto NO_CA7
CALL :att_exi SSh "%I_r%%Ws32w%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%Ws32w%%Nam_fol%" F
IF %NI_ER% == NI CALL :err_attrib "%I_r%%Ws32w%%Nam_fol%"
GOTO NO_CA7

:yes_confauto
:: test, zda pocet navracenych/prejmenovanych slozek je roven prislusnemu poctu slozek
:: a to i v ramci typu OS - vysledek bude mit vliv na moznost navraceni "Registry"
:: dany pocet - 12|13|14 - je dostatecny pro rozhodovani (mohou napr. chybet slozky
:: "sru" nebo "Program Files (x86)" nebo obe)
IF %f_ren% == 12 GOTO clone
IF %f_ren% == 13 GOTO clone
IF %f_ren% == 14 GOTO clone
IF %f_ren_cop% == 12 GOTO clone
IF %f_ren_cop% == 13 GOTO clone
IF %f_ren_cop% == 14 GOTO clone 
IF %I_OS% == WXP GOTO fol_wxp
GOTO NO_same_fol

:fol_wxp
IF %f_ren% == 6 GOTO clone
IF %f_ren% == 7 GOTO clone
IF NOT %f_ren_cop% == 6 GOTO clone
IF NOT %f_ren_cop% == 7 GOTO clone
GOTO NO_same_fol

:clone
ECHO.
:: slozka "config" pri automatickem zpracovani (posledni slozka seznamu
:: "normalnich" slozek)
ECHO *** Folder "config" - "back" mode:
ECHO     - regressive diversification folder "config_old" from the storage
ECHO       "%O_r%%F_xy%%Ws32W%" (%vol_O_r%) on the partition 
ECHO       %vol_I_r% with OS
ECHO     - authorization requires the user's responsibility:
ECHO       - this statement exists only, if the "normal" mode used
ECHO         the operation "c" and the parameter "all".
ECHO           Keeping all folders and renaming them in fact created
ECHO         favorable conditions for the eventual return of all these
ECHO         renamed system folders partitions (and currently did not 
ECHO         spare space on a partition with the OS)
ECHO       - if restoration "config" (original folder "config_old") allows,
ECHO         it returns to the state before the OS diversification (this 
ECHO         is actually a callback function clone and all "junction" will
ECHO         be re set by the original algorithm author)
ECHO     - in all other cases it is virtually certain, that the "Registry"
ECHO       with the OS are not synchronized and whatever folder "config" 
ECHO       restoration will/will not (under the mode "Bm" this possibility
ECHO       exists always), OS does/does not work properly (as one of 
ECHO       the last rescues may return of the "Registry" be done always)
CALL :any
SET I_OS_same=OK
CALL :copy_conf old
IF %I_err% == Y GOTO finn
GOTO :folder_nextB

:folder_nextB
:NO_CA7
:NO_same_fol
:WXP_NO_col_junB
GOTO %Adr_after%

:: ***********************************************
:: "zvlastni" rezim ******************************
:: ***********************************************
:S_mode
SET all_siz_o=0
SET all_siz_i=0
SET allo_w=0
SET I_err=N
:: odstraneni '"', odstraneni cesty az na oznaceni oddilu v zavislosti na tom, zda se
:: pracuje s celym oddilem (parametr "all"), oznaceni oddilu, test prace v prostredi
:: OS a eventualni vystup chyby
SET Nam_fol=%W_nam_fol:"=%
IF %I_all% == all SET "Nam_fol="
SET O_r=%O_r:~0,3%
SET X_m=%X_m:~0,3%
IF %I_envOS% == N GOTO NO_syst
IF /I NOT %O_r% == C:\ GOTO NO_out_syst
CALL :err_env
GOTO fin_orcd

:NO_out_syst
:NO_syst
:: operace: - "c" - neexistence vstupniho "objektu" je chyba, existence vystupniho take
::          - "r" - neexistence vstupniho "objektu" je chyba, u vystupniho jen upozorneni
::          - "d" - neexistence vystupniho "objektu" je chyba
:: rozskok podle "c/r/d"
GOTO ope_%I_ope%_Sm

:ope_c_Sm
:: pokud existuje parametr "all" (operace se tyka oddilu), test existence se neprovadi,
:: jinak testovani existence vstupni slozky
IF %I_all% == all GOTO fin_ope_c
CALL :att_exi Ff "%I_r%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == OK GOTO next_test1
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%Nam_fol%" F
IF %NI_ER% == NI CALL :errwar_fol_in "%I_r%%Nam_fol%"&GOTO err_IO
GOTO next_test1

:next_test1
:: existence vystupni slozky
CALL :att_exi Ff "%O_r%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == OK CALL :warerr_fol_out "%O_r%%Nam_fol%" "common" "already exist"&GOTO err_IO
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%Nam_fol%" F
IF NOT %NI_ER% == NI CALL :warerr_fol_out "%O_r%%Nam_fol%" "common" "already exist"&GOTO err_IO
GOTO fin_ope_c

:ope_r_Sm
:: pokud existuje parametr "all" (operace se tyka oddilu), test existence se neprovadi,
:: jinak testovani existence vstupni slozky
IF %I_all% == all GOTO YES_r_all
CALL :att_exi Ff "%I_r%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == OK GOTO next_test2
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%Nam_fol%" F
IF %NI_ER% == NI CALL :errwar_fol_in "%I_r%%Nam_fol%"&GOTO err_IO
GOTO next_test2

:next_test2
:: existence vystupni slozky a test, zda vystupni slozka existuje (aby mohla byt odstranena)
CALL :att_exi Ff "%O_r%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == OK GOTO next_test3
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%Nam_fol%" F
SET I_out_obj=Y
IF %NI_ER% == NI CALL :warerr_fol_out "%O_r%%Nam_fol%" "common" "was not found"&SET I_out_obj=N
:: a v tomto pripade se provede uz jen kopirovani
GOTO fin_ope_c

:next_test3
GOTO fin_ope_r

:ope_d_Sm
:: pokud existuje parametr "all" (operace se tyka oddilu), test existence se neprovadi,
:: jinak testovani existence vystupni slozky
IF %I_all% == all GOTO fin_ope_d
CALL :att_exi Ff "%O_r%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == NI CALL :warerr_fol_out "%O_r%%Nam_fol%" "common" "was not found"&GOTO err_IO
IF %NI_ER% == OK GOTO next_test4
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%Nam_fol%" F
GOTO next_test4

:next_test4
GOTO fin_ope_d

:fin_ope_d
:: odstraneni "objektu"
:: ********************
CALL :oped
GOTO fin_dc

:fin_ope_r
:: diverzifikace "objektu" spojena s odstranenim puvodniho "objektu"
:: *****************************************************************
:: pri praci se slozkou/souborem bude provedena kontrola potrebneho
:: prostoru: - velikost volneho prostoru bude zvysena o obsazenost
::             "objektu" tehoz nazvu, pokud ovsem takovy "objekt"
::             existuje
::           - neexistuje-li, bude tam zalozen s nulovou velikosti
CALL :att_exi Ff "%O_r%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%Nam_fol%" F
IF NOT %NI_ER% == NI GOTO NO_mkd
IF %I_out_obj% == N MKDIR "%O_r%%Nam_fol%" %stream%
GOTO NO_mkd

:NO_mkd
:YES_r_all
:: odstraneni a diverzifikace "objektu"
:: ************************************
CALL :oped
IF %I_err% == Y GOTO fin_dc
GOTO fin_ope_c

:fin_ope_c
:: diverzifikace "objektu"
:: ***********************
:: velikost volneho prostoru vs obsazenost - cesta az na oznaceni oddilu je odstranena
CALL :test_size "%O_r%" "%I_r%%Nam_fol%" NinTC %DA_w% siz_OU siz_IN I_ts all_siz
IF %I_ts% == G GOTO next_test5
IF %I_ts% == Eo CALL :err_tak_own "%O_r%" F
IF %I_ts% == Ei CALL :err_tak_own "%I_r%%Nam_fol%" F
IF %I_ts% == ER CALL :err_tak_own "%I_r%%Nam_fol%" F
GOTO next_test5

:next_test5
CALL :opec
GOTO fin_dc

:err_IO
GOTO fin_dc

:fin_dc
:fin_orcd
GOTO finn

:: **************************************************************************
::   skupina subroutine (a internich subroutine) pro modul "Diver_sysFol"
:: **************************************************************************

:: subroutine "sea_vol"
:: *******************
:: hledani nazvu vsech oddilu nebo jednoho podle jeho pismena
:: **********************************************************
:: vstupni parametry: - all/one - pocet vypisu
::                    - oznaceni oddilu
:: vystupni parametry: nazev oddilu
::
:sea_vol
SET vol_mark=%2
:: identifikace oddilu a odstraneni "\"
SET w_v_m=%vol_mark%
SET vol_mark=%vol_mark:~0,2%
SET "v_w="
FOR /F "delims=[]" %%x IN ('vol %vol_mark% 2^>NUL') DO (
  CALL :sea_vol_encz %1 "%%x" %w_v_m% v_w
)
SET %3=%v_w%
GOTO :eof

:: interni subroutine "sea_vol_encz"
:: *********************************
:: hledani nazvu oddilu s ohledem na mutaci "en/cz" processoru "cmd.exe"
:: *********************************************************************
:: vstupni parametry: - one/all - pocet vypisu
::                    - retezec obsahujici nazev oddilu
::                    - oznaceni oddilu   
:: vystupni parametry: nazev existujiciho oddilu
::
:sea_vol_encz
:: odstraneni '"'
SET line=%~2
:: test mutace "en/cz" - Volume .../Svazek ... a vyber nazvu oddilu nebo
:: vyber nazvu oddilu a odstraneni "."
IF /I NOT "%line:Volume in drive=%" == "%line%" (
    SET %4="%line:~22%"
    GOTO vol_ao
) ELSE ( 
    IF /I NOT "%line:Svazek v jednotce=%" == "%line%" (
    SET %4="%line:~24,-1%"
    GOTO vol_ao
)
)
GOTO NO_encz

:: podmineny zapis do souboru
:vol_ao
IF %1 == all ECHO    - "%3" =^> !%4! >> "fipa_%pismenko%.txt"
GOTO NO_encz

:NO_encz
GOTO :eof

:: subroutine "pure"
:: *****************
:: odstraneni a filtrovani vstupnich parametru (znaky "():," a znak '"'
:: ********************************************************************
:: vstupni parametry: - hodnota parametru
::                    - cislo parametru   
:: vystupni parametry:
::
:pure
SET I_err=N
SET pw=%~1
IF "%pw%" == "" GOTO fin_pure
SET pw=%pw:(=%
IF "%pw%" == "" GOTO fin_pure
SET pw=%pw:)=%
IF "%pw%" == "" GOTO fin_pure
SET pw=%pw::=%
IF "%pw%" == "" GOTO fin_pure
SET pw=%pw:,=%
IF "%pw%" == "" GOTO fin_pure
SET pww=%pw%
:: kontroly znaku parametru 1-4, 6 (7)
SET n_ch=0
GOTO c_ch123467

:c_ch123467
IF NOT %n_ch% == 256 GOTO OK_ch1234671
CALL :err_n_ch
GOTO err_ch_all

:OK_ch1234671
SET I_ch=""
:: vyber nejlevejsiho znaku a jeho odstraneni z bufferu
SET lc=%pw:~0,1%
SET pw=%pw:~1%
IF "%lc%" == " " GOTO NO_test_c
FOR %%x IN (%all_c%) DO (IF %lc% == %%x SET I_ch=%%x&GOTO fin_forPU)

:fin_forPU
IF NOT %I_ch% == "" GOTO OK_ch1234672
CALL :err_ch %2
GOTO err_ch_all

:NO_test_c
:OK_ch1234672
CALL :Math_A %n_ch% 1 n_ch 0 0
:: dalsi znak?
IF NOT "%pw%" == "" GOTO c_ch123467
GOTO fin_pure_w

:fin_pure
SET pww=?
GOTO fin_pure_w

:err_ch_all
SET I_err=Y
GOTO fin_pure_w

:fin_pure_w
GOTO :eof

:: subroutine "any"
:: ****************
:: zpracovani vstupu obsluhy pri potvrzovacich dotazech
:: ****************************************************
:: vstupni parametry:
:: vystupni parametry:
:: pozn.: umisteni jazykove mutace dotazu pro vypis
::        vzdy upravovat opatrne
::
:any
:: rozskok podle "en/cz"
ECHO.
GOTO mut_%I_mut%

:mut_en
ECHO *** Continue? ***********************************
ECHO     No:  "Ctrl C", letter "%YA% | N|n" and "Enter"
ECHO     Yes: "Enter" or any letter
GOTO mut_all

:mut_cz
ECHO *** Pokracovat? *******************************
ECHO     Ne: "Ctrl C", pismeno "%YA% | N|n" a "Enter"
ECHO     Ano: "Enter" nebo libovolne pismeno
GOTO mut_all

:mut_all
ECHO %pause_w%
PAUSE>NUL
GOTO :eof

:: subroutine "Sm_que"
:: *******************
:: vystup kombinovaneho dotazu pro praci v "Sm" rezimu
:: ***************************************************
:: vstupni parametry: - nazev oddilu vstupu
::                    - oznaceni oddilu vstupu
::                    - operace 
::                    - nazev oddilu vystupu
::                    - oznaceni oddilu vystupu
:: vystupni parametry:
::
:Sm_que
ECHO.
SET par45= na oddil %4 %5
ECHO *** Prace s oddilem  - "zvlastni" rezim:
ECHO     povolit %3 obsahu celeho oddilu 
IF %3 == diverzifikaci GOTO Yes_copy
IF %3 == odstraneni GOTO Yes_del
ECHO     %1 %2 obsahem oddilu %4 %5
GOTO Yes_any

:Yes_del
SET "par45="
GOTO YES_copy

:Yes_copy
ECHO     %1 %2%par45%
GOTO YES_any

:YES_any 
CALL :any
GOTO :eof

:: subroutine "ex_NTFS"
:: ********************
:: testovani existence FS "NTFS" na oddilech vstupujicich do operace
:: *****************************************************************
:: vstupni parametry: - oznaceni oddilu
::                    - typ oddilu ("I/O/X" - je pouzito cislo 1-3)
:: vystupni parametry:
::
:ex_NTFS
:: chyba se predpoklada a zvlastni pouziti parametru - je vstupnim
:: i vystupnim parametrem a je volan hodnotou nikoliv jmenem
SET I_err=Y
SET I_errw=E
SET lett_w=%1
SET lett_code=%2
SET "vol_w="
FOR /F "tokens=2-7 skip=8 usebackq" %%i IN ("lisp_%pismenko%.txt") DO (
  CALL :part_NTFS %%i %%j %%k %%l %%m %%n %2 vol_w %I_errw%
)
IF %I_err% == N GOTO OK_NTFS

:: rozskok podle "E/D/P/F"
GOTO err_%I_errw%

:err_E
:err_D
:err_P
CALL :err_NOex_part%lett_code%
GOTO fin_NTFS

:err_F
CALL :err_NTFS%lett_code%
GOTO fin_NTFS

:OK_NTFS
:: pokus o odstraneni a nasledne zalozeni slozky
RD /S /Q "%lett_w%_%pismenko%" %stream%
MKDIR "%lett_w%_%pismenko%" %stream%
IF NOT ERRORLEVEL 1 GOTO fin_NTFS
CALL :err_NOex_part%lett_code%
GOTO fin_NTFS

:fin_NTFS
:: odstraneni slozky
RD /S /Q "%lett_w%_%pismenko%" %stream%
GOTO :eof
 
:: interni subroutine "part_NTFS"
:: ******************************
:: testovani existence a pripadne stavu oddilu
:: *******************************************
:: vstupni parametry: - cislo oddilu
::                    - pismeno oddilu
::                    - hledany nazev oddilu
::                      (u DVD-ROM, ktery je
::                      bez media, se pouziji
::                      pouze prvni tri
::                      parametry)
::                    - typ FS
::                    - typ oddilu
::                    - velikost (pouzita, jen
::                      kdyz nazev oddilu
::                      obsahuje " ")
::                    - typ oddilu
:: vystupni parametry: - nazev oddilu
::                     - chyba - zvlastni
::                       pouziti parametru, je
::                       vstupni/vystupni
::
:part_NTFS
SET w_na_w=%3
SET w_na=%3 %4
SET w_FS=%4
SET w_typp=%5
SET I_ew=%9
IF "%4" == "NTFS" GOTO OK_part_n
IF "%4" == "FAT32" GOTO OK_part_n
IF "%4" == "" GOTO OK_part_n
:: nestandardni obsluha nazvu oddilu, pokud obsahuje mezeru (uz vyse se
:: provedlo slozeni nazvu oddilu, pokud obsahoval " " a jeste se provede
:: presun dvou promennych)
SET w_FS=%5
SET w_typp=%6
GOTO OK_part_n

:OK_part_n
:: specialni testovani oddilu, ktery nema nazev 
IF /I "%9" == "" GOTO NO_lett
IF /I NOT "%9" == "E" GOTO NO_lett
SET PR_OV=%w_typp%
SET PR_OV=%PR_OV:~0,3%
IF /I NOT %lett_w% == %2:\ GOTO NO_lett
:: testovani existence a typu:
:: - zvlastni pripady jsou oddil bez nazvu a "DVD-ROM" bez media
:: - v pripade periferie "DVD-ROM" neexistuji polozky "Label" a "Fs",
::   proto je umistena uz v promenne %3
SET I_ew=D
IF /I "%w_na_w%" == "DVD-ROM" GOTO NO_lett
SET I_ew=F
IF /I NOT "%w_FS%" == "NTFS" GOTO NO_NTFS
:: zpracovani je nutne provest v obou mutacich (Partition vs Oddil,
:: Removable vs Vymenitelne)
SET I_ew=P
IF /I NOT "%PR_OV%" == "Par" GOTO NO_lettP 
GOTO Yes_part

:NO_lettP
IF /I NOT "%PR_OV%" == "Rem" GOTO NO_lettR
GOTO Yes_part

:NO_lettR
IF /I NOT "%PR_OV%" == "Odd" GOTO NO_lettO
GOTO Yes_part

:NO_lettO
IF /I NOT "%PR_OV%" == "Vym" GOTO NO_lettV
GOTO Yes_part

:NO_lettV
GOTO NO_lett

:NO_NTFS
IF /I NOT "%w_FS%" == "FAT32" GOTO NO_lett
GOTO Yes_part 

:Yes_part
:: shozeni priznaku chyby
SET I_err=N
SET %8=%w_na%
SET %9=%I_ew%
GOTO NO_lett

:NO_lett
GOTO :eof

:: subroutine "exist_OS"
:: *********************
:: testovani existence OS a status, zda se pracuje pro OS WXP nebo jine 
:: ********************************************************************
:: vstupni parametry: - oznaceni oddilu (uloziste)
::                    - nazev oddilu vstupu/vystupu
:: vystupni parametry: nastaveni typu OS
::
:exist_OS
SET I_OSex=%~1
SET I_err=N
SET I_OSw=NO_WXP
:: pocet slozek k diverzifikaci v OS ruznem od WXP
SET N_fol=14
CALL :att_exi Ff "%I_OSex%Windows\System32\config\systemprofile" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_OSex%Windows\System32\config\systemprofile" F
IF NOT %NI_ER% == NI GOTO ex_OS
ECHO.
ECHO *** Error: in "%2" does not exist:
ECHO            - folder "config"
ECHO            - OS or storage "%I_r%Windows\System32\config\systemprofile"
ECHO            - or be found there blunders in FS
GOTO set_I_err

:ex_OS
CALL :att_exi Ff "%I_OSex%Windows\System32\config\systemprofile\AppData" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_OSex%Windows\System32\config\systemprofile\AppData" F
IF NOT %NI_ER%  == NI GOTO set_bib_OS
SET I_OSw=WXP
:: pocet slozek k diverzifikaci v OS typu WXP
SET N_fol=7
GOTO set_bib_OS

:set_bib_OS
IF %I_OSw% == WXP GOTO set_WXP
IF %I_OSw% == NO_WXP GOTO set_NO_WXP
GOTO set_I_err

:set_I_err
SET I_err=Y
GOTO set_fin

:: nastaveni seznamu existujicich slozek podle typu OS ("OS_WXP/OS_NO_WXP")
:set_WXP
SET auth_OS=%auth_OS_WXP%
SET auth_win=%auth_win_WXP%
SET auth_s32=%auth_s32_WXP%
GOTO set_fin

:set_NO_WXP
SET auth_OS=%auth_OS_NO_WXP%
SET auth_win=%auth_win_NO_WXP%
SET auth_s32=%auth_s32_NO_WXP%
GOTO set_fin

:set_fin
SET %3=%I_OSw%
GOTO :eof

:: subroutine "Ws32w_ini"
:: **********************
:: nastaveni casti cesty pro slozky umistene uvnitr slozky "Windows"
:: *****************************************************************
:: vstupni parametry: nazev slozky
:: vystupni parametry:
::
:Ws32w_ini
SET "Ws32w="
:: nazev slozky bude "obalen" znaky '"', obsahuje-li " "
SET Nam_fol=%~1
IF NOT "%Nam_fol: =%" == "%Nam_fol%" SET Nam_fol="%Nam_fol%"
:: nastaveni casti cesty, pokud slozky jsou umistene ve "Windows\System32\"
:: nebo ve "Windows\"
FOR %%x IN (%auth_s32%) DO (IF %Nam_fol% == %%x SET Ws32w=Windows\System32\)
FOR %%x IN (%auth_win%) DO (IF %Nam_fol% == %%x SET Ws32w=Windows\)
:: odstraneni '"'
SET Nam_fol=%Nam_fol:"=%
GOTO :eof

:: interni subroutine "att_exi"
:: ****************************
:: operace "Fxy" a "Sxy" pracuji s atributy "objektu" (slozka/soubor), "CA" prenasi
:: atributy ze vstupniho "objektu" na vystupni
:: ********************************************************************************
:: vstupni parametry: - Ff - zjisteni vsech atributu vstupniho "objektu" nebo
::                      Fy - zjisteni jednoho atributu "y" vstupniho "objektu"
::                           (seznam nize, platny parametr je napr. "Fr" nebo
::                           "Fx", jinak je oznamena chyba "ER") nebo
::                      SS - kompletni "nastaveni" vsech atributu vystupniho
::                           "objektu" ("S"et) nebo 
::                      SC - "preklopeni" hodnot vsech atributu vystupniho
::                           "objektu" na opacnou ("C"hange) nebo
::                      SR - "shozeni" hodnot vsech atributu vystupniho "objektu"
::                           ("R"eset) nebo
::                      SSy/SCy/SRy ("S"et/"C"hange/"R"eset) - zpracovani jednoho
::                                                             atributu "y"
::                                                             (seznam nize) nebo
::                      CA - prenos atributu "r", "a", "h" a "s" ze vstupniho
::                           na vystupni "objekt"
::                    - nazev "objektu" - obvykle je to vstupni "objekt" (jinak
::                                        proste "objekt")
::                    - nazev vystupniho "objektu" - vyhradne pro "CA" (jinak
::                                                   nezajimavy parametr)
:: vystupni parametry: - OK
::                       OT - neexistuje "target"
::                       NI - indikace neexistence vstupniho "objektu" (neexistence
::                            je sofistikovane zjistovana specialnim pouzitim
::                            "ICACLS" a analyzou poctu a cest ke skrytym
::                            "objektum") nebo
::                       AC - "objekt" je vyuzivan jinym procesem nebo
::                       ER - chyba a okamzite ukonceni prace nebo
::                     - retezec: - vsechny atributy "objektu" ve tvaru:
:                                   "d|-r|-a|-h|-s|-c|-o|-t|-l|-n|-x|-" nebo 
::                                - jeden atribut ve tvaru: "d|-", "r|-", "a|-",
::                                  "h|-", "s|-" nebo "l|-" nebo
::                                - retezec atributu ve tvaru: "r|-a|-h|-s|-"
::                                  v pripade operace "CA"  
:: pozn.: - atributy a jejich poradi zajistuje prikaz "FOR", napr.:
::          FOR %%F IN (%nam_obj%) DO (SET att=%%~aF)
::        - promenne "Fd, Fr, Fa, Fh, Fs a Fl" jsou v subroutine "att_exi"
:_:         a "att_F_S_C" "globalnimi" promennymi
::        - pri operaci "CA" se kontroluje, zda "objekty" si odpovidaji v typu
::          "soubor vs slozka" a zda "objekt" je/neni typu "repairs point" a zda
::          oba jsou/nejsou typu "junction" - pokud relace "odpovidat si" neplati,
::          je oznamena chyba "ER"
::        - seznam atributu "y": d - Directory       0
::                               r - Read Only        1
::                               a - Archived          2
::                               h - Hidden             3
::                               s - System File         4
::                               c - Compressed File      5
::                               o - Offline File          6
::                               t - Temporary File         7
::                               l - Reparse point           8
::                               n - Attribute Normal         9
::                               x - No scrub                  10
::        - prehled atributu je uveden cely, subroutine pracuje pouze s atributy
::          "d", "r", "a", "h", "s" a "l" (platny parametr je pak napr. "SSr",
::          "SRa", "Fh", "Fs", "SC" nebo "SR" - jinak je oznamena chyba "ER")
::        - chyba "AC" ("objekt" je vyuzivan jinym procesem) je momentalne
::          prezentovana jako chyba "ER"
::                               
:att_exi
:: kontroly vstupnich parametru
SET FSCA_op=""
SET "attribs="
SET "attribs_w="
SET "err_FSCA="
SET %4=OK
FOR %%p IN (CA
            Ff  Fd  Fr  Fa  Fh  Fs  Fl
            SS  SC  SR 
            SSr SSa SSh SSs SCr SCa SCh SCs SRr SRa SRh SRs
) DO (IF %1 == %%p SET FSCA_op=%%p&GOTO fin_forAE)

:fin_forAE
IF %FSCA_op% == "" GOTO FS_CA_ER
:: ziskani atributu "objektu" a zaroven test neexistence "objektu"
CALL :exist_juntar %2 attribs err_FSCA
IF %err_FSCA% == OK GOTO FS_OK
IF %err_FSCA% == OT GOTO FS_OK
IF %err_FSCA% == NI GOTO FS_NI
IF %err_FSCA% == EA GOTO SE_LA1
GOTO SE_LA1

:: ******************************
:SE_LA1
SET I_cri_f=NI
CALL :SEVERE_LAW %2 I_cri_f
:: rozskok podle "OK/NI/AC/87/ER"
GOTO FS_%I_cri_f%

::*******************************
:FS_OK
:: "rozhozeni" na jednotlive atributy:
:: "d|- r|-, a|-, h|-, s|, -c|-, o|-, t|-, l|-, n|- nebo x|-", pracovat lze
:: jen s atributy "d|-, r|-, a|-, h|-, s|- nebo l|-"
SET att_Fd=%attribs:~0,1%
SET att_Fr=%attribs:~1,1%
SET att_Fa=%attribs:~2,1%
SET att_Fh=%attribs:~3,1%
SET att_Fs=%attribs:~4,1%
SET att_Fl=%attribs:~8,1%
IF %FSCA_op% == CA (
  GOTO CA_w
) ELSE (
  GOTO FS_w
)

:FS_w
:: operace "Fxy" nebo "Sxy"
CALL :att_F_S_C %FSCA_op% %2 %attribs% attribs_w err_FSCA
IF %err_FSCA% == OK GOTO att_allone
IF %err_FSCA% == OT GOTO att_allone
IF %err_FSCA% == NI GOTO FS_NI
IF %err_FSCA% == ER GOTO FS_ER
GOTO CA_w

:CA_w
:: ziskani atributu "objektu" a zaroven test existence
CALL :exist_juntar %3 attribs_w err_FSCA
IF %err_FSCA% == OK GOTO CA_OK
IF %err_FSCA% == OT GOTO CA_OK
IF %err_FSCA% == NI GOTO CA_NI
IF %err_FSCA% == EA GOTO SE_LA2
GOOTO SE_LA2

:: ******************************
:SE_LA2
SET I_cri_f=NI
CALL :SEVERE_LAW %3 I_cri_f
:: rozskok podle "OK/NI/AC/87/ER"

::*******************************
:CA_OK
:: operace "CA"
CALL :att_F_S_C CA %3 %attribs% attribs_w err_FSCA
IF %err_FSCA% == OK GOTO att_allone
IF %err_FSCA% == OT GOTO att_allone
IF %err_FSCA% == NI GOTO CA_NI
IF %err_FSCA% == ER GOTO CA_ER

:FS_87
:: specialita pro "NUL"
SET %5=-----------
GOTO all_att

:FS_OT
:CA_OT
:: chyba neni predavana - typ "OT", predany z "exist_juntar", je doveden
:: na navesti FS_OK/CA_OK
SET %4=OT
GOTO all_att

:FS_NI
:CA_NI
SET %4=NI
GOTO all_att

:CA_ER
:FS_ER
:FS_AC
:CA_AC
:FS_CA_ER
SET %4=ER
CALL :err_tak_own %2 F
GOTO all_att

:att_allone
SET %5=%attribs_w%
GOTO all_att

:all_att
GOTO :eof

:: interni subroutine "exist_juntar"
:: *********************************
:: zjistovani existence "objektu" a ziskani atributu/chyby
:: *******************************************************
:: vstupni parametry: nazev "objektu"
:: vystupni parametry: - atributy "objektu"
::                     - vysledek testu:
::                       - OK
::                       - OT - objekt existuje (jde o
::                              "junction"), ale "target"
::                              neexistuje
::                       - NI - neexistence "objektu"
::                       - EA - pristup odepren
:: pozn.: v pripade chyby nelze brat zretel na atributy                
::
:exist_juntar
SET nam_obj="%~1"
SET %2=-----------
SET %3=OK
SET attribs_ww=-----------
SET w_OT=OK
:: pristupnost (existence) objektu - chyby: - 0  - OK
::                                          - 2  - system nemuze nalezt
::                                                 uvedeny "objekt"
::                                          - 3  - system nemuze nalezt
::                                                 uvedenou cestu
::                                          - 5  - pristup zakazan
::                                          - 32 - pristup k "objektu"
::                                                 nelze ziskat (je prave
::                                                 pouzivan jinym procesem)
::
ICACLS %nam_obj% /L %stream%
IF %ERRORLEVEL% == 32 GOTO all_err_ex_acc
IF %ERRORLEVEL% == 5 GOTO all_err_ex_acc
IF %ERRORLEVEL% == 3 GOTO all_err_ex_obj
IF %ERRORLEVEL% == 2 GOTO all_err_ex_obj
:: ziskani atributu
FOR %%A IN (%nam_obj%) DO (SET attribs_w=%%~aA)
IF "%attribs_w%" == "" GOTO possib_err
:: pokud zakladni objekt je typu "repairs-point", probehne test existence
:: "target-objektu" 
IF %attribs_w:~8,1% == l GOTO test_targ
GOTO poss_ex_tar_w

:possib_err
:: - dalsi test existence "objektu", pokud nezabral prikaz "FOR" (attrib)
:: - vysledky jsou ziskavany v zavislosti na "mutaci" a netykaji se objektu "target"
ATTRIB %nam_obj% /L %stream%
FOR /F "tokens=1 delims=: usebackq" %%E IN ("STD_%pismenko%.txt") DO (SET stat_w=%%E)
IF "%stat_w:~0,4%" == "File" GOTO all_err_ex_obj
IF "%stat_w:~0,4%" == "Soub" GOTO all_err_ex_obj
SET "attribs_w="
:: seskladani atributu tak, jako by byly ziskany pomoci prikazu "FOR" - nemenit
:: poradi zpracovani atributu (d => R => A => H => S => l)
IF /I %attribs_ww:~0,1% == d (
   SET attribs_w=%attribs_w%d
) ELSE (
   SET attribs_w=%attribs_w%-
)
IF /I "%stat_w:~5,1%" == "R" (
   SET attribs_w=%attribs_w%r
) ELSE (
   SET attribs_w=%attribs_w%-
)
IF /I "%stat_w:~0,1%" == "A" (
   SET attribs_w=%attribs_w%a
) ELSE (
   SET attribs_w=%attribs_w%-
)
IF /I "%stat_w:~4,1%" == "H" (
   SET attribs_w=%attribs_w%h
) ELSE (
   SET attribs_w=%attribs_w%-
)
IF /I "%stat_w:~3,1%" == "S" (
   SET attribs_w=%attribs_w%s---
) ELSE (
   SET attribs_w=%attribs_w%----
)
IF /I %attribs_ww:~8,1% == l (
   SET attribs_w=%attribs_w%l--
) ELSE (
   SET attribs_w=%attribs_w%---
)

:test_targ
:: testovani existence "target" a jeji podminene nastaveni
ATTRIB %nam_obj% /L %stream%
FOR /F "tokens=1 delims=: usebackq" %%E IN ("STD_%pismenko%.txt") DO (SET stat_w=%%E)
IF /I NOT "%stat_w:The t=%" == "%stat_w%" SET w_OT=OT
IF /I NOT "%stat_w:l sym=%" == "%stat_w%" SET w_OT=OT
GOTO poss_ex_tar_w

:poss_ex_tar_w
SET %2=%attribs_w%
:: existence/neexistence "target"
SET %3=%w_OT%
GOTO all_ex_juntar

:all_err_ex_obj
:: neexistence "objektu"
SET %3=NI
GOTO all_ex_juntar

:all_err_ex_acc
:: odepren pristup
SET %3=EA
GOTO all_ex_juntar

:all_ex_juntar
GOTO :eof

:: interni subroutine "SEVERE_LAW"
:: *******************************
:: "shozeni" nedostupnosti - prevzeti vlastnictvi, reset a nastaveni prav
:: **********************************************************************
:: vstupni parametry: cesta s nazvem slozky
:: vystupni parametry: "OK/NI/AC/87/ER": - "objekt" existuje
::                                       -   - "-   neexistuje
::                                       - je nepristupny
::                                       - pouziti "NUL"
::                                       - chyba
::
:SEVERE_LAW
:: "vylakani" informaci o dobre skrytych a nedostupnych "objektech"
ICACLS %1 %stream%
:: test chyb pri hledani "objektu" a jeho vyuzivani
::  - 0   - OK
::  - 2   - system nemuze nalezt uvedeny "objekt"
::  - 3   -         -"-          uvedenou cestu
IF NOT ERRORLEVEL 1 GOTO all_OK
IF %ERRORLEVEL% == 2 GOTO all_NI
IF %ERRORLEVEL% == 3 GOTO all_NI
:: **************************************************************************
:: tento blok prikazu slouzi jedinemu ucelu, ziskat pravo pouzivat "objekt"
:: blok je hrube ucinny a chova se jako posledni moznost k nastaveni "pouzit
:: objekt je mozne", ale za cenu zniceni informaci o puvodnim vlastnikovi
:: a pravech (zpusobi uziti "TAKEOWN")
:: prevzeti vlastnictvi:
:: - prikaz "TAKEOWN" nikdy nehlasi chybu (vyjimkou je neexistujici "objekt",
::   co je jiny pripad, zde osetreny), proto je jeho ucinek proveren prikazem
::   "ICACLS", ktery je nedestruktivni (samotny "TAKEOWN" destruktivni je,
::   ale nikoliv fatalne)
:: - skonci-li tento prikaz bez chyby, objekt EXISTUJE a bylo prevzato
::   vlastnictvi
:: - pokud prikaz skoncil chybou, objekt NEEXISTUJE nebo prece jen EXISTUJE,
::   ale jsou rozbite zapisy o jeho stavu nebo existuji jine zavazne chyby,
::   tykajici se "objektu" (vliv na tento stav maji rozbita metadata v MFT
::   oddilu - "objekt" s takovy daty je vyhodnocen jako neexistujici)
:: - v techto chybovych pripadech pak NELZE PREVZIT VLASTNICTVI - "objekt"
::   bude odmitnut a prace ukoncena
:: - tento SW, z duvodu nekompatibility verzi "cmd.exe", nepouziva parametr
::   "SKIPSL" v prikazu "TAKEOWN", ktery je zaveden pouze v OS W10 - proto
::   v nekterych pripadech  nelze pracovat s "objektem" typu "junction"
::   a prebirat vlastnictvi (ale je pravda, ze objekty "junction" nejsou tak
::   "hlidane", aby pro jejich zpracovani bylo potreba pouzivat takove 
::   "ostre" prostredky, jako je "TAKEOWN")
TAKEOWN /F %1 /A %stream%
IF ERRORLEVEL 1 GOTO all_ER
:: opakovani kontroly pomoci "ICACLS" a prevzeti vlastnictvi celeho stromu
ICACLS %1 %stream%
IF ERRORLEVEL 1 GOTO all_ER
ICACLS %1 /RESET /L /T /Q /C %stream%
ICACLS %1 /GRANT EveryOne:F /L /T /Q /C %stream%
:: ***************************************************************************
GOTO all_OK

:: prevzeti se podarilo
:all_OK
SET %2=OK
GOTO all_law

:all_ER
SET %2=ER
GOTO all_law

:all_NI
SET %2=NI
GOTO all_law

:all_AC
SET %2=AC
GOTO all_law

:all_law
GOTO :eof

:: interni subroutine "att_F_S_C"
:: ******************************
:: zpracovani hodnot atributu v zavislosti na typu operace a vystup vsech/jednoho atributu
:: ***************************************************************************************
:: vstupni parametry: - operace "Fyz/Syz/CA"
::                    - nazev "objektu" - u "Syz/CA" vstupni/vystupni "objekt", u "Fyz"
::                                        nezajimave 
::                    - vstupni atributy "globalne" oznacene "att_Fy" (y="d|r|a|h|s|l")
:: vystupni parametry: - atributy: - jeden: "d|-", "r|-", "a|-", "h|-", "s|-", "l|-"
::                                 - vsechny: d|-r|-a|-h|-s|-c|-o|-t|-l|-n|-x|-
::                     - indikatory skonceni operace - "OK/OT/NI/ER"
::
:att_F_S_C
SET FSCA_opw=%1
set att_w=-----------
SET %5=OK
:: rozskok podle "Fyz/Syz/CA"
GOTO %1_att

:: zpracovani funkci "F..."
:: predani vsech atributu
:Ff_att
SET %4=%3
GOTO fin_f_att

:: predani jednoho atributu - jeho pismene nebo znaku "-"
:Fd_att
:Fr_att
:Fa_att
:Fh_att
:Fs_att
:Fl_att
:: atribut je nastaven v zavislosti na jeho oznaceni "Fd|Fr|Fa ...."
SET FSCA_opww=%FSCA_opw:~1,1%
SET %4=!att_F%FSCA_opww%!
GOTO fin_f_att

:: zpracovani funkci "S..."
:: "nahozeni" vsech atributu
:SS_att
SET att_Frw=+r
SET att_Faw=+a
SET att_Fhw=+h
SET att_Fsw=+s
GOTO all_S

:: "preklopeni" vsech atributu
:SC_att
IF %att_Fr% == - (
   SET att_Frw=+r 
) ELSE (
   SET att_Frw=-r
)
IF %att_Fa% == - (
   SET att_Faw=+a 
) ELSE (
   SET att_Faw=-a
)
IF %att_Fh% == - (
   SET att_Fhw=+h 
) ELSE (
   SET att_Fhw=-h
)
IF %att_Fs% == - (
   SET att_Fsw=+s 
) ELSE (
   SET att_Fsw=-s
)
GOTO all_S

:: "shozeni" vsech atributu
:SR_att
SET att_Frw=-r
SET att_Faw=-a
SET att_Fhw=-h
SET att_Fsw=-s
GOTO all_S

:all_S
SET att_w=%att_Frw% %att_Faw% %att_Fhw% %att_Fsw%
SET %4=%att_Fd%%att_Frw%%att_Faw%%att_Fhw%%att_Fsw%%att_Fc=%%att_Fo%%att_Ft%%att_Fl%%att_Fn%%att_Fx%%
GOTO new_att

:: "nahozeni" jednoho atributu
:SSr_att
SET att_Frw=+r
GOTO one_S
:SSa_att
SET att_Faw=+a
GOTO one_S
:SSh_att
SET att_Fhw=+h
GOTO one_S
:SSs_att
SET att_Fsw=+s
GOTO one_S

:: "preklopeni" jednoho atributu
:SCr_att
IF %att_Fr% == - (
   SET att_Frw=+r 
) ELSE (
   SET att_Frw=-r
)
GOTO one_S
:SCa_att
IF %att_Fa% == - (
   SET att_Faw=+a 
) ELSE (
   SET att_Faw=-a
)
GOTO one_S
:SCh_att
IF %att_Fh% == - (
   SET att_Fhw=+h 
) ELSE (
   SET att_Fhw=-h
)
GOTO one_S
:SCs_att
IF %att_Fs% == - (
   SET att_Fsw=+s 
) ELSE (
   SET att_Fsw=-s
)
GOTO one_S

:: "shozeni" jednoho atributu
:SRr_att
SET att_Frw=-r
GOTO one_S
:SRa_att
SET att_Faw=-a
GOTO one_S
:SRh_att
SET att_Fhw=-h
GOTO one_S
:SRs_att
SET att_Fsw=-s
GOTO one_S

:one_S
SET FSCA_opww=%FSCA_opw:~2,1%
:: presun hodnoty atributu podle parametru "SSy", "SCy" a "SRy"
SET att_w=!att_F%FSCA_opww%w!
SET %4=%att_w%
GOTO new_att

:: zpracovani funkce "CA..." - prenos atributu ze vstupu na vystup
:CA_att
SET I_fifo=fo
SET I_fofi=fo
:: test "objektu" stejneho typu v zavislosti na indikaci slozky/souboru
IF %att_Fd% == - SET I_fifo=fi
CALL :exist_juntar %2 att_w err_FSCA
:: rozskok "OK/OT/NI/EA"
GOTO fofi_%err_FSCA%

:fofi_OK
:fofi_OT
:: indikace slozky/souboru a test, zda "objekty" (normalni/l-repairs point)
:: jsou stejneho typu
IF %att_w:~0,1% == - SET I_fofi=fi
IF NOT %I_fifo% == %I_fofi% GOTO fofi_ER
:: vytvoreni sady parametru tvaru "+|-r+|-a+|-h+|-s" pro prikaz "attrib"
SET "att_w="
IF %att_Fs% == s (
   SET att_w=+s %att_w%
) ELSE (
   SET att_w=-s %att_w%
)
IF %att_Fh% == h (
   SET att_w=+h %att_w%
) ELSE (
   SET att_w=-h %att_w%
)
IF %att_Fa% == a (
   SET att_w=+a %att_w%
) ELSE (
   SET att_w=-a %att_w%
)
IF %att_Fr% == r (
   SET att_w=+r %att_w%
) ELSE (
   SET att_w=-r %att_w%
)
GOTO new_att

:new_att
:: nastaveni/nenastaveni parametru "/L":
:: - aby bylo mozne s atributy manipulovat, je potreba atributy "s" a "h" odstranit
::   "natvrdo" a "nahodit" nove atributy
:: - nakonec odstranit " " v bufferu s atributy 
SET "w_L="
IF NOT %att_Fl% == - SET w_L=/L
ATTRIB -S -H %2 %w_L% %stream%
ATTRIB %att_w% %2 %w_L% %stream%
SET %4=%att_w: =%
GOTO fin_f_att

:fofi_NI
SET %5=NI
GOTO all_fofi

:fofi_EA
:fofi_ER
SET %5=ER
GOTO all_fofi

:all_fofi
GOTO fin_f_att

:fin_f_att
GOTO :eof

:: subroutine "ex_si"
:: ******************
:: kontrola existence a vypocet velikosti "normalnich" slozek
:: **********************************************************
:: vstupni parametry: - nazev "objektu"
::                    - prubezna velikost pred pripoctenim
::                      velikosti dalsi slozky
:: vystupni parametry: - prubezna velikost po  pripocteni
::                       velikosti dalsi slozky
:ex_si
SET Nam_folw=%~1
:: nastaveni casti cest pro slozky nachazejici se uvnitr slozky "Windows" nebo
:: slozky "Wndows\System32"
CALL :Ws32w_ini "%Nam_folw%"
SET siz_ALLw=%2
SET siz_ALLww=0
:: podle rezimu pridani oznaceni vstupniho oddilu a casti cesty, test existence
:: slozky a vypocet velikosti potrebneho prostoru pro diverzifikovanou slozku
IF %I_mod% == Nm SET Nam_folw="%I_r%%Ws32w%%Nam_folw%"&GOTO exi_test
IF %I_mod% == Bm SET Nam_folw="%O_r%%F_xy%%Ws32w%%Nam_folw%"
GOTO exi_test

:exi_test
SET Nam_folw=%Nam_folw:"=%
CALL :att_exi Ff "%Nam_folw%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%Nam_folw%" F
IF %NI_ER% == NI CALL :errwar_fol_in "%Nam_folw%"&GOTO fol_NO_ex
CALL :test_size "%Nam_folw%" NUL NenOB %DA_w% siz_ALLww siz_IN I_ts siz_ALL
IF %I_ts% == OK GOTO next_test6
IF %I_ts% == Eo CALL :err_tak_own "%Nam_folw%" F
IF %I_ts% == ER CALL :err_tak_own "%Nam_folw%" F
GOTO next_test6

:next_test6
:: velikost slozky "config", a protoze jeste mohou existovat slozky "config_old"
:: a "config_new", se nasobi "3" a celkovy pozadavek potrebneho prostoru
:: pro existujici slozky (postupna sumace)
IF NOT "%Nam_folw:config=%" == "%Nam_folw%" CALL :Math_M %siz_ALLww% 3 siz_ALLww 0 0
CALL :Math_A %siz_ALLw% %siz_ALLww% siz_ALLw 0 0
GOTO fol_NO_ex

:fol_NO_ex
SET %3=%siz_ALLw%
GOTO :eof

:: interni subroutine "test_size"
:: ******************************
:: velikost volneho prostoru v "objektu ou" vs velikost "objektu in" nebo zjisteni
:: velikosti "objektu_in"
:: *******************************************************************************
:: vstupni parametry: - "objekt ou" (parametr_1): - je-li t = "T", pracuje se
::                                                  pouze s oznacenim oddilu
::                                                - je-li t = "O", je "objektem"
::                                                  "oddil/slozka/soubor"
::                    - "objekt in" (parametr_2) je "oddil/slozka/soubor"          
::                    - indikatory "bwstco": "Yey/Yen/Yiy/Yin/Ney/Nen/Niy/Nin"
::                                           (prvni tri) 
::                                           - b = Y|N - vysypani/nevysypani kose
::                                           - w = e|i - ukonceni/neukonceni prace
::                                           - s = y|n - odstraneni/neodstraneni
::                                                       systemovych souboru
::                                                       "page...", "hiber..."
::                                                       a "swap..."
::                                           - t = T|O - zpracovani dvou/jednoho
::                                                       "objektu"
::                                           - c = B|F|C - obsazenost nebo volny
::                                                         prostor "objektu" nebo
::                                                         celkova kapacita
::                                                         oddilu (viz poznamky)
::                                           - o = f|_ - "objekt" je/neni soubor
::                    - indikace "mutace" - "Dir/Adr" (podle mutace "en/cz")
:: vystupni parametry: - "velikost" "objektu ou" - viz poznamky
::                     - "velikost" "objektu in" - viz poznamky
::                     - znaky "OK/ER/Eo/Ei/G/L/S": - OK
::                                                  - ER - chyba
::                                                  - Ei/Eo - neexistujici
::                                                            vstupni/vystupni
::                                                            "objekt"
::                                                  - G-vetsi/L-mensi/S-shoda,
::                                                    oznacujici vysledek relace
::                                                    mezi velikosti volneho
::                                                    prostoru v "objektu-par_1"
::                                                    a velikosti "objektu"-par_2"
::                     - celkova kapacita objektu
:: pozn.: - subroutine plni dve zcela odlisne ulohy - testuje relaci mezi velikosti
::          volneho prostoru na "objektu"-parametr_1 a velikosti "objektu"
::          na oddile-parametr_2 a tedy primo urcuje, zda "objekt"-parametr_2 bude
::          mozne na "objekt"-parametr_1 umistit nebo pouze zjistuje velikost
::          "objektu"-parametr_1
::        - v obou pripadech se vraci v zavislosti na indikatoru "T/O" rozdilna data:
::           - t = "T": - velikost volneho prostoru na "objektu"-parametr_1
::                      - velikost "objektu" - "oddilu/slozky/souboru"-parametr_2
::                      - indikator vysledku operace
::                      - celkova kapacita "objektu"-parametr_2 = "0"
::           - t = "O": - velikost "objektu" - "oddilu/slozky/souboru"-parametr_1
::                      - dalsi parametr neni vyznamny (ma hodnotu "0")
::                      - indikator vysledku operace
::                      - celkova kapacita "objektu"-parametr_1 = "0" nebo pokud
::                        parametr "c" = "C", je to skutecna velikost oddilu
::                        (zaroven parametr_5 = "0")
::        - "objektem" je soubor/slozka/oddil (mluvi-li se napr. o vysypani kose
::          "objektu" a "objektem" je soubor, je tim mysleno, ze jde o vysypani kose
::          na oddilu, kde se soubor nachazi, podobne u slozky)
::        - vsechny "velikosti" jsou ve znakovem tvaru
::        - "objekty" musi mit vzdy uvedene oznaceni oddilu (vyjimkou je parametr_2,
::          ktery v pripade t = "O", muze byt oznacen pomoci NUL)
::        - je-li indikator "t" = T, parametr "c" ("B/F/C") se neuplatni - zpracovani
::          probehne jen tak, jak je popsano - urci se vysledek relace mezi velikosti
::          volneho prostoru na vystupu a velikosti "objektu" na vstupu a prislusne
::          velikosti budou vracene (celkova kapacita "objektu"-parametr_2 bude "0",
::          naprosto dominantni roli zde hraje cas - vypocet celkove kapacity oddilu
::          je casove narocny, proto neni bezne vypocitavan)
::        - jinak: - je-li indikator "t" = O a zaroven plati, e parametr "c" = C,
::                   pouzije se z cesty k "objektu" pouze oznaceni oddilu (i kdyz
::                   cesta bude obsahovat libovolne dalsi informace)
::                 - je-li, take v pripade "t" = O, parametr "c" roven C/F, vezme
::                   se do uvahy pouze oznaceni oddilu a bude vracena celkova
::                   kapacita/velikost volneho prostoru a bude-li zadan parametr "B",
::                   bude v pripade slozky vracena jeji velikost a v pripade, kdy jde
::                   pouze o oddil, bude vracena jeho kompletni obsazenost
::
:test_size
SET only_O=ou
SET Ind_bwstc=%3
SET %7=OK
SET s_o=0
SET s_i=0
:: nasledujici tri promenne (velikosti systemovych souboru) momentalne nejsou
:: prakticky vyuzivane
SET s_p=0
SET s_h=0
SET s_s=0
SET all_siz=0
:: nastaveni indikace zpracovani "jednoho/dvou" objektu, zjisteni velikosti "objektu",
:: indikace ukonceni operace (nestandardne predane, ktera byla odejmuta od hodnoty
:: velikosti oddilu) a obsluha pripadne chyby
IF %Ind_bwstc:~3,1% == O SET only_O=in
CALL :tyob_size "%~1" %only_O% %Ind_bwstc% %4 s_o s_p s_h s_s all_siz
SET Ind_oper=%all_siz:~0,2%
SET all_siz=%all_siz:~2%
IF NOT %Ind_oper% == OK GOTO err_ex
SET Ind_bwstc=%3
SET s_i=0
:: test prace pouze s jednim objektem, zjisteni velikosti "objektu", indikace ukonceni
:: operace (nestandardne predane), ktera byla odejmuta od hodnoty velikosti oddilu
:: a obsluha pripadne chyby
IF %Ind_bwstc:~3,1% == O GOTO calcul_only_O
CALL :tyob_size "%~2" in %Ind_bwstc% %4 s_i s_p s_h s_s all_siz
SET Ind_oper=%all_siz:~0,2%
SET all_siz=%all_siz:~2%
IF NOT %Ind_oper% == OK GOTO err_ex
:: urceni relace mezi velikosti volneho prostoru v "objektu ou" a velikosti
:: "objektu in" s podminenym oznamenim chyby o nedostatecne velikosti volneho
::  prostoru v "objektu ou" a eventualnim ukoncenim prace
CALL :Math_C %s_o% %s_i% I_com 0 0
IF NOT %I_com% == L GOTO all_ts
IF %Ind_bwstc:~1,1% == i GOTO all_ts
CALL :err_insu %1

:all_ts
:: vysledek srovnani
SET %7=%I_com%
GOTO fin_ts

:err_ex
SET %7=%Ind_oper%
GOTO fin_ts

:calcul_only_O
SET %7=%Ind_oper%
GOTO fin_ts

:fin_ts
SET %5=%s_o%
SET %6=%s_i%
SET %8=%all_siz%
GOTO :eof

:: interni subroutine "tyob_size"
:: ******************************
:: urceni velikosti volneho prostoru nebo velikosti "objektu" - pomocna subroutine
:: subroutine
:: *******************************************************************************
:: vstupni parametry: - nazev "objektu ou/in"
::                    - oznaceni "ou/in" "objektu"  
::                    - indikatory "bwstco": - b = Y|N - vysypani/nevysypani kose
::                                           - w = e|i - ukonceni/neukonceni prace
::                                           - s = y|n - odstraneni/neodstraneni
::                                                       systemovych souboru 
::                                                       "page...", "hiber..."
::                                                       a "swap..."
::                                           - t = T|O - zpracovani dvou/jednoho
::                                                       "objektu"
::                                           - c = B/F/C - obsazenost nebo
::                                                         volny prostor "objektu"
::                                                         nebo celkova kapacita
::                                                         oddilu
::                                           - o = f|_ - "objekt" je/neni soubor
::                                                       (indikace je v subroutine
::                                                       vytvarena)
::                    - indikace "mutace" - "Dir/Adr"
:: vystupni parametry: - velikost "objektu ou/in" (ve znakovem tvaru)
::                     - velikost "page..."
::                     - velikost "hiber..."
::                     - velikost "swap..."
::                     - "indikatory" (dva znaky) a velikost oddilu
:: pozn.: - indikace vysledku operace "OK/Ei...." je vytvarena v teto subroutine
::        - indikace ukonceni subroutine "OK/Eo/Ei/ER": OK - operace v poradku
::                                                      Eo - neexistujici vystupni
::                                                           "objekt"
::                                                      Ei - neexistujici vstupni
::                                                           "objekt"
::                                                      ER - neexistujici "objekt"
::          budou navracene jako prvni dva znaky parametru "9", tesne nasledovane
::          celkovou kapacitou oddilu
::        - velikosti systemovych souboru jsou predavane, ale momentalne nevyuzivane
::
:tyob_size
SET s_w=0
SET s_ww=0
SET s_p=0
SET s_h=0
SET s_s=0
SET all_siz_w=0
:: pouzito i pro predani indikace ukonceni prace subroutine, indikace souboru
:: ("naslepo"), test, zda se pracuje se s oddilem a test, zda se skutecne pracuje
:: s oddilem (tedy zda obsahuje ":") a test slozky/souboru podle atributu "d"
SET %9=OK%all_siz_w%
SET Ind_bwstco=%3f
CALL :Math_C "%~1" %str_4% I_com 0 0
IF NOT %I_com% == L GOTO part_NO0
SET two_colon=%1
IF NOT %two_colon::=% == %two_colon% GOTO obj_Pa
GOTO part_NO0

:part_NO0
CALL :att_exi Fd "%~1" out_NUL NI_ER str_att
IF %NI_ER% == ER GOTO obj_ER_ex
IF %NI_ER% == NI GOTO obj_NI_ex
:: slozka/soubor
IF %str_att% == d (
  GOTO obj_Fo
) ELSE (
  GOTO obj_Fi
)

:obj_NI_ex
:: neexistujici "objekt" a rozskok podle "ou/in", ve vsech trech pripadech pouzity
:: i pro predani indikace ukonceni prace subroutine
GOTO err_OI_%2

:err_OI_ou
SET all_siz_w=Eo%all_siz_w%
GOTO fin_tyobw

:err_OI_in
SET all_siz_w=Ei%all_siz_w%
GOTO fin_tyobw

:obj_ER_ex
:: hruba chyba
SET all_siz_w=ER%all_siz_w%
GOTO fin_tyobw

:fin_tyobw
SET %9=%all_siz_w%
GOTO fin_tyob

:obj_Fi
:: velikost souboru
SET s_ww=%~z1
GOTO fin_tyob

:obj_Fo
:obj_Pa
:: indikace slozky/oddilu
SET Ind_bwstco=%3_
GOTO too_space

:too_space
CALL :all_space "%~1" %2 %Ind_bwstco% %4 s_w s_p s_h s_s all_siz_w
SET %9=OK%all_siz_w%
GOTO fin_tyob

:fin_tyob
:: delka souboru byla pripravena uz drive
IF %Ind_bwstco:~5,1% == _ GOTO NO_file
SET %5=%s_ww%
GOTO after_file

:NO_file 
SET %5=%s_w%
GOTO after_file

:after_file
SET %6=%s_p%
SET %7=%s_h%
SET %8=%s_s%
GOTO :eof

:: interni subroutine "all_space"
:: ******************************
:: urceni velikosti volneho prostoru nebo velikosti "objektu" - jedna z pripravnych
:: pomocnych subroutine
:: ********************************************************************************
:: vstupni parametry: - nazev "objektu ou/in"
::                    - oznaceni "ou/in" "objektu"  
::                    - indikatory "bwstco": - b = Y|N - vysypani/nevysypani kose
::                                           - w = e|i - ukonceni/neukonceni prace
::                                           - s = y|n - odstraneni/neodstraneni
::                                                       systemovych soluboru 
::                                                       "page...", "hiber..."
::                                                       a "swap..."
::                                           - t = T|O - zpracovani dvou/jednoho
::                                                       "objektu"
::                                           - c = B/F/C - obsazenost/volny prostor
::                                                         "objektu"/celkova
::                                                         kapacita oddilu
::                                           - o = f|_ - "objekt" je/neni soubor
::                                                       (indikace je v subroutine
::                                                       vytvarena)
::                    - indikace "mutace" - "Dir/Adr"
:: vystupni parametry: - velikost "objektu ou/in"
::                     - velikost "page..."
::                     - velikost "hiber..."
::                     - velikost "swap..."
::                     - kapacita oddilu
:: pozn.: vsechny parametry jsou ve znakovem tvaru
::
:all_space
SET l_p=0
SET l_h=0
SET l_s=0
SET summ_w=0
SET all_siz_w=0
SET %9=%all_siz_w%
SET Ind_bws_w=%3
:: odstraneni kose?
IF %Ind_bws_w:~0,1% == N GOTO NO_eras_bin
CALL :bin_sys_del %2 b
GOTO NO_eras_bin

:NO_eras_bin
CALL :deter_size "%~1" %2 %3 %4 summ_w l_p l_h l_s all_siz_w
:: kapacita oddilu a pri praci se systemovymi soubory vyber jejich velikosti
:: a jejich odstraneni
SET %9=%all_siz_w%
SET summ_p=0
SET summ_h=0
SET summ_s=0
IF %Ind_bws_w:~2,1% == n GOTO NO_sys_file1
FOR /F "tokens=3" %%s IN ("%l_p%") DO SET summ_p=%%s
CALL :bin_sys_del %2 p
FOR /F "tokens=3" %%s IN ("%l_h%") DO SET summ_h=%%s
CALL :bin_sys_del %2 h
FOR /F "tokens=3" %%s IN ("%l_s%") DO SET summ_s=%%s
CALL :bin_sys_del %2 s
GOTO NO_sys_file1

:NO_sys_file1
:: test prace se souborem a podminene odecteni velikosti systemovych souboru
IF %Ind_bws_w:~5,1% == f GOTO YES_work_file
IF %Ind_bws_w:~2,1% == n GOTO NO_sys_file2
CALL :Math_S %summ_w% %summ_h% summ_w 0 0
CALL :Math_S %summ_w% %summ_p% summ_w 0 0
CALL :Math_S %summ_w% %summ_s% summ_w 0 0
GOTO all_all_space

:YES_work_file
SET summ_w=0
GOTO all_all_space

:all_all_space
:NO_sys_file2
SET %5=%summ_w%
SET %6=%summ_p%
SET %7=%summ_h%
SET %8=%summ_s%
GOTO :eof

:: interni subroutine "bin_sys_del"
:: ********************************
:: prace s kosem a systemovymi soubory "page...", "hiber..." a "swap..."
:: *********************************************************************
:: vstupni parametry: - oznaceni "objektu" je zde "ou/in"
::                    - b/p/h/s kde: - b - odstraneni obsahu kose
::                                   - p -    -"-     "pagefile.sys"
::                                   - h -            "hiberfil.sys"
::                                   - s -            "swapfile.sys"
:: vystupni parametry:
::
:bin_sys_del
:: rozskok podle "ou/in"
GOTO bin_phs_%1

:bin_phs_ou
SET bin_IO=%O_r%
GOTO all_bin_phs

:bin_phs_in
SET bin_IO=%I_r%
GOTO all_bin_phs

:all_bin_phs
:: nastaveni operace "DEL" a parametru
SET "S_ope="
SET ope_r_d=DEL
:: rozskok podle "b/p/h/s"
GOTO del_%2

:del_b
:: nastaveni operace "RD" a parametru
SET S_ope=/S
SET ope_r_d=RD
SET obj_w=$RECYCLE.BIN
GOTO rd_del

:del_p
SET obj_w=pagefile.sys
GOTO all_t_ss

:del_h
SET obj_w=hiberfil.sys
GOTO all_t_ss

:del_s
SET obj_w=swapfile.sys
GOTO all_t_ss

:all_t_ss
GOTO rd_del

:rd_del
:: prevzeti vlastnictvi, "RESET", nastaveni prav a odstraneni kose nebo jednoho ze systemovych
:: souboru
TAKEOWN /F %bin_IO%%obj_w% /A %stream%
ICACLS %bin_IO%%obj_w% /RESET /Q /C %stream%
ICACLS %bin_IO%%obj_w% /GRANT EveryOne:F /Q /C %stream%
%ope_r_d% %S_ope% /Q %bin_IO%%obj_w% %stream%
GOTO :eof

:: interni subroutine "deter_size"
:: *******************************
:: nastaveni znaku "caret - ^" pro nazvy slozek obsahujicich znaky "()" a zjisteni
:: velikosti volneho prostoru "objektu" nebo velikosti "objektu" s ohledem na jeho
:: typ a mutaci "en/cz"
:: ********************************************************************************
:: vstupni parametry: - nazev "objektu ou/in"
::                    - "ou/in": - "ou" - vypocet volneho prostoru na oddilu
::                               - "in" - velikost oddilu/slozky (velikost souboru
::                                        uz byla urcena drive, ale i zde je
::                                        zjistovanana - subroutine muze byt
::                                        pouzita i samostatne)
::                    - indikatory "bwstco": - b = Y|N - vysypani/nevysypani kose
::                                           - w = e|i - ukonceni/neukonceni prace
::                                           - s = y|n - odstraneni/neodstraneni
::                                                       systemovych soluboru 
::                                                       "page...", "hiber..."
::                                                       a "swap..."
::                                           - t = T|O - zpracovani dvou/jednoho
::                                                       "objektu"
::                                           - c = B/F/C - obsazenost/volny prostor
::                                                         "objektu"/celkova
::                                                         kapacita oddilu
::                                           - o = f|_ - "objekt" je/neni soubor
::                                                       (indikace je v subroutine
::                                                       vytvarena)
::                    - indikace "mutace" - "Dir/Adr"
:: vystupni parametry: - velikost "objektu"
::                     - velikost "page..."
::                     - velikost "hiber..."
::                     - velikost "swap..."
::                     - kapacita oddilu
:: pozn.: - je_li "o" = f, zpracuji se podminene podle "s" i velikosti systemovych
::          souboru "page....", "hiber..." a "swap..."
::        - vsechny velikosti jsou ve znakovem tvaru
::
:deter_size
SET summa=0
SET %5=0
SET %9=0
SET Nam_folw=%~1
SET Ind_bwstco_w=%3
:: vlozeni znaku "caret" pred "(" a ")" tak, ze uprava nazvu slozek obsahujicich
:: znaky "()" "zaridi" spravnou funkcnost prikaz u "FOR" pri stanoveni obsazenost
:: i volneho prostoru
IF "%Nam_folw:(=%" == "%Nam_folw%" GOTO NO_bracl
SET Nam_folw=%Nam_folw:(=^^(%
GOTO NO_bracl

:NO_bracl
IF "%Nam_folw:)=%" == "%Nam_folw%" GOTO NO_bracr
SET Nam_folw=%Nam_folw:)=^^)%
GOTO NO_bracr

:NO_bracr
:: oznaceni oddilu a test na praci s kosem a systemovymi soubory
SET Id_part=%Nam_folw:~0,3%
IF NOT %Ind_bwstco_w:~2,1% == n GOTO NO_sys_file3
SET l_p=0
SET l_h=0
SET l_s=0
:: velikosti systemovych souboru
FOR /F "tokens=*" %%x IN ('"DIR "%Id_part%" /-C /A 2^>NUL|FIND "pagefile.sys""') DO SET l_p=%%x
FOR /F "tokens=*" %%x IN ('"DIR "%Id_part%" /-C /A 2^>NUL|FIND "hiberfil.sys""') DO SET l_h=%%x
FOR /F "tokens=*" %%x IN ('"DIR "%Id_part%" /-C /A 2^>NUL|FIND "swapfile.sys""') DO SET l_s=%%x
GOTO NO_sys_file3

:NO_sys_file3
:: rozskok podle "T/O"
GOTO one_two_%Ind_bwstco_w:~3,1%

:one_two_T
:: rozskok podle "ou/in" 
GOTO OUIN_%2

:OUIN_ou
:: velikost volneho prostoru
CALL :deter_ouin "%Id_part%" ou %3 %4 summa
GOTO all_OU_IN

:OUIN_in
:one_two_O
:: velikost "objektu"
CALL :deter_ouin "%Nam_folw%" in %3 %4 summa
:: zpracovani jednoho "objektu" nebo "bezne"? 
IF %Ind_bwstco_w:~3,1% == T GOTO norm_work
IF %Ind_bwstco_w:~4,1% == C SET %5=0&SET %9=%summa%&GOTO all_deter
GOTO all_OU_IN

:all_OU_IN
:norm_work
SET %5=%summa%
GOTO all_deter

:all_deter
:: velikosti systemovych souboru "page...", "hiber..." a "swap..." nebo "0"
SET %6=%l_p%
SET %7=%l_h%
SET %8=%l_s%
GOTO :eof

:: interni subroutine "deter_ouin"
:: ******************************
:: vykonna subroutine pro "deter_size" - velikost "volneho prostoru/"objektu"/kapacity
:: ***********************************************************************************
:: vstupni parametry: - nazev objektu
::                    - operace "ou/in" (velikost volneho prostoru vs velikost
::                      "objektu")
::                    - indikatory "bwstco": - b = Y|N - vysypani/nevysypani kose
::                                           - w = e|i - ukonceni/neukonceni prace
::                                           - s = y|n - odstraneni/neodstraneni
::                                                       systemovych soluboru 
::                                                       "page...", "hiber..."
::                                                       a "swap..."
::                                           - t = T|O - zpracovani dvou/jednoho
::                                                       "objektu"
::                                           - c = B/F/C - obsazenost/volny prostor
::                                                         "objektu"/celkova
::                                                         kapacita oddilu
::                                           - o = f|_ - "objekt" je/neni soubor
::                                                       (indikace je v subroutine
::                                                       vytvarena)
::                    - indikace "mutace" - "Dir/Adr"
:: vystupni parametry: velikost ve znakovem tvaru
:: pozn.: - parametr "ou" - je vracena velikost volneho prostoru "oddilu", oznaceneho
::                          v ceste k "objektu"
::        -   -"-    "in" - "objekt" je oddil - je vracena obsazenost oddilu
::                             -"-     slozka - je vracena velikost slozky (je-li
::                                              slozka "juntion" nebo symlinkD, je
::                                              jako jeji velikost vracena "0")
::                        - je-li "objekt" soubor, je vracena velikost souboru
::        - z indikatoru je zde dulezity pouze "c" ("B/F/C")
::        - v zavislosti na mutaci maji parametry rozdilne vyznamy - v kazdem pripade
::          bylo potreba se vyhnout spatne lokalizaci, kde jsou do prekladu zavadena
::          "nabodenicka", ale dokonce je meneno poradi i umisteni "citlivych"
::          informaci a nektere vyrazy byly prelozeny tak spatne, ze je znemoznena
::          prace jinych SW, ktere jsou nucene tyto prostredky pouzivat nebo je nutne
::          tyto SW narocne upravovat - objekty totiz jsou v originale pouzite napr.
::          jako testovaci objekty, co po prekladu predstavuje vazny problem 
::
:deter_ouin
SET lo_li=0
SET Nam_folww=%~1
SET Id_part=%Nam_folww:~0,3%
SET bwstco_I=%3
:: vytvoreni retezce pro trideni podle mutace
:: rozskok podle "Dir/Adr"
GOTO DAs_%4

:DAs_Dir
SET w_BB=Bytes
GOTO all_DAs

:DAs_Adr
SET w_BB=Bajty
GOTO all_DAs

:all_DAs
:: rozskok podle "ou/in"
GOTO deter_%2

:deter_ou
:: - zjistovani velikosti je provadene v zavislosti na parametru "T/O" a indikatoru
::   "c" ("B/F/C") 
:: - podle okolnosti je pouzit prikaz "FOR" nebo "robocopy" - vse je podrizeno tomu,
::   aby v zadnem pripade nebyly do velikosti zahrnuty i velikosti "target" slozek,
::   na ktere ukazuji "junction", tak jak to provadi - a SPATNE - prikaz "dir"
GOTO free_F

:free_F
:: volny prostor
CALL :deter_ouin_w %Id_part% %4 lo_li
SET lo_liw=%lo_li%
GOTO fin_deter_ouin

:capa_C
:: kapacita = volny prostor + obsazenost
CALL :deter_ouin_w %Id_part% %4 lo_li
:: - urceni velikosti "objektu", ktery neni oddilem
:: - vyuziti specialni vlastnosti prikazu "robocopy", ktera dovoluje pouzit tento
::   prikaz transparentne (parametr "/L") a pritom nezpracuje (to je mejdulezitejsi)
::   velikosti "target" objektu, na ktere ukazuji "junction"
SET Nf_Id=%Id_part%
GOTO busy_B

:busy_B
:: obsazenost (velikost "objektu")
robocopy %Nf_Id% %Nf_Id% /XF %hib% %pag% %swa% /XD "System Volume Information" %BinE% %BinR% %BinS% %L_rob%|FIND "%w_BB%" %stream%
:: nasilne ukonceni po hrubych chybach?
IF %ERRORLEVEL% GEQ 10 CALL :err_robo
:: rozskok podle "Dir/Adr"
GOTO DAf_%4

:DAf_Dir
FOR /F "tokens=1-3 usebackq" %%s IN ("STD_%pismenko%.txt") DO SET lo_liw=%%u
GOTO all_DAf

:Daf_Adr
FOR /F "tokens=1-3 usebackq" %%s IN ("STD_%pismenko%.txt") DO SET lo_liw=%%t
GOTO all_DAf

:all_DAf
:: pri parametru "C" se provede secteni volneho prostoru a obsazenosti
IF %bwstco_I:~4,1% == C CALL :Math_A %lo_li% %lo_liw% lo_liw 0 0
GOTO fin_deter_ouin

:deter_in
:: parametr "T" - bezne zpracovani?
IF %bwstco_I:~3,1% == T GOTO comm_TO
:: zpracovani parametru "C"?
IF %bwstco_I:~4,1% == C GOTO capa_C
:: zpracovani parametru "F"?
IF %bwstco_I:~4,1% == F GOTO free_F
GOTO comm_TO

:comm_TO
:: test, zda se pracuje s oddilem a test, zda skutecne se jedna o nazev oddilu,
:: tedy zda obsahuje ":"
CALL :Math_C "%Nam_folww%" %str_4% I_com 0 0
IF NOT %I_com% == L GOTO part_NO6
SET two_colon="%Nam_folww%"
:: zpracovani oddilu?
IF %two_colon::=% == %two_colon% GOTO part_NO6
:: obsazenost oddilu
SET Nf_Id=%Id_part%
GOTO busy_B

:part_NO6
:: objekt neni oddil
CALL :att_exi Fd "%Nam_folww%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%Nam_folww%" F
:: pokud je "objektem" soubor, bude jeho velikost stanovena specialnim zpusobem
IF NOT %str_att% == d GOTO file_OK
CALL :att_exi Fl "%Nam_folww%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%Nam_folww%" F
:: zde se rozhoduje, zda slozka je typu "junction" (symlinkD) nebo "normalni"
:: slozkou
IF NOT %str_att% == l SET Nf_Id="%Nam_folww%"&GOTO busy_B
:: velikost, v pripade "junction" (symlinkD) = "0"
SET lo_liw=0
GOTO fin_deter_ouin

:file_OK
:: velikost souboru
SET lo_liw=%~z1
GOTO fin_deter_ouin

:fin_deter_ouin
SET %5=%lo_liw%
GOTO :eof

:: interni subroutine "deter_ouin_w"
:: *********************************
:: vykonna subroutine pro "deter_ouin" - urcuje velikost volneho prostoru oddilu
:: *****************************************************************************
:: vstupni parametry: - oznaceni oddilu
::                    - indikace "mutace" - "Dir/Adr"
:: vystupni parametry: velikost ve znakovem tvaru
::
:deter_ouin_w
:: rozskok podle "Dir/Adr"
GOTO DA_%2

:DA_Dir
:: podle prislusne mutace je vytridena informace o velikosti volneho prostoru
:: oddilu do souboru, nalezena, vybrana a odeslana
:: "en" mutace
FOR /F "tokens=1-5" %%d IN ('DIR %1 /S /-C /A 2^>NUL^|FIND "bytes free" 1^>"STD_%pismenko%.txt" 2^>NUL') DO (%%d)
FOR /F "tokens=1-3 usebackq" %%s IN ("STD_%pismenko%.txt") DO SET lo_li=%%u
GOTO all_DA

:DA_Adr
:: "cz" mutace
FOR /F "tokens=1-5" %%d IN ('DIR %1 /S /-C /A^|FIND "Voln"^|FIND "bajt" 1^>"STD_%pismenko%.txt" 2^>NUL') DO (%%d)
FOR /F "tokens=1-3 usebackq" %%s IN ("STD_%pismenko%.txt") DO SET lo_li=%%u
GOTO all_DA

:all_DA
SET %3=%lo_li%
GOTO :eof

:: subroutine "copy_conf"
:: **********************
:: komplexni obsluha slozky "config" ("config_new" a "config_old")
:: ***************************************************************
:: vstupni parametry: all/new/old - typ prace se slozkou "config"
:: vystupni parametry:
::
:copy_conf
SET NBx=%1
IF %NBx% == all GOTO conf_all
ECHO.
ECHO *** Folder "config" - %2 mode:
ECHO     - very responsible work with folders "config"
ECHO     - allowed decides users, who "knows what to do"^^!
CALL :any
GOTO conf_all

:conf_all
SET I_err=N
:: test existence slozky "config" - podle typu rezimu je hledana v ruznych
:: slozkach oddilu a odstraneni '"'
SET IO_pie_fol=%I_r%
IF %I_mod% == Bm (SET IO_pie_fol=%O_r%%F_xy%)
SET IO_pie_fol=%IO_pie_fol:"=%
CALL :att_exi Ff "%IO_pie_fol%Windows\System32\config" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%IO_pie_fol%Windows\System32\config" F
IF NOT %NI_ER% == NI GOTO YES_copcon
ECHO.
ECHO *** Error: the folder "config" has not been in OS repository or
ECHO            %IO_pie_fol%Windows\System32\ found
GOTO err_fin_conw

:err_fin_conw
SET I_err=Y
GOTO err_fin_con

:YES_copcon
:: rozskok podle "all/new/old"
GOTO conf_%1

:conf_all
CALL :work_conf %I_r% %O_r%%F_xy%
IF %I_err% == Y GOTO err_work_conf
:: prejmenovani slozky "config" na zalohu "config_old" a zopakovani celeho
:: procesu
REN "%O_r%%F_xy%Windows\System32\config" config_old %stream%
CALL :work_conf %I_r% %O_r%%F_xy%
IF %I_err% == Y GOTO err_work_conf
GOTO NO_copyconf

:conf_new
:: rozskok podle "Nm/Bm"
GOTO conf_new_%I_mod%

:conf_new_Nm
CALL :att_exi Ff "%O_r%%F_xy%Windows\System32\config_1" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%Windows\System32\config_1" F
IF %NI_ER% == NI GOTO NO_conf_1
CALL :att_exi Ff "%O_r%%F_xy%Windows\System32\config_2" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%Windows\System32\config_2" F
IF %NI_ER% == NI GOTO NO_conf_2
CALL :att_exi Ff "%O_r%%F_xy%Windows\System32\config_3" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%Windows\System32\config_3" F
IF %NI_ER% == NI GOTO NO_conf_3
RD /S /Q "%O_r%%F_xy%Windows\System32\config_3" %stream%
GOTO NO_conf_3

:NO_conf_3
REN "%O_r%%F_xy%Windows\System32\config_2" config_3 %stream%
GOTO NO_conf_2

:NO_conf_2
REN "%O_r%%F_xy%Windows\System32\config_1" config_2 %stream%
GOTO NO_conf_1

:NO_conf_1
REN "%O_r%%F_xy%Windows\System32\config" config_1 %stream%
CALL :work_conf %I_r% %O_r%%F_xy%
IF %I_err% == Y GOTO err_work_conf
GOTO NO_copyconf

:conf_new_Bm
RD /S /Q %I_r%Windows\System32\config %stream%
CALL :att_exi Ff "%O_r%%F_xy%Windows\System32\config_3" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%Windows\System32\config_3" F
IF NOT %NI_ER% == NI GOTO YES_conf_3
CALL :att_exi Ff "%O_r%%F_xy%Windows\System32\config_2" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%Windows\System32\config_2" F
IF NOT %NI_ER% == NI GOTO YES_conf_2
CALL :att_exi Ff "%O_r%%F_xy%Windows\System32\config_1" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%Windows\System32\config_1" F
IF NOT %NI_ER% == NI GOTO YES_conf_1
SET "Indx="
GOTO Indx_all

:YES_conf_3
SET Indx=_3
GOTO Indx_all

:YES_conf_2
SET Indx=_2
GOTO Indx_all

:YES_conf_1
SET Indx=_1
GOTO Indx_all

:Indx_all
CALL :work_conf %O_r%%F_xy% %I_r%
IF %I_err% == Y GOTO err_work_conf
GOTO NO_copyconf

:conf_old
:: rozskok podle "Nm/Bm"
GOTO conf_old_%I_mod%

:conf_old_Nm
:: pokud uz neexistuje ani "config_1"
CALL :att_exi Ff "%O_r%%F_xy%Windows\System32\config_1" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%Windows\System32\config_1" F
IF NOT %NI_ER% == NI GOTO back_conf

:: oznameni neexistence zaloh "config", uz neexistuje ani slozka "config_1"
ECHO.
ECHO *** Error: there's not even the first backup folder
ECHO            "config_1" included the "Registry"
GOTO robo_conf

:back_conf
RD /S /Q %I_r%Windows\System32\config %stream%
RD /S /Q "%O_r%%F_xy%Windows\System32\config" %stream%
CALL :att_exi Ff "%O_r%%F_xy%Windows\System32\config_3" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%Windows\System32\config_3" F
IF %NI_ER% == NI GOTO NO_ex_con3
REN "%O_r%%F_xy%Windows\System32\config_1" config %stream%
REN "%O_r%%F_xy%Windows\System32\config_2" config_1 %stream%
REN "%O_r%%F_xy%Windows\System32\config_3" config_2 %stream%
GOTO robo_conf

:NO_ex_con3
CALL :att_exi Ff "%O_r%%F_xy%Windows\System32\config_2" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%Windows\System32\config_2" F
IF %NI_ER% == NI GOTO NO_ex_con2
REN "%O_r%%F_xy%Windows\System32\config_1" config %stream%
REN "%O_r%%F_xy%Windows\System32\config_2" config_1 %stream%
GOTO robo_conf

:NO_ex_con2
CALL :att_exi Ff "%O_r%%F_xy%Windows\System32\config_1" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%Windows\System32\config_1" F
IF %NI_ER% == NI GOTO NO_ex_con1
REN "%O_r%%F_xy%Windows\System32\config_1" config %stream%
GOTO robo_conf

:NO_ex_con1
GOTO robo_conf

:robo_conf
CALL :work_conf %O_r%%F_xy% %I_r%
IF %I_err% == Y GOTO err_work_conf
GOTO NO_copyconf

:conf_old_Bm
RD /S /Q %I_r%Windows\System32\config %stream%
RD /S /Q "%O_r%%F_xy%Windows\System32\config" %stream%
:: prejmenovani slozky "config_old" na "config", navraceni slozky "config"
:: do aktualniho umisteni v OS, zpetne prejmenovani slozky "config"
:: na "config_old" a zpetna diverzifikace slozky "config" z aktualniho
:: umisteni do uloziste a odstraneni vsech verzi "config_x" 
REN "%O_r%%F_xy%Windows\System32\config_old" config %stream%
CALL :work_conf %O_r%%F_xy% %I_r%
IF %I_err% == Y GOTO err_work_conf
REN "%O_r%%F_xy%Windows\System32\config" config_old %stream%
CALL :work_conf %I_r% %O_r%%F_xy%
IF %I_err% == Y GOTO err_work_conf
CALL :att_exi Ff "%O_r%%F_xy%Windows\System32\config_3" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%Windows\System32\config_3" F
IF NOT %NI_ER% == NI RD /S /Q "%O_r%%F_xy%Windows\System32\config_3" %stream%
CALL :att_exi Ff "%O_r%%F_xy%Windows\System32\config_2" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%Windows\System32\config_2" F
IF NOT %NI_ER% == NI RD /S /Q "%O_r%%F_xy%Windows\System32\config_2" %stream%
CALL :att_exi Ff "%O_r%%F_xy%Windows\System32\config_1" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%F_xy%Windows\System32\config_1" F
IF NOT %NI_ER% == NI RD /S /Q "%O_r%%F_xy%Windows\System32\config_1" %stream%
GOTO NO_copyconf

:NO_copyconf
IF %I_all% == all GOTO NO_txt
ECHO.
ECHO *** Slozka "config" - "%I_mod%" mode:
:: rozskok podle "all/new/old"
GOTO tx_%1

:tx_all
ECHO.
ECHO     - current folder "%I_r%Windows\System32\config"
ECHO       partition "%vol_I_r%" was diversified
ECHO     - this diversification was required (initial preparatory
ECHO       work), took place once time, has been placed in storage
ECHO       "%DJ%%F_xy%Windows\System32\" ("%vol_O_r%") and after 
ECHO       renaming the "config" to "config_old" diversification 
ECHO       was retried (Folder "config_old" is the backup 
ECHO       and will not be rewriting)
ECHO     - there are max 3 versions of the folder "config_1-3"
GOTO fin_config

:tx_new
:: rozskok podle "Nm/Bm"
GOTO tx_new_%I_mod%

:tx_new_Nm
ECHO.
ECHO     - folders "config_x" have been cascaded renamed as follows:
ECHO       If, for example, does not exist "config_2" folder was 
ECHO       "config_1" was renamed "config_2" and "config" to 
ECHO       "config_1" (if there was a folder "config_3" would 
ECHO       be removed first)
ECHO     - current folder "%I_r%Windows\System32\config"
ECHO       partition %vol_I_r% has been diversified
ECHO       into storage "%DJ%%F_xy%Windows\System32\" 
ECHO       (%vol_O_r%)
GOTO fin_config

:tx_new_Bm
ECHO.
ECHO     - "config" with the highest index was from the store
ECHO       "%DJ%%F_xy%Windows\System32\" "%vol_O_r%) 
ECHO       with the name "config" returned to the folder
ECHO       "%I_r%Windows\System32\" in the OS (%vol_I_r%)
ECHO     - diversification did not "touch" the existing version
GOTO fin_config

:tx_old
:: rozskok podle "Nm/Bm"
GOTO tx_old_%I_mod%

:tx_old_Nm
ECHO.
ECHO     - folders "config" were removed: 
ECHO        - from the storage "%DJ%%F_xy%Windows\System32\"
ECHO          (%vol_O_r%)
ECHO        - from folder "%I_r%Windows\System32\" in the OS (%vol_I_r%)
ECHO     - and the subsequent cascaded renamed as follows:
ECHO       If, for example, there was a maximum folder "config_2" 
ECHO       was folder "config_1" renamed to "config", "config_2" 
ECHO       to "config_1" and finally the folder
ECHO       "%O_r%%F_xy%Windows\System32\config_2" 
ECHO       (%vol_O_r%) was removed (if does not exist folder 
ECHO       "config_x" will only drawback)
ECHO     - from the storage "%DJ%%F_xy%Windows\System32\"
ECHO       was the folder "config" returned to the folder 
ECHO       "%I_r%Windows\System32\" in OS 
GOTO fin_config

:tx_old_Bm
ECHO.
ECHO     - Folders "config" were removed: 
ECHO        - from the storage "%DJ%%F_xy%Windows\System32\"
ECHO          (%vol_O_r%)
ECHO        - from folder "%I_r%Windows\System32\" in the OS (%vol_I_r%)
ECHO     - folder "config_old" has been renamed to "config"
ECHO       and returned to the folder 
ECHO       "%I_r%Windows\System32\" in OS 
ECHO     - folder "config" has been renamed "config_old"
ECHO     - folder "%I_r%Windows\System32\" v OS (%vol_I_r%)
ECHO       has been diversified into storage
ECHO       "%DJ%%F_xy%Windows\System32\" (%vol_O_r%)
ECHO     - all possible versions "config_1-3" were removed
GOTO fin_config

:fin_config
ECHO     - other operations with the folder was not done
GOTO NO_txt

:err_work_conf
:err_fin_con
:NO_txt
GOTO :eof

:: interni subroutine "work_conf"
:: ******************************
:: vykonna subroutine obsluhy slozky "config"
:: ******************************************
:: vstupni parametry: - oznaceni oddilu
::                      vstupu
::                    - oznaceni oddilu
::                      vystupu
:: vystupni parametry:
::
:work_conf
SET IO_i=%~1
SET IO_o=%~2
CALL :test_size %IO_o:~0,3% "%IO_i%Windows\System32\config" NenTC %DA_w% siz_OU siz_IN I_ts siz_ALL
IF %I_ts% == G GOTO next_test7
IF %I_ts% == Eo CALL :err_insu "%IO_o:~0,3%"
IF %I_ts% == Ei CALL :err_insu "%IO_i:~0,3%"
IF %I_ts% == ER CALL :err_tak_own Windows\System32\config F
GOTO next_test7

:next_test7
ROBOCOPY "%IO_i%Windows\System32\config" "%IO_o%Windows\System32\config" %I_rob% %stream% 
SET err_l=%ERRORLEVEL%
:: nasilne ukonceni po hrubych chybach pri praci s "config"?
IF %err_l% GEQ 10 CALL :err_robo
:: sesbirani "junction" slozky "config" a vytvoreni, pojmenovani a umisteni novych "junction"
CALL :collect_jun "%IO_o%Windows\System32\config" config %IO_o:~0,3% %X_m:~0,3% %I_err_taow%
IF %I_err_taow% == Y SET I_err=Y&GOTO fin_fl_OK
GOTO fin_fl_OK

:fin_fl_OK
GOTO :eof

:: interni subroutine "collect_jun"
:: ********************************
:: nalezeni, vytvoreni, umisteni a nasmerovani vsech "vnitrnich junction" objektu
:: ******************************************************************************
:: vstupni parametry: - cesta ke slozce nebo oznaceni oddilu (v "objektu" prikaz
::                      "dir" vyhleda "junction"), navic se z parametru vzdy
::                      extrahuje oznaceni oddilu ("pismeno:\" 
::                    - cast nazvu "log-souboru" (je-li = "_pismenko", bude pro
::                      "log-soubor" vytvoren zvlastni nazev)
::                    - oznaceni vystupniho oddilu pro uloziste v "boot"
::                      prostredi prikazoveho radku
::                    - oznaceni vystupniho oddilu pro uloziste po "boot"
::                      do prostredi OS
:: vystupni parametry: N/Y - prevzate/neprevzate vlastnictvi spolu
::                           s nastavenim/nenastavenim prav
:: pozn.: subroutine "collect_jun" spolu s internimi subroutinami "filter"
::        a "warslash" v "LE" verzi neexistuje (prikazy mezi ""LE" verze start"
::        a ""LE" verze konec ..." budou odstraneny a zustane pouze startovaci
::        navesti ":collect_jun" a prikaz "GOTO :eof")
::
:collect_jun
:: ***
:: *** "LE" verze start**********************************************************
:: ***

:: ***
:: *** "LE" verze konec *********************************************************
:: ***
GOTO :eof

:: interni subroutine "TO_law"
:: ***************************
:: prebirani vlastnictvi (i znacne nasilnym zpusobem) a prace s pravy "objektu"
:: ****************************************************************************
:: vstupni parametry: - nazev objektu
::                    - s/c/r - storage (+ "shozeni")/cleaning/recovery
::                    - rekurze "ICACLS" - "T/-"
::                    - rekurze "TAKEOWN" - "R/-" (pri parametru "R" bude
::                                          nastaven i parametr "D" a podle
::                                          "mutace" i potrebna odpoved "Y/A")                                          )
::                    - oznaceni "N/J/E" - "Normal/Junction/Error" objekt
::                                         v "log-souboru" prav 
:: vystupni parametr: N/Y - prevzate/neprevzate vlastnictvi
::                          s nastavenim/nenastavenim prav
:: pozn.: - parametry "/Q" a "/C" ("ICACLS") a "/A" ("TAKEOWN") jsou nastaveny
::          vzdy, stejne jako parametr "L" (ICACLS)
::        - pri chybe se nastavi globalni promenna "I_err_taow" na hodnotu "Y"
::          (jinak se = "N")    
::
:TO_law
:: odstraneni '"' a pokud je na posledni pozici cesty znak "\", bude odebran
SET p_w=%~1
SET lc=%p_w:~-1%
IF "%lc%" == "\" SET p_w=%p_w:~0,-1%
:: - byl-li pouzit parametr "r" ("recovery" v prikazu "/RESTORE"), provadi se uprava
::   cesty odstranenim posledni "casti" cesty (pokud cesta neni delsi nez 3 znaky,
::   kdy jde jen o oznaceni oddilu)
:: - vlastni zpracovani je "dvoustupnove" - pracuje se totiz se slozkou, ktera
::   "junction" obsahuje, i se samotnou slozkou "junction" a obema se vraci prava
::   situace: - cesta muze vypadat napr. takto "t:\a\b\....\x\y\j, kde "j" je slozka
::              obsahujici "junction"
::            - pak vraceni prav slozce "j" se provadi pomoci slozky "y" a vraceni
::              prav slozce "y" pomoci slozky "x"
:: - dvoustupnove zpracovovani je bezpodminecne nutne, protoze pri konstrukci
::   "junction" je potreba vzdy pouzit jeji nadrizenou slozku, vyzaduje to totiz
::   syntaxe prikazu "MKLINK" (posledni cast cesty je samotny nazev "junction" - jde
::   o nazev slozky a tento objekt slozkou je)
:: - velmi dulezite je nastavit indikaci "objekt = oddil", protoze zjistovani
::   existence je neprukazne - oddil ma atributy "d", "s" a "h" jaksi "automaticky"
::   (a navic existence oddilu je zde prukazne zjistovana jinou metodou) 
SET p_ww=%p_w%
SET I_only_p=N
:: test prace s oddilem a test, zda se skutecne jedna o nazev oddilu, tedy
:: zda obsahuje ":"
CALL :Math_C "%p_ww%" %str_4% I_com 0 0
IF NOT %I_com% == L GOTO part_NO1
SET two_colon=%1
IF NOT %two_colon::=% == %two_colon% SET I_only_p=Y
GOTO part_NO1

:part_NO1
SET I_all_part=*
:: pokud "objekt" neni oddilem, indikatory pro "TAKEOWN" se nenastavuji - je-li
:: operace = "r", dojde k oddeleni nazvu na konci cesty (zbytek cesty tak bude
:: ukazovat na nadrizenou slozku)
IF %I_only_p% == Y GOTO OK_part1
SET "I_all_part="
IF %2 == r (
    CALL :disjun_path_obj "%p_ww%" p_ww name_w
) ELSE (
    GOTO OK_part1
)
:: pokud "objekt" (po rozdeleni cesty) je "jen" oddil, cesta bude opravena
IF %I_only_p% == Y SET p_ww=%p_ww%
GOTO OK_part1

:OK_part1
:: nastaveni "T" a podminene nastaveni "D", "YA" a "R"
SET "w_T="
IF %3 == T SET w_T=/T
SET "w_D="
SET "w_YA="
SET "w_R="
IF NOT %4 == R GOTO NO_R
SET w_R=/R
:: v pripade slozky bude nastaven parametr "D" a automaticka odpoved
:: "Y/A" na dotaz, aby tento nebyl vypisovan
CALL :att_exi Fd "%p_ww%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%p_ww%" F
IF %str_att% == d SET w_D=/D&SET w_YA=%charYA%&GOTO OK_part2
:: je-li objekt oddilem, budou parametr "D" a automaticka odpoved
:: nastavene take
IF %I_only_p% == Y SET w_D=/D&SET w_YA=%charYA%&GOTO OK_part2
GOTO OK_part2

:OK_part2
:NO_R
:: nastaveni casti nazvu souboru pro "uklid" prav
SET laww=law%5
:: rozskok podle "s/c/r"
GOTO law_%2

:law_s
:: "uklid" prav s pripadnym prevzetim vlastnictvi a nastavenim prav
:: ****************************************************************
ICACLS "%p_w%" /SAVE "%laww%_%pismenko%.txt" /L %w_T% /Q /C %stream%
:: podle "mutace" bude vybrano cislo tokenu
IF %charYA% == Y (
  FOR /F "tokens=7 usebackq" %%E IN ("STD_%pismenko%.txt") DO (SET Er_obj=%%E)
) ELSE (
  FOR /F "tokens=11 usebackq" %%E IN ("STD_%pismenko%.txt") DO (SET Er_obj=%%E)
)
:: bude nasledovat specialni osetreni chyby po "SAVE"?
IF %Er_obj% == 0 GOTO fin_TO_law
GOTO attempt

:attempt
:: "l-objekty" se nezpracovavaji (parametr "/SKIPSL" existuje pouze v OS W10)
IF %str_att% == l GOTO NO_ta_ow
:: prevzeti vlastnictvi, "RESET", specialni osetreni chyby po "RESET"
:: a "nastaveni" pristupu
TAKEOWN /F "%p_w%" /A %w_R% %w_D% %w_YA% %stream%
ICACLS "%p_w%%I_all_part%" /RESET /L %w_T% /Q /C %stream%
:: podle "mutace" bude vybrano cislo tokenu
IF %charYA% == Y (
  FOR /F "tokens=7 usebackq" %%E IN ("STD_%pismenko%.txt") DO (SET Er_obj=%%E)
) ELSE (
  FOR /F "tokens=11 usebackq" %%E IN ("STD_%pismenko%.txt") DO (SET Er_obj=%%E)
)
:: pri hrubych chybach (nemoznost prevzeti prav) je prace ukoncena
IF NOT %Er_obj% == 0 GOTO NO_ta_ow
:: pokud se jedna o pripad "shozeni" prav, prikaz "/SAVE" se neprovadi
IF %2 == c GOTO OK_reset
ICACLS "%p_w%" /SAVE "%laww%_%pismenko%.txt" /L %w_T% /Q /C %stream%
:: podle "mutace" bude vybrano cislo tokenu
IF %charYA% == Y (
  FOR /F "tokens=7 usebackq" %%E IN ("STD_%pismenko%.txt") DO (SET Er_obj=%%E)
) ELSE (
  FOR /F "tokens=11 usebackq" %%E IN ("STD_%pismenko%.txt") DO (SET Er_obj=%%E)
)
:: specialni vyber chyby po "SAVE"
:: pri hrubych chybach (nemoznost prevzeti prav) je prace ukoncena
IF NOT %Er_obj% == 0 GOTO NO_ta_ow
GOTO OK_reset

:OK_reset
ICACLS "%p_w%%I_all_part%" /RESET /L %w_T% /Q /C %stream%
:: podle "mutace" bude vybrano cislo tokenu
IF %charYA% == Y (
  FOR /F "tokens=7 usebackq" %%E IN ("STD_%pismenko%.txt") DO (SET Er_obj=%%E)
) ELSE (
  FOR /F "tokens=11 usebackq" %%E IN ("STD_%pismenko%.txt") DO (SET Er_obj=%%E)
)
:: specialni vyber chyby po "RESET"
:: pri hrubych chybach (nemoznost prevzeti prav) je prace ukoncena
IF NOT %Er_obj% == 0 GOTO NO_ta_ow
GOTO OK_law

:OK_law
ICACLS "%p_w%" /GRANT EveryOne:F /L %w_T% /Q /C %stream%
GOTO fin_TO_law

:law_c
:: "shozeni" prav s pripadnou pomoci (prevzeti vlastnictvi a nastaveni prav)
:: *************************************************************************
ICACLS "%p_w%%I_all_part%" /RESET /L %w_T% /Q /C %stream%
:: podle "mutace" bude vybrano cislo tokenu
IF %charYA% == Y (
  FOR /F "tokens=7 usebackq" %%E IN ("STD_%pismenko%.txt") DO (SET Er_obj=%%E)
) ELSE (
  FOR /F "tokens=11 usebackq" %%E IN ("STD_%pismenko%.txt") DO (SET Er_obj=%%E)
)
:: specialni vyber chyby po "RESET"
IF NOT %Er_obj% == 0 GOTO attempt
GOTO OK_law

:law_r
:: obnova prav
:: ***********
:: - test, zda se pracuje s oddilem
:: - pokud cesta je/neni oznacenim oddilu, tak se "nebali/bali" do dvojice znaku
::   '"' a testuje se, zda skutecne se jedna o nazev oddilu (zda obsahuje ":")
CALL :Math_C "%p_ww%" %str_4% I_com 0 0
SET W_com=%p_ww%
IF NOT %I_com% == L GOTO wrap
SET two_colon=%1
IF NOT %two_colon::=% == %two_colon% GOTO part_NO2
GOTO wrap

:wrap
SET W_com="%p_ww%"
GOTO part_NO2

:part_NO2
:: log-soubor prav pro "/RESTORE" obsahuje cesty k podslozkam i souborum
ICACLS %W_com% /RESTORE "%laww%_%pismenko%.txt" /L /Q /C %stream%
GOTO fin_TO_law

:NO_ta_ow
:: nastaveni hrube chyby - nepodarilo se prevzit vlastnictvi a nastavit prava
SET %6=Y
GOTO fin_TO_law

:fin_TO_law
GOTO :eof

:: interni subroutine "disjun_path_obj"
:: ************************************
:: rozdeleni cesty na uvodni cast a nazev "objektu"
:: ************************************************
:: vstupni parametry: cesta
:: vystupni parametry: - cesta bez nazvu koncoveho
::                       "objektu"
::                     - nazev koncoveho "objektu"
::
:disjun_path_obj
:: odstraneni '"' a pokud je na posledni pozici cesty znak "\", bude odebran
SET na_fo=%~1
SET lc=%na_fo:~-1%
IF %lc%. == \. SET na_fo=%na_fo:~0,-1%
:: test, zda se pracuje s oddilem a test, zda skutecne se jedna o nazev oddilu,
:: tedy zda obsahuje ":"
CALL :Math_C "%na_fo%" %str_4% I_com 0 0
IF NOT %I_com% == L GOTO part_NO3
SET two_colon=%1
IF NOT %two_colon::=% == %two_colon% GOTO all_jufo
GOTO part_NO3

:part_NO3
SET na_w=%na_fo%
:: existuje alespon jeden znak "\" (dotaz pro "jistotu")?
IF "%na_fo:\=%" == "%na_fo%" GOTO all_jufo
:: cykl odebirani nazvu posledniho "objektu" vcetne "\"
SET "na_w="
GOTO next_slash_ap

:next_slash_ap
SET lc=%na_fo:~-1%
SET na_fo=%na_fo:~0,-1%
:: znak je roven "\"
IF NOT %lc%. == \. SET na_w=%lc%%na_w%&GOTO next_slash_ap
GOTO all_jufo

:fin_sl_ap
:: cesta bez posledni polozky a znaku "\"
SET na_fo=%na_fo%
GOTO all_jufo

:all_jufo
SET %2=%na_fo%
SET %3=%na_w%
GOTO :eof

:: subroutine "oped"
:: *****************
:: odstraneni obsahu slozky (a slozky samotne) nebo obsahu celeho oddilu
:: *********************************************************************
:: vstupni parametry:
:: vystupni parametry:
::
:oped
:: odstraneni obsahu oddilu?
IF %I_all% == all GOTO OK_alld
:: odstraneni slozky (jejiho obsahu i slozky samotne)
:: **************************************************
SET I_err=N
IF /I NOT %lett_SP% == %O_r% GOTO OK_div_syfo
IF /I "%Nam_fol:Diver_SysFol=%" == "%Nam_fol%" GOTO OK_div_syfo
:: prace s domovskou slozkou neni povolena
ECHO.
ECHO *** Error: working with folder "Diver_SysFol" (the output partition) is not allowed
SET I_err=Y
GOTO fin_oped

:OK_div_syfo
ECHO.
ECHO *** Folder "%Nam_fol%" - "special" mode:
ECHO     allow removal of the folder "%O_r%%Nam_fol%"
IF NOT %I_ope% == r GOTO NO_cop_fol1
ECHO     and its subsequent diversification to the %vol_O_r%
GOTO NO_cop_fol1

:NO_cop_fol1
CALL :any
CALL :rdf "%O_r%%Nam_fol%" rdf
IF %I_ope% == r GOTO YES_cop_fol
ECHO.
ECHO *** Folder "%Nam_fol%" - "special" mode:
ECHO     output folder "%O_r%%Nam_fol%" has been removed
IF %I_ope% == d GOTO NO_cop_fol2
ECHO     and the input "%I_r%%Nam_fol%" will be diversified
GOTO NO_cop_fol2

:NO_cop_fol2
:YES_cop_fol
GOTO fin_oped

:OK_alld
:: odstraneni obsahu oddilu
:: ************************
IF NOT %I_ope% == r GOTO NO_cop_part
CALL :Sm_que %vol_O_r% (%O_r%) obnoveni %vol_I_r% (%I_r%)
GOTO cop_folpar

:NO_cop_part
CALL :Sm_que %vol_O_r% (%O_r%) odstraneni "" ""
GOTO cop_folpar

:cop_folpar
CALL :rdf "%O_r%" rdp
:: - test na pozadavek diverzifikace
:: - subroutine "oped" podminene a nestandardne pokracuje do subroutine
::   "opec" (navrat pres ":eof" bude i tak v poradku)
IF NOT %I_ope% == r GOTO fin_opec_w
GOTO fin_oped

:fin_oped
GOTO :eof

:: interni subroutine "rdf"
:: ************************
:: odstraneni "junction" nebo obsahu slozky (a slozky samotne) nebo celeho oddilu
:: ******************************************************************************
:: vstupni parametry: - cesta s nazvem slozky/oznaceni oddilu
::                    - identifikace flag_souboru ("rdp/rdf")
:: vystupni parametry:
::
:rdf
SET I_err_taow=N
SET "ex_w="
:: odstraneni '"' a test na typ slozky - pokud je to slozka "repairs point",
:: bude ihned odstranena
SET w_rdf=%~1
SET err_l=0
CALL :att_exi Fl "%w_rdf%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%w_rdf%" F
IF NOT %str_att% == l GOTO NO_fol_del
:: - po prvnim pokusu o odstraneni slozky "junction", nasleduje test, zda
::   se podarilo slozku odstranit
:: - nasledovan je prevzetim vlastnictvi a navysenim prav a dalsim pokusem
::   o odstraneni slozky "junction"
:: - pak nasleduje zaverecny test, zda se slozku podarilo skutecne odstranit 
RD "%w_rdf%" %stream%
CALL :att_exi Ff "%w_rdf%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%w_rdf%" F
IF %NI_ER% == NI GOTO NO_jex
CALL :TO_law "%w_rdf%" c - - J I_err_taow
IF %I_err_taow% == Y CALL :err_tak_own "%w_rdf%" F
RD "%w_rdf%" %stream%
CALL :att_exi Ff "%w_rdf%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%w_rdf%" F
IF %NI_ER% == NI CALL :err_tak_own "%w_rdf%" F
GOTO fin_rdf

:NO_fol_del
:: spusteni "wait" smycky
CALL :flag_file_WD W %2 %I_mut% %charYA% %wait_YN%
:: odstraneni slozky/oddilu - nepodari-li se to, prevzit vlastnictvi,
:: nastavit prava a opakovat operaci
CALL :del_fol_par "%w_rdf%" ex_w
IF %ex_w% == N GOTO fin_rdf
CALL :TO_law "%w_rdf%" c T R N %I_err_taow%
IF %I_err_taow% == Y CALL :err_tak_own "%w_rdf%" F
CALL :del_fol_par "%w_rdf%" ex_w
IF %ex_w% == Y CALL :err_tak_own "%w_rdf%" F
:: ukonceni "wait" smycky
CALL :flag_file_WD D %2 %I_mut% %charYA% %wait_YN%
GOTO fin_rdf

:fin_rdf
GOTO :eof

:: interni subroutine "del_fol_par"
:: ********************************
:: odstranovani objektu (vzdy je specialne proverovano, zda operace mela uspech)
:: *****************************************************************************
:: vstupni parametry: nazev "objektu"
:: vystupni parametry: Y/N - "objekt" po "odstraneni" existuje/neexistuje
::
:del_fol_par
:: odstraneni '"'
SET __rdf=%~1
:: test, zda se pracuje s oddilem a test, zda se skutecne jedna o nazev
:: oddilu, tedy zda obsahuje ":"
CALL :Math_C "%__rdf%" %str_4% I_com 0 0
IF NOT %I_com% == L GOTO ex_part_YES
SET two_colon=%1
IF NOT %two_colon::=% == %two_colon% GOTO part_NO4
GOTO ex_part_YES

:ex_part_YES
:: "objekt" existuje ?
CALL :att_exi Ff "%__rdf%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%__rdf%" F
IF %NI_ER% == NI GOTO next_test9
GOTO part_NO4

:part_NO4
:: o strategii zjisteni, zda "objekt" byl odstranen, rozhoduji velikosti dvou
:: souboru s parametrem "all" a metoda zachytavani chyb pomoci "virtualniho
:: prikazu CALL":
:: - zvlastni prikaz - konstrukce (CALL ) s prikazy "RD/DEL" - predem
::   nastavi "ERRORLEVEL" na 0, cim bude systemova promenna "ERRORLEVEL"
::   ucinna (bude existovat a pripravena prenaset eventualni chyby)
:: - na prikazy "RD/DEL", pokud skonci bez chyby, se "naretezi" nastaveni
::   promenne "ErRD" rovne "0"
:: - skonci-li prikaz chybou, naretezi se (v pripade "RD") dalsi operace,
::   ktera hodnotou z "ERRORLEVEL" nastavi promennou "ErRD" na nekterou
::   ze znamejsich chyb - viz seznam (je nutne zapnout "delayed
::   expansion")
::   - prikaz "RD": - 0   - OK
::                  - 2   - system nemuze nalezt uvedeny "objekt"
::                  - 3   - system nemuze nalezt uvedenou cestu
::                  - 5   - pristup zakazan
::                  - 32  - pristup k "objektu" nelze ziskat (je vyuzivan
::                          jinym procesem)
::   - prikaz "DEL": - 0 - ale nektere soubory nebyly odstranene (cekal
::                         se kod "1")!
::                   - 0 - "slaba" prava nebo napr. "objekt" je "read-only"
::                         (cekal se kod >= "1")!
::                   - 0 - neexistujici svazek nebo neni pripraven (napr.
::                         neni vlozeno medium CD - dal by se cekat jeste
::                         vyssi kod)!
::                   - 1 - neplatna cesta (take zde by se dal cekat jeste
::                         vyssi kod)!
:: pozn.: pokud je v prikazu "DEL" zadan seznam souboru takovy, ze alespon
::        jeden z nich bude pricinou stejne chyby, jako jsou posledni vyse
::        uvedene, nebude odstranen zadny soubor ze seznamu
::
:: zalozeni pomocnych prazdnych souboru
TYPE NUL > "DEL_%pismenko%.txt"
TYPE NUL > "RD_%pismenko%.txt"
:: odstranovani objektu - u souboru se bere do uvahy pouze velikost souboru "DEL ..."
(CALL )&DEL /F /Q /A: "%__rdf%" %stream_1% 2>"DEL_%pismenko%.txt"
CALL :test_size "%CD%\DEL_%pismenko%.txt" NUL NenOB %DA_w% siz_OU siz_IN I_ts siz_ALL
IF NOT %siz_OU% == 0 GOTO Next_err
IF %I_ts% == OK GOTO next_test8
IF %I_ts% == Eo CALL :err_tak_own "%CD%\DEL_%pismenko%.txt" E
GOTO next_test8

:next_test8
:: u slozky jsou chyby ukladane do promenne "ErRD" a do uvahy se bere i velikost
:: souboru "RD ..."
(CALL )&RD /S /Q "%__rdf%" %stream_1% 2>"RD_%pismenko%.txt"&&SET Er_RD=0||SET Er_RD=!ERRORLEVEL!
IF %Er_RD% == 5 GOTO err_ACC
IF %Er_RD% == 32 GOTO err_ACC
CALL :test_size "%CD%\RD_%pismenko%.txt" NUL NenOB %DA_w% siz_OU siz_IN I_ts siz_ALL
IF NOT %siz_OU% == 0 GOTO Next_err
IF %I_ts% == OK GOTO next_test9
IF %I_ts% == Eo CALL :err_tak_own "%CD%\RD_%pismenko%.txt" E
GOTO next_test9

:next_test9
SET %2=N
GOTO all_fin_del

:err_ACC
:Next_err
:EX_err
SET %2=Y
GOTO all_fin_del

:all_fin_del
GOTO :eof

:: subroutine "opec"
:: *****************
:: diverzifikace "junction", obsahu slozky nebo obsahu celeho oddilu
:: *****************************************************************
:: vstupni parametry:
:: vystupni parametry:
::
:opec
:: diverzifikace oddilu?
IF %I_all% == all GOTO OK_allc
:: diverzifikace normalni slozky/slozky typu "junction" a test, zda vstupni
:: slozka je typu "l-repairs point"
SET err_l=0
CALL :att_exi Fl "%I_r%%Nam_fol%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%Nam_fol%" F
IF NOT %str_att% == l GOTO YES_div_fol
:: diverzifikace slozky "junction"
:: ******************************* 
:: objekt "junction" - uklid prav
SET I_pz=N
CALL :TO_law "%I_r%%Nam_fol%" s - - J %I_err_taow%
:: rozdeleni cesty na jeji uvodni cast (s oznacenim oddilu) a nazev "junction"
:: z jejiho konce, test, zda se pracuje s oddilem a test, zda skutecne se
:: jedna o nazev oddilu, tedy zda obsahuje ":"
SET "path_loc="
CALL :disjun_path_obj "%I_r%%Nam_fol%" path_loc name_w
CALL :Math_C "%path_loc%" %str_4% I_com 0 0
IF NOT %I_com% == L GOTO part_NO5
SET two_colon=%path_loc%
IF NOT %two_colon::=% == %two_colon% GOTO part_NO5
SET I_pz=Y
GOTO part_NO5

:part_NO5
:: nadrizena slozka - uklid prav
CALL :TO_law "%path_loc%" s - - N %I_err_taow%
GOTO NO_law1

:NO_law1
SET "w_targ="
FOR /F "tokens=1-2 delims=[] skip=2" %%j IN ('DIR "%path_loc%" /A:L /S 2^>NUL') DO (
  CALL :recon_jun_one "%%j" "%%k" "%name_w%" w_targ
)
:: - je-li cesta pouhym oznacenim oddilu, bude nahrazena prazdnou cestou
:: - v opacnem pripade ji bude odebrano oznaceni oddilu a pokud vystupni nadrizena
::   slozka pro "junction" neexistuje, bude zalozena a slozka "junction" vytvorena
IF %I_pz% == Y (
  SET "path_loc="
) ELSE (
  SET path_loc=%path_loc:~3%
)
CALL :att_exi Ff "%O_r%%path_loc%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%O_r%%path_loc%" F
IF %NI_ER% == NI MKDIR "%O_r%%path_loc%" %stream%
:: pridani znaku "\" k neprazdne ceste
IF NOT "%path_loc%" == "" SET path_loc=%path_loc%\
MKLINK "%O_r%%path_loc%%name_w%" "%w_targ%" /J %stream%
IF %ERRORLEVEL% == 0 GOTO OK_targSm
CALL :warerr_targ "%O_r%%path_loc%%name_w%" "%w_targ%" s
GOTO fin_opec

:OK_targSm
IF %I_pz% == N GOTO NO_law2
:: obnova prav vstupu
CALL :TO_law "%I_r%%path_loc%" r - - N %I_err_taow%
GOTO NO_law2

:NO_law2
:: obnova prav vstupu - objekt "junction" a obnova prav vystupu
CALL :TO_law "%I_r%%path_loc%%name_w%" r - - J %I_err_taow%
IF %I_pz% == N GOTO NO_law3
CALL :TO_law "%O_r%%path_loc%" r - - N %I_err_taow%
GOTO NO_law3

:NO_law3
:: obnova prav vystupu - objekt "junction" a atributu (s osetrenim pripadnych chyb)
CALL :TO_law "%O_r%%path_loc%%name_w%" r - - J %I_err_taow%
CALL :att_exi CA "%I_r%%Nam_fol%" "%O_r%%Nam_fol%" NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%Nam_fol%" F
IF %NI_ER% == NI CALL :err_attrib "%I_r%%Nam_fol%"
GOTO report_Sm

:: diverzifikace bezne slozky
:: **************************
:YES_div_fol
SET I_Elog=N
CALL :robo_f S "%Nam_fol%"
IF %err_l% LSS 5 GOTO OK_lawf
:: pokus o opravu havarovanych slozek:
:: - uklid prav vstupu - po prevzeti vlastnictvi a nastaveni prav k havarovane slozce
::   bude diverzifikace opakovana
:: - postupny vyber havarovanych slozek z log-souboru "ELog" a pokus o jejich opravu
SET I_Elog=Y 
CALL :TO_law "%I_r%%Nam_fol%" s T R N %I_err_taow%
SET "path_sf="
SET "path_s="
SET "err_path="
FOR /F "tokens=7* usebackq" %%P IN ("ELog_%pismenko%.txt") DO (
  CALL :recon_ERR_fol "%%Q" path_sf path_s err_path
)
IF %I_err_taow% == Y CALL :err_tak_own "%I_r%%err_path%" F&GOTO fin_opec
GOTO OK_lawf

:OK_lawf
:: "sesbirani" "junction" diverzifikovane slozky a vytvoreni, pojmenovani a umisteni
:: novych, nahrady znaku "\" a " " znakem "_" a obnova prav na vstupu
SET Nam_folw=%Nam_fol:\=_%
CALL :collect_jun "%I_r%%Nam_fol%" "%Nam_folw: =_%" %O_r:~0,3% %X_m:~0,3% %I_err_taow%
IF %I_Elog% == N GOTO NO_N_law
CALL :TO_law "%I_r%%Nam_fol%" r - - N %I_err_taow%

:NO_N_law
GOTO report_Sm

:report_Sm
ECHO.
ECHO *** Folder "%Nam_fol%" - "special" mode:
ECHO     - folder "%I_r%%Nam_fol%" was diversified and saved 
ECHO       as a "%O_r%%Nam_fol%" to partition %vol_O_r%
ECHO     - other operations with the input folder was not made
GOTO fin_opec

:: diverzifikace obsahu oddilu
:: ***************************
:OK_allc
IF %I_ope% == r GOTO YES_cop_part
CALL :Sm_que %vol_I_r% (%I_r%) diversification %vol_O_r% (%O_r%)
GOTO YES_cop_part

:YES_cop_part
CALL :robo_p S
IF %err_l% LSS 5 GOTO OK_lawp
:: - sekvence pracuje pouze tehdy, pokud se vyskytla jen jista minimalni trida chyb,
::   nebranici pokracovani
:: - uklid prav vstupu, diverzifikace "zbytku" (po eventualnim prevzeti vlastnictvi
::   a nastaveni prav) a obnova prav na vstupu
CALL :TO_law "%I_r%" s T R N %I_err_taow%
CALL :robo_p E
CALL :TO_law "%I_r%" r - - N %I_err_taow%
IF NOT %err_l% GEQ 10  GOTO OK_lawp
CALL :err_tak_own "%p_w%" E
GOTO fin_opec_w

:OK_lawp
:: - "sesbirani" "junction" diverzifikovanych slozek a vytvoreni, pojmenovani
::   a umisteni novych
:: - "specialni" druhy parametr zajisti pro "log-soubor" zvlastni nazev
CALL :collect_jun "%I_r:~0,3%" "_%pismenko%" %O_r:~0,3% %X_m:~0,3% %I_err_taow%
GOTO fin_opec_w

:fin_opec_w
ECHO.
ECHO *** "Special" mode "%I_mod%": 
IF %I_ope% == d GOTO SM_yesd
IF %I_ope% == c GOTO SM_yesc
GOTO SM_yesd

:Sm_yesd
ECHO     - complete partition content "%vol_O_r%" has been removed
:: probehla i diverzifikace?
IF NOT %I_ope% == r GOTO fin_cd
GOTO SM_yesc

:Sm_yesc
ECHO     - partition %vol_I_r% has been diversified to
ECHO       the partition %vol_O_r%, which was "defragmented"
ECHO       by this operation and in folder "Diver_SysFol"
ECHO       was saved "log-file" all the "junction" partitions
GOTO fin_cd

:fin_cd
GOTO fin_opec

:fin_opec
GOTO :eof

:: interni subroutine "recon_jun_one"
:: *********************************
:: sestaveni "vnitrni junction" pri diverzifikaci slozky v rezimu "Sm"
:: *******************************************************************
:: vstupni parametry: - retezec s nazvem oddilu/"junction"/dalsimi
::                      "nezajimavymi" informacemi
::                    - "target" pro "junction"
::                    - nazev  pro "junction" 
:: vystupni parametry: "target" pro novou "junction"
::
:recon_jun_one
:: zpracovani se lisi v zavislosti "en" ("cz") verze "cmd.exe"
SET line_one=%1
:: - odstraneni znaku "<>" (pusobi presmerovani)
:: - odebraji se vzdy na zacatku zpracovani)
:: - pak odstraneni '"', zpracovani nazvu slozky lokace a "target junction"
SET line_one=%line_one:>=%
SET line_one=%line_one:<=%
SET line_one=%line_one:"=%
IF /I NOT "%line_one:Directory of=%" == "%line_one%" GOTO NO_jex_one
IF /I NOT "%line_one:pis adres=%" == "%line_one%" GOTO NO_jex_one
IF /I NOT "%line_one:JUNCTION=%" == "%line_one%" GOTO YES_tar_all
IF /I NOT "%line_one:SYMLINKD=%" == "%line_one%" GOTO YES_tar_all
IF /I NOT "%line_one:SYMLINK=%" == "%line_one%" GOTO YES_tar_all
GOTO NO_jex_one

:YES_tar_all
:: nazev 
:: *****
SET j_nam_one=%line_one:~34,-1%
:: - oprava nazvu, nutna pro ruzne verze "cmd.exe"
:: - odebrani tri moznych uvodnich znaku " ", vznikajicich vyberem z dat
::   "dir" prikazu, pouziteho pri ruznych verzich "cmd"
IF /I "%j_nam_one:~0,3%" == "   " SET j_nam_one=%j_nam_one:~3%
:: target
:: ******
SET j_tar_one=%2
:: kolem promenne "j_tar_one" uz znaky '"' jsou
IF NOT %j_tar_one% == ".." GOTO full_targ_one
GOTO NO_jex_one

:full_targ_one
:: odstraneni '"' a test, zda jde o hledanou "junction"? 
SET j_tar_one=%j_tar_one:"=%
IF /I "%j_nam_one%" == %3 SET %4=%j_tar_one%
GOTO :NO_jex_one

:NO_jex_one
GOTO :eof

:: interni subroutine "recon_ERR_fol"
:: **********************************
:: prace s havarovanou slozkou - uklid prav, prevzeti vlastnictvi a po diverzifikaci
:: obnova prav
:: *********************************************************************************
:: vstupni parametry: - cesta ke slozce
::                    - po rozdeleni cesty se testuje: uvodni cast cesty 
::                    -             "-"              : nazev objektu na konci cesty   
:: vystupni parametry: cesta k havarijni slozce
::
:recon_ERR_fol
:: odstraneni '"', oznaceni oddilu a podminene odebrani posledniho znaku
:: cesty, pokud je to "/"
SET path_err=%~1
:: odstraneni oznaceni oddilu
SET path_err=%path_err:~3%
SET path_errw=%path_err%
SET lc=%path_err:~-1%
IF NOT %lc%. == \. GOTO NO_slash_er
SET path_errw=%path_err:~0,-1%
GOTO NO_slash_er

:NO_slash_er
:: vylouceni systemovych souboru, rozdeleni cesty na uvodni cast a nazev "objektu"
:: na jejim konci a podminene vylouceni zapisu "objektu" do "ELog..." ("objekty"
:: vznikaji po opakovani operace v "robocopy")
IF /I NOT "%path_errw:hiberfil=%" == "%path_errw%" GOTO fin_er_op
IF /I NOT "%path_errw:swapfile=%" == "%path_errw%" GOTO fin_er_op
IF /I NOT "%path_errw:pagefile=%" == "%path_errw%" GOTO fin_er_op
IF /I NOT "%path_errw:RECYCLE=%" == "%path_errw%" GOTO fin_er_op
IF /I NOT "%path_errw:System Volume Information=%" == "%path_errw%" GOTO fin_er_op
CALL :disjun_path_obj "%path_errw%" path_errw name_w
IF "%path_err%" == "%2" GOTO fin_er_op
IF "%path_errw%" == "%3" GOTO fin_er_op
:: - "uklid", prevzeti vlastnictvi a nastaveni prav (log-soubor prav ma v nazvu "E",
::   havarijni log) a opakovani diverzifikace havarijni slozky
:: - pokud se podarilo prevzeti vlastnictvi a nastaveni prav, obnova prav na vstupu
::   a nastaveni prav na vystupu
CALL :TO_law "%I_r%%path_errw%" s T R E %I_err_taow%
IF %I_err_taow% == Y GOTO fin_er_op
CALL :robo_f E "%path_errw%"
CALL :TO_law "%I_r%%path_errw%" r - - E %I_err_taow%
CALL :TO_law "%O_r%%path_errw%" r - - E %I_err_taow%
SET path_sf=%path_err%
SET path_s=%path_errw%
SET %4=%path_errw%
GOTO fin_er_op

:fin_er_op
GOTO :eof

:: interni subroutine "robo_f"
:: ***************************
:: diverzifikace slozky (poprve "bezna", podruhe "chybova" po nastaveni prav)
:: ************************************************************************** 
:: vstupni parametry: - S/E - bezna/chybova diverzifikace (parametr je uzity
::                            i v nazvu "log-souboru")
::                    - cesta ke vstupni slozce
:: vystupni parametry:
::
:robo_f
:: spusteni "wait" smycky
CALL :flag_file_WD W rof %I_mut% %charYA% %wait_YN%
:: odstraneni '"', pridani "nazvu oddilu_", "n/e" a ".txt" a nahrada znaku
:: " " a "\" znakem "_"
SET path_i=%~2
SET path_o=%path_i%
SET Nam_folw=%path_o:"=%
SET Nam_folw=%Nam_folw:\=_%
SET Nam_folw=%Nam_folw: =_%
SET vol_w=%vol_I_r:"=%
SET vol_w=%vol_w: =_%
SET Nam_folww=%vol_w%_%Nam_folw%_%1.txt
ROBOCOPY "%I_r%%path_i%" "%O_r%%path_o%" %I_rob% /LOG:Log_%Nam_folww% %stream%
SET err_l=%ERRORLEVEL%
IF %err_l% LSS 5 GOTO NO_findf
:: pokud je provadeno chybove zpracovani, soubor chyb "ELog..." uz nebude
:: vytvaren, jinak trideni cest havarovanych diverzifikovanych slozek
:: do "ELog..." souboru
IF %1 == E GOTO NO_findf
FINDSTR /C:" ERROR " Log_%Nam_folww% 1>>"ELog_%pismenko%.txt" %stream_2%
GOTO NO_findf

:NO_findf
:: ukonceni "wait" smycky
CALL :flag_file_WD D rof %I_mut% %charYA% %wait_YN%
GOTO :eof

:: interni subroutine "robo_p"
:: ***************************
:: diverzifikace oddilu (prvni "bezna", druha "chybova" po nastaveni prav)
:: *********************************************************************** 
:: vstupni parametry: S/E - bezna/chybova diverzifikace (parametr je uzity
::                          i v nazvu "log-souboru") 
:: vystupni parametry:
::
:robo_p
:: spusteni "wait" smycky
CALL :flag_file_WD W rop %I_mut% %charYA% %wait_YN%
:: odstraneni '"', pridani "nazvu oddilu_", "n/e" a ".txt" a nahrada znaku
:: " " znakem "_"
SET vol_w=%vol_I_r:"=%
SET vol_w=%vol_w: =_%
SET Nam_folww=%vol_w%_%I_all:"=%_%1.txt
ROBOCOPY %I_r% %O_r% /XF %hib% %pag% %swa% /XD "System Volume Information" %BinE% %BinR% %BinS% %I_rob% /LOG:Log_%Nam_folww% %stream%
SET err_l=%ERRORLEVEL%
IF %err_l% LSS 5 GOTO NO_findp
:: pokud je provadeno chybove zpracovani, soubor chyb "ELog..." uz nebude
:: vytvaren, jinak trideni cest havarovanych diverzifikovanych slozek do
:: "ELog..." souboru
IF %1 == E GOTO NO_findp
FINDSTR /C:" ERROR " Log_%Nam_folww% 1>>"ELog_%pismenko%.txt" %stream_2%
GOTO NO_findp

:NO_findp
:: ukonceni "wait" smycky
CALL :flag_file_WD D rop %I_mut% %charYA% %wait_YN%
GOTO :eof

:: subroutine "rendel_UP"
:: **********************
:: zpracovani dvojice "junction" slozek "Users/ProgramData"
:: ********************************************************
:: vstupni parametry:
:: vystupni parametry: 
:: pozn.: promenna "I_err_taow" bude nastavena/nenastavena 
::        na hodnotu"N/Y": bezchybne/chybne zpracovani
::        "junction"
::
:rendel_UP
:: nastaveni viditelnosti prejmenovane slozky "ProgramData"
CALL :att_exi SRh "%I_r%%PD%_%pismenko%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_r%%PD%_%pismenko%" F
:: - stav: slozky "Users/ProgramData" jsou zpracovane (existuji jejich
::         "junction" a puvodni slozky jsou prejmenovane pomoci pridani
::         "_pismenko")
:: - slozky "Users/ProgramData" ("junction") budou prejmenovane na
::   "Users/ProgramData__pismenko", slozky "Users/ProgramData_pismenko"
::   na "Users/ProgramData" a nasledne budou zpracovane vsechny vnitrni
::   "junction" obou slozek
:: - pak budou slozky "Users/ProgramData" prejmenovane zpet na puvodni 
::   "Users/ProgramData_pismenko" a slozky "Users/ProgramData__pismenko"
::   na puvodni "Users/ProgramData" ("junction")
:: - na zaver budou puvodni slozky odstranene, pokud byl pouzit parametr
::   "r" (vztahuje se na obe slozky)
REN %I_r%%Us% "%Us%__%pismenko%" %stream%
REN %I_r%%PD% "%PD%__%pismenko%" %stream%
REN "%I_r%%Us%_%pismenko%" %Us% %stream%
REN "%I_r%%PD%_%pismenko%" %PD% %stream%
IF %I_err_taow% == Y SET %2=Y&GOTO fin_rendel
:: "sesbirani" a vytvoreni "junction" pro slozky "ProgramData/Users"
CALL :collect_jun %I_r%%Us% %Us% %O_r:~0,3% %X_m:~0,3% %I_err_taow%
CALL :collect_jun %I_r%%PD% %PD% %O_r:~0,3% %X_m:~0,3% %I_err_taow%
IF %I_err_taow% == Y SET %2=Y&GOTO fin_rendel
REN %I_r%%Us% "%Us%_%pismenko%" %stream% %stream%
REN %I_r%%PD% "%PD%_%pismenko%" %stream%
REN "%I_r%%Us%__%pismenko%" %Us% %stream%
REN "%I_r%%PD%__%pismenko%" %PD% %stream%
IF %I_ope% == c GOTO fin_rendel
RD /S /Q "%I_r%%Us%_%pismenko%" %stream%
RD /S /Q "%I_r%%PD%_%pismenko%" %stream%
GOTO fin_rendel

:fin_rendel
:: zpetne nastaveni neviditelnosti prejmenovane slozky "ProgramData"
CALL :att_exi SSh "%I_r%%PD%_%pismenko%" out_NUL NI_ER str_att
IF %NI_ER% == ER CALL :err_tak_own "%I_r%ProgramData_%pismenko%" F
GOTO :eof

:: ***************************************************************************
:: subroutine, po kterych je prace ukoncena, protoze vznikly velmi hrube chyby
:: ***************************************************************************
::
:: interni subroutine "err_robo"
:: *****************************
:: vystup "hrubych" chyb po pouziti prikazu "robocopy"
:: ***************************************************
:: vstupni parametry: cislo chyby "ERRORLEVEL"
:: vystupni parametry:
:: pozn.: prikaz "GOTO :eof" u techto soubroutine je pouze formalitou
::
:err_robo
ECHO.
ECHO *** Error: - some directories (files) can not copy, occurred copying 
ECHO              error ("%err_l%") and was exhausted retry limit
ECHO            - you can be a severe fault operations "robocopy" (eg. bad
ECHO              path, created in mode "Sm" by the user, insufficient 
ECHO              space, permission etc.).
CALL :tot_ex
GOTO :eof

:: subroutine "err_repairs"
:: ************************
:: vystup chyby "slozka neni typu "repairs ..."
:: ********************************************
:: vstupni parametry: nazev slozky
:: vystupni parametry:
::
:err_repairs
ECHO.
ECHO *** Error: folder "%I_r%%Ws32W%%Nam_fol%" (%vol_I_r%) 
ECHO            is not the "repairs point" - a severe mistake,
CALL :tot_ex
GOTO :eof

:: interni subroutine "err_insu"
:: *****************************
:: vystup chyby "nedostatecny prostor na vystupnim oddilu"
:: *******************************************************
:: vstupni parametry: oznaceni oddilu (obvykle vystupniho)
:: vystupni parametry:
::
:err_insu
SET out_vol=%1
SET out_vol=%out_vol:"=%
SET out_vol=%out_vol:~0,3%
ECHO.
ECHO *** Error: insufficient space on the partition "%out_vol%",
CALL :tot_ex
GOTO :eof

:: interni subroutine "err_tak_own"
:: ********************************
:: vystup chyby "neprevzeti vlastnictvi a nenastaveni prav"
:: ********************************************************
:: vstupni parametry: - nazev "objektu"
::                    - indikace "E/F" - vypis chyby nebo
::                      vypis chyby a nasilne ukonceni 
:: vystupni parametry:
:: pozn.: jedina subroutine z teto skupiny, ktera nemusi
::        ukoncit praci SW 
::
:err_tak_own
ECHO.
ECHO *** Chyba: - nepodarilo se prevzit vlastnictvi "objektu" 
ECHO              %1
:: rozskok podle "E/F"
GOTO tot_%2

:tot_E
:: navrat
ECHO.
GOTO :eof

:tot_F
:: ukonceni prace
CALL :tot_ex
GOTO :eof

:: interni subroutine "tot_ex"
:: ***************************
:: nasilne ukonceni - nasilne ukonceni prace SW
:: ********************************************
:: vstupni parametry:
:: vystupni parametry:
::
:tot_ex
ECHO            - "Diver_SysFol.bat" konci praci^^!
::datum a cas, dialog cekani a nasilne ukonceni
CALL :DA_TI u
ECHO.
ECHO %pause_ww%*** press ... ^| stiskni ... *** "Y|y" ^| "A|a"
PAUSE>NUL
EXIT
GOTO :eof

:: *****************************************************
:: subroutine vykonavaji hlaseni beznych chyb zpracovani
:: *****************************************************
:: subroutine "warerr_fol_out"
:: ***************************
:: vystup upozorneni/chyby (zjisteni existence/neexistence slozek)
:: ***************************************************************
:: vstupni parametry: - nazev slozky
::                    - typ slozky (normalni/bezna/"junction")
::                    - existuje/nenalezena
:: vystupni parametry:
::
:warerr_fol_out
SET par_out=%3
SET par_out=%par_out:"=%
ECHO.
ECHO *** Warning/error: - the output folder (%2)
ECHO                      %1
ECHO                      %par_out%
IF %2 == "common" GOTO YES_comm
IF NOT %2 == "normal" GOTO NO_norm
ECHO                      - it is about a "normal" folder, "Diver_SysFol.bat"
ECHO                        therefore used a diversified folder from the storage
ECHO                        "%O_r%%F_xy%" and all its "junction" restored so that
ECHO                        if this folder has not been damaged, it is virtually
ECHO                        certain that the OS will work properly
GOTO YES_comm

:YES_comm
:NO_norm
GOTO :eof

:: subroutine "err_ren_del"
:: ************************
:: vystup chyby jiz uskutecneho zpracovani
:: ***************************************
:: vstupni parametry: nazev slozky
:: vystupni parametry:
::
:err_ren_del
ECHO.
ECHO *** Error: processing has been already done, see the folder
ECHO            %1
GOTO :eof

:: interni subroutine "errwar_fol_in"
:: **********************************
:: vystup chyby/upozorneni existence slozky
:: ****************************************
:: vstupni parametry: nazev slozky
:: vystupni parametry:
::
:errwar_fol_in
ECHO.
ECHO *** Error/warning: input folder 
ECHO                     %1
ECHO                     was not found
GOTO :eof

:: interni subroutine "err_attrib"
:: *******************************
:: vystup chyby (problematika zjisteni atributu)
:: *********************************************
:: vstupni parametry: nazev "objektu"
:: vystupni parametry:
::
:err_attrib
ECHO.
ECHO *** Warning/error: problem with atributes - %1
GOTO :eof

:: interni subroutine "err_NOex_partx"
:: ***********************************
:: hlaseni chyb typu "neexistence" oddilu ("uzka" spoluprace s nasledujici) 
:: ************************************************************************
:: vstupni parametry: typ oddilu
:: vystupni parametry:
::
:err_NOex_part1
ECHO.
ECHO *** Error: input partition "%I_r%" to "robocopy" does not exist
ECHO            or insufficient space on the partition 
GOTO fin_err_part

:err_NOex_part2
ECHO.
ECHO *** Error: output partition "%O_r%" to "robocopy" does not exist
ECHO            or insufficient space on the partition
GOTO fin_err_part

:err_NOex_part3
ECHO.
ECHO *** Error: output partition "%X_m%" to "mklink" does not exist
ECHO            or insufficient space on the partition:
ECHO            - problem is labeled accurately, partition this letter "%X_m%" 
ECHO             in this environment really does not exist. But undoubtedly, 
ECHO             it rather mislabeled partition exists physically
ECHO            - it is not a paradox
ECHO            - a letter of probably comes from a working OS environments,
ECHO              which commonly indicates the partition, who kept the user
ECHO              has selected for the folder "Data_jun\" (and to which
ECHO              the folders will be diversified) and since letters is
ECHO              undoubtedly one of the letters from the rear of the alphabet,
ECHO              there appears the fact, that the characters in this environment
ECHO              was not found and the SW would thus not correctly work
ECHO            - the solution is simple - in the operating environment OS 
ECHO              change a letter in this partition so, subsequently to have 
ECHO              existed in this installation environment (and rarely 
ECHO              solvable problem)
GOTO fin_err_part

:: interni subroutine "err_NTFSx"
:: ******************************
:: vypis chyb typu "NTFS" (neexistence FS NTFS)
:: ********************************************
:: vstupni parametry: typ oddilu
:: vystupni parametry:
::
:err_NTFS1
ECHO.
ECHO *** Error: input partition "%I_r%" too "robocopy"
GOTO NTFS_err

:err_NTFS2
ECHO.
ECHO *** Error: output partition "%O_r%" to "robocopy"
GOTO NTFS_err

:err_NTFS3
ECHO.
ECHO *** Error: output partition "%X_m%" to "mklink"
GOTO NTFS_err

:NTFS_err
ECHO            although it is equal to one partition from the list 
ECHO            "%pismenko%"
ECHO            and exists on PC disks, but is not allowed, because 
ECHO            FS is unequal "NTFS"
GOTO fin_err_part

:fin_err_part
SET I_err=Y
GOTO :eof

:: interni subroutine "warerr_targ"
:: ********************************
:: vystup upozorneni/chyby - "target" "junction"
:: *********************************************
:: vstupni parametry: - nazev "junction"
::                    - lokace
::                    - indikace casti textu
:: vystupni parametry:
::
:warerr_targ
ECHO.
IF %3 == n SET word_we=located in
IF %3 == s SET word_we=with target
ECHO *** Warning/error: "junction" %1 %word_we% in 
ECHO                    %2 
ECHO                    can not becreated, "target" does
ECHO                    not exist or "junction" exist already
GOTO :eof

:: subroutine "err_env"
:: ********************
:: konflikt nastaveneho rezimu a typu prostredi 
:: ********************************************
:: vstupni parametry: typ oddilu
:: vystupni parametry:
::
:err_env
ECHO.
ECHO *** Error: mode "%I_mod%" in the OS environment is not allowed
GOTO :eof

:: interni subroutine "err_n_ch"
:: *****************************
:: vystup chyb pro subroutine "pure"
:: *********************************
:: vstupni parametry:
:: vystupni parametry:
::
:err_n_ch
ECHO.
ECHO *** Error: number of characters in the parameter is greater than "255",
ECHO            which is not allowed
GOTO :eof

:: interni subroutine "err_ch"
:: ***************************
:: vystup chyb pro subroutine "pure"
:: *********************************
:: vstupni parametry:
:: vystupni parametry:
::
:err_ch
ECHO.
ECHO *** Error: character "%lc%" in the parameter number "%1" is not allowed
GOTO :eof

:: *************************************************
:: hlaseni chyb, po kterych nasleduje ukonceni prace
:: *************************************************
::
:err_space
ECHO.
ECHO *** Error: "a space" or "\" in the first position of the parameter 
ECHO            "Nam_fol" is not allowed
GOTO des

:err_sum_par
ECHO.
ECHO *** Error: the number of parameters is zero or unequal to "6-9",
ECHO            what is not allowed
GOTO des

:err_all_parNY
ECHO.
ECHO *** Error: input parameter "%Ind_p%" does unequal to "Y|N"
ECHO            and is not permitted
GOTO des

:err_all_par
ECHO.
ECHO *** Error: input parameter "%Ind_p%" does unequal to "all"
ECHO            and is not permitted
GOTO des

:err_i_Ir
ECHO.
ECHO *** Error: marking the input partition "%p1%:\" for "robocopy"
GOTO Ir_Or_Om

:err_o_Or
ECHO.
ECHO *** Error: marking the output partition "%p2%:\" for "robocopy"
GOTO Ir_Or_Om

:err_o_Om
ECHO.
ECHO *** Error: marking the output partition "%p3%:\" for "mklink"
GOTO Ir_Or_Om

:Ir_Or_Om
ECHO            is unequal to the marking none of partition from  
ECHO            "%pismenko%":\,
ECHO            and therefore is not allowed
GOTO des

:err_mode
ECHO.
ECHO *** Error: mode "%p4%" unequal to any of the mode "Nm|Sm|Bm" 
ECHO            should not be permitted
GOTO des
 
:err_nam_fol
SET W_nam_fol="%W_nam_fol:"=%"
ECHO.
ECHO *** Error: folder name %W_nam_fol% in mode "%p4%" is not allowed
GOTO des

:err_ope_crd
ECHO.
ECHO *** Error: operation "%p6%" in mode "%I_mod%" is not allowed
GOTO des

:err_DJ
ECHO.
ECHO *** Error: folder "%O_r%%DJ%" could not be based or was not found
GOTO des

:err_env
ECHO.
ECHO *** Error: mode "%I_mod%" in the OS environment is not allowed
GOTO des

:des
IF NOT %Ind_p% == 0 GOTO finn
:: specialni "pause" v pripade vypisu dokumentace
IF %Ind_p% == 0 ECHO.&ECHO %pause_ww%&PAUSE>NUL&GOTO YES_note
ECHO %pause_w%
PAUSE>NUL
GOTO YES_note

:: ************************
:: popis "Diver_SysFol.bat"
:: ************************

:YES_note
CLS
ECHO ***
ECHO      Main operation definitions of "Diver_SysFol.bat":
ECHO.
ECHO  SW in a "boot" environment installing means (beginning W7 OS) 
ECHO  or in ABD,
ECHO.
ECHO       REPLACE
ECHO.
ECHO  using the command "robocopy" diversified folder of the system 
ECHO  partition "I_r" to output partition "O_r", different from the input
ECHO  folder (important FS = "NTFS"), which may contain data too:
ECHO       - hidden, system, or having both properties
ECHO       - owned by any owner, including systems,
ECHO       - tied the supreme law, including system,
ECHO.
ECHO       CONNECTION - "JUNCTION"
ECHO.
ECHO  original and its new location in the repository "Data_jun\F_?" by help 
ECHO  further order "mklink". Performance of each incorrect operation will be 
ECHO  1x repeteted without delay and failure stops its processing.
ECHO %pause_ww%
PAUSE>NUL
CLS
ECHO ***
ECHO       Parameter description:
ECHO.
ECHO  I_r: input partition letter (which usually contains the OS), found in
ECHO       a "boot" command prompt line environment or in the ABD
ECHO  O_r: drive letter for the diversified folders storage of the OS in 
ECHO       the same environment as the parameter "I_r"
ECHO  X_m: the same repository letter, VALID in a usual working OS environment
ECHO       (generally unequal to "O_r"^^! - very important parameter)
ECHO  I_mod: "Nm|Sm|Bm": "normal", "special" and "back" mode
ECHO  Nam_fol: - the name "normal" folder
ECHO           - path with the name of a folder (ie. the "full" path that 
ECHO             must be in quotes if it contains at least one space)
ECHO  Ope_fol: c - "Nm|Sm|Bm": input system folder diversification (in "Nm" 
ECHO                           mode with its renaming)
ECHO           r - "Nm": input system folder diversification and its
ECHO                    removal 
ECHO           d - "Sm": removal the output folder
ECHO           r - "Sm": "d: Sm" (removal...) + "c: Sm" (diversification...)
ECHO  all: "Nm|Bm": automatic processing of all "normal" folders
ECHO       "Sm": c - diversification of the contents of the input partition
ECHO             d - removal of entire content output partition
ECHO             r - "d" (removal...) + "c" (diversification...)
ECHO %pause_ww%
PAUSE>NUL
CLS
ECHO ***
ECHO    Notes to parameters:
ECHO.
ECHO  - order of the parameters is necessary to maintain
ECHO  - drive letters: "c|d|e|f|g|h|i|j|k|l|m|n|o|p|q|r|s|t|u|v|w|x|y|z"
ECHO  - direction of the processing: "Nm|Sm": c - "I_r => O_r"
ECHO                                          d - working with "O_r" ("I_r" is 
ECHO                                              not taken into account, by
ECHO                                              analogy with the "r" operation)
ECHO                                 "Bm": c - "I_r <= O_r"^^!
ECHO  - characters in the parameters:
ECHO    - common: lowercase/uppercase letters, numbers, "_ "
ECHO    - special: eg. ",:()", '"' and "space", which are from the par. 1-4, 6/7
ECHO               withdrawing; from Nam_fol (par. 5) are removing redundant
ECHO               '"', the first character must be not " " or "\" and with the
ECHO               character '"' is wrapped, if it contains at least one " " 
ECHO  - if there is an empty parameter after cleaning, it is replaced by "?"
ECHO  - total string characters have to be "<256" and "exotic" characters might 
ECHO    cause a syntax error
ECHO  - existence of folder the "config" is tested at diversification and if not
ECHO    it is created including backup (see scenarios in mode "Nm|Bm" where 
ECHO    found, Nam_fol = "config", "config_new" or "config_old")
ECHO %pause_ww%
PAUSE>NUL
CLS 
ECHO ***
ECHO  - list of "normal" folders (the name must be exactly specified):
ECHO    Users, "Program Files", "Program Files (x86)", SoftwareDistribution,
ECHO    ProgramData, WDI, winevt, "Documents and Settigs", Logs, Temp, Prefetch, 
ECHO    oobe, sru, wbem,  ServiceProfiles and special config (possibly even 
ECHO    "config_new" and "config_old")
ECHO  - "full" path (eg. in the form: "Fol_1\Fol_2\Fol x\Fol_n ...")
ECHO  - "Nm": c - after diversification "normal" folder will remain and will be 
ECHO              renamed by adding the following text: 
ECHO              "_t h e q u i c k f o x l z y g s p j n m w r v d"
ECHO          r - do the same and "normal" folders will be removed
ECHO  - "Sm": c - diversification any folder
ECHO          d - removal any folder
ECHO          r - "d" (removal...) + "c" (diversification...)
ECHO  - "Bm": c - "normal" folders will be rediversified
ECHO  - folders diversifies into storage "Data_Jun\F_?" (?=Partition_name), so 
ECHO    in the "Data_Jun\" can e.g. appear the folders "F_W7" or "F_My_OS" with 
ECHO    the folders e.g. Users, "Program Files"
ECHO  - in the mode "Sm" diversifies by "full" path in Nam_fol
ECHO  - "robocopy" makes log-files "Log_?[_jun][_N|B|S|E].txt" (to folder with 
ECHO    "Diver_SysFol.bat"),  where "?"="[name_partition]_name_folder|_all", 
ECHO    (when added "_jun", it is always about a file containing a "junction",
ECHO    "_N|B|S|E" - "Normal|Back|Special|Error")
ECHO %pause_ww%
PAUSE>NUL
CLS
ECHO *** 
ECHO  - special importance is the parameter "all", that triggers the "automatic" 
ECHO    mode (when you enter the content Nam_fol not taken into account):
ECHO    "Nm": c - diversification of all the "normal" folders (direction 
ECHO             "I_r => O_r") and in its original location the folders 
ECHO             remains unnamed
ECHO          r - do the same and folders are removed
ECHO    "Sm": c - diversification of all the partition (direction "I_r => O_r")
ECHO          d - removal of entire content output partition "O_r"^^!
ECHO          r - "d" (removal...) + "c" (diversification...)
ECHO    "Bm": return of diversified folders from storage "Data_Jun\F_?" on 
ECHO          the appropriate position in the OS and setting all "junction" 
ECHO          (direction "I_r <= O_r"^^! and the input partitions "O_r" will 
ECHO           be unchanged)
ECHO  - if "all" in "Nm|Sm|Bm" modes is not used, one folder will be perform:
ECHO      "Nm|Bm": the name "normal" folder is parameter Nam_fol (folder 
ECHO               "ProgramData" always causes folder processing "Users" 
ECHO               and vice versa, if they have not already)
ECHO      "Sm": in the Nam_fol is the name of a "full" path (to be able to 
ECHO            handle any partition folder)
ECHO %pause_ww%
PAUSE>NUL
CLS
ECHO ***
ECHO    Resuming in information to the mode "Sm":
ECHO  - existence OS, "Data_jun\" or parameter "X_m" are not checked
ECHO  - mode of operation "d" (not to mention the operation "r") is 
ECHO    dangerous and with "all" parameter is literally "demolition" tools
ECHO    (it is used by a time "endless" system folders removing) 
ECHO  - operation "c" on the output (preferably previously empty) partition
ECHO    "O_r" makes diversify defragmentation (as a side effect)
ECHO  - processes only internal "junction" diversified folders
ECHO. 
ECHO    General information to the SW operation:
ECHO  - some operations requires the user agreement (eg. in automatic 
ECHO    mode - parameter "all")
ECHO  - e.g. In the conclusion mode "Bm" the user can enable return of 
ECHO    initial folder "config" with the "Registry" if in normal mode was 
ECHO    used "c" operation with "all" (what have created favorable conditions
ECHO    for return "Registry") - if enabled comeback, return to the original 
ECHO    state of the OS will be made and in every case OS is "waiting" 
ECHO    for confirmation this "back-clone" OS
ECHO %pause_ww%
PAUSE>NUL
CLS
ECHO ***
ECHO    End notes:
ECHO  - the letters "O_r" (FOR "robocopy") from the "boot" or ABD deployment
ECHO    environment and "X_m" (for "mklink") from the ORDINARY OS work 
ECHO    environment, namely indicates the SAME partition, but generally they
ECHO    are in both environments different^^! Identify as the first "X_m"
ECHO  - internal parameter "/XJ" operation "robocopy" (absolutely necessary)
ECHO    ensures, that will not be copied no existing folders, which is 
ECHO    "junction" in the OS pointing (the object itself can not be copied 
ECHO    by any way - is excluded). "Junction" are therefore creating by 
ECHO    the author the original algorithm and only in the "final" release
ECHO  - diversification can be successfully performed only in command-line 
ECHO    installation or ABD environment (run the software under OS can be
ECHO    done at any time)
ECHO  - SW can also be used to diversify the folders of the OS WXP. This OS
ECHO    command "robocopy" or "mklink" do not know, but their effects, adjusted
ECHO    sometimes elsewhere, worked without problems
ECHO  - the diversification of the "Users/ProgramData" folder always automatic
ECHO    invokes the diversification of the "ProgramData/Users" folder
ECHO  - in OS working environments W7 (10, etc.) behave folder names sometimes
ECHO    "interesting". But they are renamed correctly - you can ensure in 
ECHO    the environment command prompt (mysteriously easygoing property)
ECHO %pause_ww%
PAUSE>NUL
CLS
ECHO ***
ECHO     The procedure for letters identifying:
ECHO.
ECHO  1. "boot" into the operating environment of the OS. The partition
ECHO     letter, where user want to place the repository ("Data_Jun\F_?"),
ECHO     will be parameter "X_m" (it is the only parameter that MUST 
ECHO     BE NOW KNOWN before starting work in environment command line 
ECHO     the installation or in ABD)
ECHO  2. after pressing the "Shift + F10" "boot" into one of these 
ECHO     environments, using the command "dir" and "cd" finding 
ECHO     "Diver_SysFol.bat" its run without arguments and findings of 
ECHO     letters input "I_r" and output "O_r" partition, along with their 
ECHO     names
ECHO  3. INCORRECT INPUT parameter can in OS with a diversified folders 
ECHO     DESTROY his the "Registry" and of whole partitions^^!
ECHO %pause_ww%
PAUSE>NUL
CLS
ECHO ***
ECHO    Examples launching:
ECHO  - Diver_SysFol.bat (or e.g. diver_sysfol)  - information about SW, list
ECHO                                               letters and partitions
ECHO  - Diver_SysFol i j k Sm "ab d\asa s" d     - will be removed folder 
ECHO                                               "asa s" from folder "ab d"
ECHO                                               partition "j"
ECHO  - diver_SYsfol s t q Bm "Program Files" c  - return of diversified 
ECHO                                               folder "Program Files"
ECHO                                               to partition "s"
ECHO  - diver_Sysfol.bat m h g Nm "s d" r all    - diversification folders
ECHO                                               from OS partition "m" to
ECHO                                               the partition "h" - list  
ECHO                                               folders see manual 
ECHO                                               (original folders will
ECHO                                               be deleted; with parameter
ECHO                                               "c" will be renamed)
ECHO  - diver_sysfol i j j Sm fol_lof r all      - removal content partition
ECHO                                               "j" and diversification 
ECHO                                               content partition "i" to
ECHO                                               the partition "j" (with
ECHO                                               all existing "junction")
ECHO %pause_ww%
PAUSE>NUL
CLS
GOTO finn

:finn
CALL :DA_TI u
EXIT /B